#
# snf_blas.m4
#
# SYNOPSIS
#
#   ACX_SNF_BLAS()
#
# DESCRIPTION
#
#   ACX_SNF_BLAS calls another macro to look for BLAS libraries. At the end,
#   it prints the library found and provides an automake condition.
#
#
AC_DEFUN([ACX_SNF_BLAS], [
AC_PREREQ(2.61)
AC_REQUIRE([ACX_BLAS_WITH_FC_FUNC])

AM_CONDITIONAL([COND_BLAS_FOUND], [test x"$acx_blas_ok" = xyes])

AS_IF([test x"$acx_blas_ok" = xyes],
	[AC_MSG_NOTICE([Found BLAS as: $BLAS_LIBS])],
	[AC_MSG_NOTICE([Found no working BLAS, will build my own version])]
)

])dnl ACX_SNF_BLAS
