#
# snf_debug.m4
#
# SYNOPSIS
#
#   ACX_SNF_DEBUG()
#
# DESCRIPTION
#
#   ACX_SNF_DEBUG determines whether debugging code 
#   should be activated.
#
#
AC_DEFUN([ACX_SNF_DEBUG], [
AC_PREREQ(2.61)

AC_MSG_CHECKING([whether to activate debugging code])

AC_ARG_ENABLE(
	[debug],
	[AS_HELP_STRING([--enable-debug], [enable debugging code])],
	[],
	[enable_debug=no]
)

AS_IF([test "x$enable_debug" != xno], 
	[
		AC_MSG_RESULT([yes])
		AC_DEFINE([DEBUG], 1, [Define to 1 to include debugging code])
	],
	[AC_MSG_RESULT([no])]
)

])dnl ACX_SNF_DEBUG
