#
# snf_lapack.m4
#
# SYNOPSIS
#
#   ACX_SNF_LAPACK()
#
# DESCRIPTION
#
#   SNF_LAPACK calls another macro to look for LAPACK libraries. At the end,
#   it prints the library found and provides an automake condition.
#
#
AC_DEFUN([ACX_SNF_LAPACK], [
AC_PREREQ(2.61)
AC_REQUIRE([ACX_LAPACK])

AM_CONDITIONAL([COND_LAPACK_FOUND], [test x"$acx_lapack_ok" = xyes])

AS_IF([test x"$acx_lapack_ok" = xyes],
	[AC_MSG_NOTICE([Found LAPACK as: $LAPACK_LIBS])],
	[AC_MSG_NOTICE([Found no working LAPACK, will build my own version])]
)

])dnl ACX_SNF_LAPACK
