#
# snf_scp.m4
#
# SYNOPSIS
#
#   ACX_SNF_SCP()
#
# DESCRIPTION
#
#   ACX_SNF_SCP determines whether scp should be used for
#   file transfers.
#
#
AC_DEFUN([ACX_SNF_SCP], [
AC_PREREQ(2.61)

AC_MSG_CHECKING([whether to use scp for file transfers])

AC_ARG_WITH(
	[scp],
	[AS_HELP_STRING([--with-scp], [
		Use scp for file transfers. Only use this if scp/ssh works without
		password if called from a program. This usually requires public key
		authentication with an empty passphrase.
	])],
	[],
	[with_scp=no]
)

AS_IF([test "x$with_scp" != xno], 
	[
		AC_MSG_RESULT([yes])
		AC_DEFINE([SNF_SCP], 1, [Define to 1 to use scp for file transfers])
	],
	[AC_MSG_RESULT([no])]
)

])dnl ACX_SNF_SCP
