      subroutine wakiractrl(acontrol,naus,nvar,nnbm,mxit,iti,rthres,
     *  apphess,rabsthres,dvthres,ecthres,roothmpr,g98bs,g98it,
     *  xmolout,tmout,printall,precond,genstart,rchthres,minnbt,
     *  iorth,snfout,natoms,mode,cstep,iclean,icleanl,idbg,ipol,
     *  lastqmatom,irescp,restadf,sleeptime)
*
* write AKIRA input information to file akira_control
*
* written by J. Neugebauer, Uni Erlangen, 2002
c modified by C. Herrmann, Uni Jena, 2005
*
      implicit none
      real*8 xx,cstep,getreal
      integer natoms,idbg,ipol,irescp
      integer iclean,icleanl,lastqmatom
      character*255 restadf

      integer i,lactrl,lu,nvar,j,naus,nbm,mxit,iti
      integer nnbm(mxit),minnbt,iorth,mode,sleeptime
      character*(*) acontrol
      logical ex,prnmod,g98it,g98bs,apphess,printall
      logical xmolout,genstart,tmout,snfout
      real*8 rthres,rabsthres,dvthres,ecthres,rchthres
      character*7 precond, roothmpr
      integer mxrow,nrow
      parameter(mxrow=4000000)
      character*132 buf,cbuf(mxrow)
      integer lcbuf(mxrow)
      lu=1

      prnmod=.false.
      call llen(acontrol,lactrl)
      inquire(file=acontrol(1:lactrl), exist=ex)
      open(unit=lu,file=acontrol(1:lactrl))
      nrow=0
      if(ex) then
100    read(lu,'(A)',err=999,end=999) buf
101    continue
       if(index(buf,'$prnmod').ne.0) then
         prnmod=.true.
       else if(index(buf,'$tmpdirclean').ne.0) then
         goto 100
       else if(index(buf,'$logdirclean').ne.0) then
         goto 100
       else if(index(buf,'$restartit').ne.0) then
         goto 100
       else if(index(buf,'$anfmode').ne.0) then
         goto 100
       else if(index(buf,'$rundimensions').ne.0) then
         goto 100
       else if(index(buf,'natoms=').ne.0) then
         goto 100
       else if(index(buf,'cstep').ne.0) then
         goto 100
       else if(index(buf,'numderiv').ne.0) then
         goto 100
       else if(index(buf,'lastqmatom').ne.0) then
         goto 100
       else if(index(buf,'irescp').ne.0) then
         goto 100
       else if(index(buf,'$restadf').ne.0) then
         goto 100
       else if(index(buf,'$genstart').ne.0) then
         goto 100
       else if(index(buf,'$rthres').ne.0) then
         goto 100
       else if(index(buf,'$iortho').ne.0) then
         goto 100
       else if(index(buf,'$sleeptime').ne.0) then
         goto 100
       else if(index(buf,'$rabsthres').ne.0) then
         goto 100
       else if(index(buf,'$dvthres').ne.0) then
         goto 100
       else if(index(buf,'$rchthres').ne.0) then
         goto 100
       else if(index(buf,'$ecthres').ne.0) then
         goto 100
       else if(index(buf,'$printall').ne.0) then
         goto 100
       else if(index(buf,'$roothmpr').ne.0) then
         goto 100
       else if(index(buf,'$precond').ne.0) then
         goto 100
       else if(index(buf,'$minnbt').ne.0) then
         goto 100
       else if(index(buf,'$g98it').ne.0) then
         goto 100
       else if(index(buf,'$tmout').ne.0) then
         goto 100
       else if(index(buf,'$xmolout').ne.0) then
         goto 100
       else if(index(buf,'$snfout').ne.0) then
         goto 100
       else if(index(buf,'$g98bs').ne.0) then
         goto 100
       else if(index(buf,'$nnbm').ne.0) then
200      read(lu,'(A)',err=999,end=999) buf
         if(index(buf,'$').ne.0) goto 101
         goto 200
       else if((.not.apphess).and.(index(buf,'$appr_hessian').ne.0)) 
     *  then
300      read(lu,'(A)',err=999,end=999) buf
         if(index(buf,'$').ne.0) goto 101
         goto 300
       else if(index(buf,'$end').ne.0) then
         goto 800
       else
         nrow=nrow+1
         if(nrow.gt.mxrow) call errex('** wakiractrl: buffer too small')
         cbuf(nrow)(1:132)=buf(1:132)
         call llen(cbuf(nrow),lcbuf(nrow))
         goto 100
       end if
      end if
800   rewind(lu)
      do i=1,nrow
        write(lu,'(A)') cbuf(i)(1:lcbuf(i))
      end do
      if(iclean.eq.1) write(lu,'(a12,i6)')'$tmpdirclean'
      if(icleanl.eq.1) write(lu,'(a12,i6)')'$logdirclean'
      write(lu,'(a8,2x,i5)') '$anfmode', mode
      write(lu,'(a8,2x,i5)') '$irescp ',irescp
      if(irescp.gt.0) then
        write(lu,'(a11,2x,a)') '$restadf = ',restadf
      end if
      write(lu,'(a12,2x,i5)') '$lastqmatom ',lastqmatom
      write(lu,'(a)') '$rundimensions '
      write(lu,'(a11,2x,i5)')  '  natoms= ',natoms
      write(lu,'(a7,2x,f14.8)') '$cstep ',cstep
      if(prnmod) write(lu,'(A)') '$prnmod'
      if(genstart) then
        write(lu,'(A)') '$genstart on'
      else
        write(lu,'(A)') '$genstart off'
      end if
      if(xmolout) then
        write(lu,'(A)') '$xmolout on'
      else
        write(lu,'(A)') '$xmolout off'
      end if
      if(tmout) then
        write(lu,'(A)') '$tmout on'
      else
        write(lu,'(A)') '$tmout off'
      end if
      if(snfout) then
        write(lu,'(A)') '$snfout on'
      else
        write(lu,'(A)') '$snfout off'
      end if
      if(g98it) then
        write(lu,'(A)') '$g98it on'
      else
        write(lu,'(A)') '$g98it off'
      end if
      if(g98bs) then
        write(lu,'(A)') '$g98bs on'
      else
        write(lu,'(A)') '$g98bs off'
      end if
      if(printall) then
        write(lu,'(A)') '$printall on'
      else
        write(lu,'(A)') '$printall off'
      end if
      write(lu,'(A,A7)') '$precond ',precond(1:7)
      write(lu,'(A,A7)') '$roothmpr ',roothmpr(1:7)
      if(precond.eq.'backtra') write(lu,'(A,i7)') '$minnbt ',minnbt
      write(lu,'(A,f20.10)') '$rthres   ',rthres
      write(lu,'(A,i20)') '$iortho ',iorth
      write(lu,'(A,i20)') '$sleeptime',sleeptime
      if(.not.(rchthres.lt.0.0d0)) write(lu,'(A,f20.10)') 
     *  '$rchthres ',rchthres
      if(rabsthres.gt.0.0d0) write(lu,'(A,f20.10)') 
     *  '$rabsthres ',rabsthres
      if(dvthres.gt.0.0d0) write(lu,'(A,f20.10)') 
     *  '$dvthres   ',dvthres
      if(ecthres.gt.0.0d0) write(lu,'(A,f20.10)') 
     *  '$ecthres   ',ecthres
      write(lu,'(A,i5)') '$nnbm',iti
      do i=1,iti
        write(lu,'(i4)') nnbm(i)
      end do
      write(lu,'(A)') '$end'
      goto 900
999   call errex2('** wakiractrl: error while reading '
     *            //acontrol(1:lactrl))
900   close(lu)
      end

***********************************************************************

      subroutine rakiractrl(acontrol,rthres,rabsthres,dvthres,ecthres,
     *  roothmpr,g98it,g98bs,xmolout,tmout,printall,precond,genstart,
     *  rchthres,minnbt,iorth,snfout,natoms,mode,cstep,naus,iclean,
     *  icleanl,idbg,ipol,lastqmatom,irescp,restadf,sleeptime)
*
* read AKIRA input information from file akira_control
*
* written by J. Neugebauer, Uni Erlangen, 2002
c modified by C. Herrmann, Uni Jena, 2005
*
      implicit none
      real*8 xx,cstep,getreal
      dimension xx(2)
      integer natoms,idbg,ipol,irescp,n,naus
      integer iclean,icleanl,lastqmatom,mode
      character*20 a20
      character*255 restadf
      integer i,lactrl,lu,j,idum,mxitem,minnbt,iorth,ii,sleeptime
      parameter(mxitem=12)
      character*(*) acontrol
      character*132 item(mxitem)
      character*255 buf
      character*7 precond,roothmpr
      real*8 temp,theta,rthres,rabsthres,dvthres,ecthres,rchthres
      logical ex,g98it,g98bs,xmolout,tmout,printall,genstart,snfout

      ipol=0
      if (mode.eq.0) mode=4
      cstep=0.01000      
      iclean=0
      icleanl=0

      lu=1
      call llen(acontrol,lactrl)
      inquire(file=acontrol(1:lactrl), exist=ex)
      if(.not.ex) return
      open(unit=lu,file=acontrol(1:lactrl))
10    read(lu,'(A)',end=900) buf
11    if(index(buf,'$tmpdirclean').ne.0) iclean=1
      if(index(buf,'$logdirclean').ne.0) icleanl=1
      if(index(buf,'$anfmode').ne.0) then
        ii=index(buf,'$anfmode')
        read(buf(ii+9:),*) mode
      end if
      if(index(buf,'natoms=').ne.0) then
       a20=buf
       call readl(20,a20,xx,n)
       natoms=int(xx(1))
      endif
      if(index(buf,'cstep').ne.0) then
       a20=buf
       call readl(20,a20,xx,n)
       cstep=xx(1)
CJN:NEU
       read(buf(7:),*) cstep
      endif
      if(index(buf,'numderiv').ne.0) then
       a20=buf
       call readl(20,a20,xx,n)
       naus=xx(1)
       naus=naus*2
      endif
      if(index(buf,'lastqmatom').ne.0) then
       a20=buf
       call readl(20,a20,xx,n)
       lastqmatom=xx(1)
      end if
      if(index(buf,'irescp').ne.0) then
       a20=buf
       call readl(20,a20,xx,n)
       irescp=xx(1)
      end if
      if(index(buf,'$restadf').ne.0) then
       read(buf(14:255),'(A)') restadf
      end if
      if(index(buf,'$rthres').ne.0) then
        read(buf(8:),*) rthres
      else if(buf(1:9).eq.'$roothmpr') then
        call split(buf,item,mxitem)
        read(item(2),*,end=10,err=10) roothmpr
      else if(buf(1:8).eq.'$precond') then
        call split(buf,item,mxitem)
        read(item(2),*,end=10,err=10) precond
      else if(index(buf,'$printall').ne.0) then
        if(index(buf(10:),'on').ne.0) then
          printall=.true.
        else 
          printall=.false.
        end if
      else if(index(buf,'$genstart').ne.0) then
        if(index(buf(10:),'on').ne.0) then
          genstart=.true.
        else 
          genstart=.false.
        end if
      else if(index(buf,'$xmolout').ne.0) then
        if(index(buf(9:),'on').ne.0) then
          xmolout=.true.
        else 
          xmolout=.false.
        end if
      else if(index(buf,'$tmout').ne.0) then
        if(index(buf(7:),'on').ne.0) then
          tmout=.true.
        else 
          tmout=.false.
        end if
      else if(index(buf,'$snfout').ne.0) then
        if(index(buf(8:),'on').ne.0) then
          snfout=.true.
        else 
          snfout=.false.
        end if
      else if(index(buf,'$g98it').ne.0) then
        if(index(buf(7:),'on').ne.0) then
          g98it=.true.
        else 
          g98it=.false.
        end if
      else if(index(buf,'$g98bs').ne.0) then
        if(index(buf(7:),'on').ne.0) then
          g98bs=.true.
        else 
          g98bs=.false.
        end if
      else if(index(buf,'$iortho').ne.0) then
        read(buf(8:),*) iorth
      else if(index(buf,'$sleeptime').ne.0) then
        read(buf(11:),*) sleeptime
      else if(index(buf,'$minnbt').ne.0) then
        read(buf(8:),*) minnbt
      else if(index(buf,'$rabsthres').ne.0) then
        read(buf(11:),*) rabsthres
      else if(index(buf,'$rchthres').ne.0) then
        read(buf(10:),*) rchthres
      else if(index(buf,'$dvthres').ne.0) then
        read(buf(9:),*) dvthres
      else if(index(buf,'$ecthres').ne.0) then
        read(buf(9:),*) ecthres
      else if(index(buf,'$end').ne.0) then
        goto 900
      end if
      goto 10
900   close(lu)
999   if(natoms.lt.2) stop 'natoms < 2. stop in rakiractrl'
      if(mode.eq.2) ipol=1
      if(lastqmatom.eq.0) lastqmatom=natoms
      end

***********************************************************************

      subroutine rkeyreal(anfname,anfkey,anfval)
*
* read file anfname; if <anfkey> is present, then read double precision
* variable anfval from the keyword input line
*
* written by J. Neugebauer, Uni Erlangen, 2002.
*
      implicit none
      integer lu,lanfn,lanfk
      real*8 anfval,anfold
      character*(*) anfname,anfkey
      character*132 buf
      logical ex
      lu=1
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
      anfold=anfval
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        read(buf(lanfk+1:),*,end=800,err=800) anfval
        goto 900
      end if
800   anfval=anfold
      goto 10
900   close(lu)
      end

***********************************************************************

      subroutine rkeyint(anfname,anfkey,anfval)
*
* read file anfname; if <anfkey> is present, then read integer
* variable anfval from the keyword input line
*
* written by J. Neugebauer, Uni Erlangen, 2002.
* modified by C. Herrmann, ETH Zurich, 30/05/07
*
      implicit none
      integer lu,lanfn,lanfk,anfval,anfvalold,ii
      character*(*) anfname,anfkey
      character*132 buf
      logical ex
      lu=1
      anfvalold=anfval
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
         ii=index(buf,anfkey(1:lanfk))
        read(buf(ii+lanfk+1:),*,err=800,end=800) anfval
        goto 900
      end if
800   anfval=anfvalold
      goto 10
900   close(lu)
      end

***********************************************************************

      subroutine rkeywd(anfname,anfkey,anfval)

*------------------------------------------------------------------
* read file anfname; if <anfkey> is present, then set anfval=.true.
*
* written by J. Neugebauer, Uni Erlangen, 2002.
*------------------------------------------------------------------

      implicit none
      integer lu,lanfn,lanfk
      character*(*) anfname,anfkey
      character*132 buf
      logical ex,anfval
      lu=1
      anfval=.false.
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        anfval=.true.
        goto 900
      end if
      goto 10
900   close(lu)
      end


***********************************************************************

      subroutine rnnbm(acontrol,iti,nbm,nnbm,mxit,itir)
*
* read no. of basis vectors for each iteration from akira_control
*
* written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer i,lactrl,lu,j,idum,iti,nbm,mxit,itir
      integer nnbm(mxit)
      character*(*) acontrol
      character*132 buf
      logical ex

      itir=0
      lu=1
      call llen(acontrol,lactrl)
      inquire(file=acontrol(1:lactrl), exist=ex)
      if(.not.ex) return
      open(unit=lu,file=acontrol(1:lactrl))
10    read(lu,'(A)',end=900) buf

*     ------------------------------------------------------------
*     read no. of iterations already done/prepared in previous run
*     (and no. of basis modes per iteration)
*     ------------------------------------------------------------
      if(index(buf,'$nnbm').ne.0) then
        read(buf(6:),*,end=800,err=800) iti
        nbm=0
        do i=1,iti
          read(lu,*,end=800,err=800) nnbm(i)
          nbm=nbm+nnbm(i)
        end do

*     -------------------------------------------------------
*     read iteration no. at which restart should be performed
*     -------------------------------------------------------
      else if(index(buf,'$restartit').ne.0) then
        read(buf(11:),*,end=800,err=800) itir
      else if(index(buf,'$end').ne.0) then
        if(itir == 0) itir = iti
        if(itir > iti) goto 800
        goto 900
      end if
      goto 10
800   continue
      call serror('rnnbm',2,'Error while reading akira_control !',6)
900   close(lu)
      end


***********************************************************************

      subroutine aphprec(normm,natoms,vibf,ic)

*--------------------------------------------------------------
* calculate approximate Hessian from approximate 
* wavenumbers and approximate normal modes; write approximate
* Hessian and wavenumbers for selected modes to akira_control file 
* in order to use approximate Hessian for preconditioning
*
*--------------------------------------------------------------------
* Note: in MOPAC output, the last six normal modes
* are the translational and rotational modes, while for SNF, ANF, AKIRA,
* TURBOMOLE and other programs the first six normal modes should be
* the translational and rotational modes
*--------------------------------------------------------------------
*
* written by J. Neugebauer, Uni Erlangen, 2002
* f90 memory management by J. Neugebauer, 2007
*--------------------------------------------------------------
#include "defs.h"

      real*8, allocatable :: hesstmp(:,:)
      integer i,j,natoms,nvar,ic(natoms),lu,mxrow,nrow
      parameter(mxrow=40000)
      character*132 buf,cbuf(mxrow)
      real*8 normm(3*natoms,3*natoms),vibf(3*natoms),fqfc
      real*8 qfc2freq
      logical ex
      external fqfc

      lu=1
      nvar=3*natoms

*--------------------------------------------------------------------
* allocate and initialize array
*--------------------------------------------------------------------
      allocate(hesstmp(nvar,nvar))
      hesstmp(:,:) = 0.0d0

*--------------------------------------------------------------------
* normal modes must be mass-weighted here
*--------------------------------------------------------------------
      do i=1,nvar
        call nmod_c2m(normm(1,i),natoms,ic)
      end do

*--------------------------------------------------------------------
* calculate force constants
* caution: zero-frequency modes might have artificial wavenumbers
*          of 10000
*--------------------------------------------------------------------
      do i=1,nvar
        if(vibf(i).lt.9999.0d0) hesstmp(i,i) = fqfc(vibf(i))
      end do

*--------------------------------------------------------------------
* calculate approximate cartesian hessian
*--------------------------------------------------------------------
      call hessian_nm2m(hesstmp,natoms,normm)
      call hessianumw(hesstmp,natoms,ic)

*--------------------------------------------------------------------
* write approximate hessian to akira_control
*--------------------------------------------------------------------
      nrow=0
      inquire(file='akira_control',exist=ex)
      open(unit=lu,file='akira_control',err=999)
      if(.not.ex) goto 800
100   read (lu,'(A)',err=998,end=800) buf
101   if((index(buf,'$appr_hessian').ne.0)) then
110     read(lu,'(A)',err=998,end=800) buf
        if(index(buf,'$').eq.0) then
          goto 110
        else
          goto 101
        end if
      else if(index(buf,'$end').ne.0) then
        goto 800
      else
        nrow=nrow+1
        if(nrow.gt.mxrow) then
          write(*,*) '** aphprec: too many rows in akira_control'
          stop
        end if
        cbuf(nrow)(1:132)=buf(1:132)
      end if
      goto 100
800   if(ex) rewind(lu)
      do i=1,nrow
        write(lu,'(A)') cbuf(i)
      end do
      call wrnmodes(natoms,hesstmp,nvar,'$appr_hessian',lu)
      write(lu,'(A)') '$precond aphsinv'
      write(lu,'(A)') '$end'
      goto 1000  

998   write(*,*) '** aphprec: Error while reading akira_control'
      goto 1000
999   write(*,*) '** aphprec: could not open akira_control'
1000  close(lu)

      deallocate(hesstmp)
*--------------------------------------------------------------------
* back to non mass-weighted normal modes
*--------------------------------------------------------------------
      do i=1,nvar
        call nmod_c2m(normm(1,i),natoms,ic)
      end do
      return
      end

***********************************************************************
 
      subroutine rkeystr(anfname,anfkey,anfstr)
C
C read file anfname; if <anfkey> is present, then read string
C variable anfstr from the keyword input line
C
C written by J. Neugebauer, Uni Erlangen, 2002.
C
      implicit none
      integer lu,lanfn,lanfk,lstr
      character*(*) anfname,anfstr,anfkey
      character*255 buf,anfold
      logical ex
      lu=1
      call slen(anfstr,lstr)
      call clean(anfold)
      anfold(1:lstr)=anfstr(1:lstr)
      call clean(anfstr)
      call slen(anfname,lanfn)
      call slen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) then
        anfstr(1:lstr)=anfold(1:lstr)
        return
      end if
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        read(buf(lanfk+2:),'(A)',err=800,end=800) anfstr
        goto 900
      end if
800   anfstr(1:lstr)=anfold(1:lstr)
      goto 10
900   close(lu)
      end

***********************************************************************
 
      subroutine rkeyonoff(anfname,anfkey,anfval)
 
*------------------------------------------------------------------
* read file anfname; if <anfkey on> is present, then set anfval=.true.
*
* written by J. Neugebauer, Uni Erlangen, 2002.
*------------------------------------------------------------------
 
      implicit none
      integer lu,lanfn,lanfk,ikey
      character*(*) anfname,anfkey
      character*132 buf
      logical ex,anfval
      lu=1
      anfval=.false.
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      ikey=index(buf,anfkey(1:lanfk))
      if(ikey.ne.0) then
        ikey=ikey-1+lanfk
        if(index(buf(ikey:),'on').ne.0) then
          anfval=.true.
          goto 900
        end if
      end if
      goto 10
900   close(lu)
      end
              
***********************************************************************

      SUBROUTINE akirahead(unit)
      implicit none
      integer unit

#include "version.h"

      write(unit,'(A)')
C        +1234567890123456789012345678+8765432109876543210987654321+
      write(unit,'(A)')
     * ' +----------------------------------------------------------+'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' |                        A K I R A                         |'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' |                            by                            |'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' |                J. Neugebauer, C. Herrmann,               |'
      write(unit,'(A)')
     * ' |                      and M. Reiher                       |'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' |             www.reiher.ethz.ch/software/akira            |'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' |                  ETH Zurich, 2006-2007                   |'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' | cite this work as:                                       |'
      write(unit,'(A)')
     * ' | M. Reiher, J. Neugebauer, J. Chem. Phys., 118 (2003) 1634|'
      write(unit,'(A)')
     * ' |                                                          |'
      write(unit,'(A)')
     * ' +----------------------------------------------------------+'
C        +1234567890123456789012345678+8765432109876543210987654321+
      write(unit,'(A)')
      write(unit,'(A)') version
      write(unit,'(A)')
      RETURN
      END
