      subroutine akiraini(lu,flag)
*---------------------------------------------------------
* read control and coord; initialize variables for anforce
*
* written by J. Neugebauer, Uni Erlangen, 2002.
* slighty adapted for excited state gradients by C. Herrmann,
* Uni Jena 04/2005
*---------------------------------------------------------

      use CoordModule
#include "defs.h"
#include "param.h"

      integer nn,iclean,icleanl,dtype,idummy,lu,ipos,la,flag
      real*8 dummy,dummy2
      character*132 buf
      character*10 prtype,catype
      logical valmod,valdtype,proj,ex
      external valmod,valdtype

*====================================================================
* initialization
*====================================================================
      rthres    = 5.0d-4
      rchthres  = rthres*1.0d-4
      rabsthres = -1.0d0
      dvthres   = -1.0d0
      ecthres   = -1.0d0
      masstype  = 1
      dtype     = 1
      roothmpr  = 'lastsel'
      genstart  = .false.
      g98it     = .true.
      g98bs     = .true.
      tmout     = .false.
      xmolout   = .false.
      snfout    = .false.
      precond   = 'backtra'
      minnbt    = 6
      iorth     = 8
      restadf   = '   '
      sleeptime = 5

*====================================================================
      la=1

      if(index(restart,'restart.akira').eq.0) restart='./restart.akira'
*-----------------------------------------------
* read control file
*-----------------------------------------------
       call rakiractrl('akira_control',rthres,rabsthres,dvthres,ecthres,
     *  roothmpr,g98it,g98bs,xmolout,tmout,printall,precond,genstart,
     *  rchthres,minnbt,iorth,snfout,natoms,mode,cstep,naus,iclean,
     *  icleanl,idbg,ipol,lastqmatom,irescp,restadf,sleeptime)
      if(mode.lt.20.and.mode.gt.0)
     * call rcontrol('control',rpast,smult,natoms,jscfc,
     * isuhf,riflag)
      iscfc=jscfc
      if(.not.valmod(mode)) then
        write(lu,*) '** akiraini: mode no. does not exist: ',mode
        call errex2('mode no. does not exist')
      end if
      call rkeyint('akira_control','$masstype',masstype)

*-------------------------------------------------
*  allocate memory (this is now done in tmini ...)
*-------------------------------------------------
      if(mode.eq.60) then
        call getnatomstm('coord',lastqmatom)
        call gcomqumnatoms('prmcrd3',natoms)
      end if
      if(flag.eq.1) then
        allocate(icharge(natoms), coord(3,natoms))
      end if

*-----------------------------------------------
* read coord file
*-----------------------------------------------
      if(mode.eq.60) then
        call readcomqum('prmcrd3','prmtop3',natoms,coord,icharge,
     *                  maxatoms)
      else
        call rcoord('coord',nn,coord,icharge)
        if(nn.ne.natoms.and.mode.ne.60) then
          write(lu,*)
     *     '** akiraini: natoms from control and coord differ!'
          call errex2('natoms from control and coord differ')
        end if
      end if

*-----------------------------------------------
* print basic input information
*-----------------------------------------------
      nvar=3*natoms
C      nstept=naus*maxnbm
      write(lu,'(a)')
      write(lu,'(a)') '  ==========================================='
      write(lu,'(a)') '               AKIRA Input'
      write(lu,'(a)') '  ==========================================='
      write(lu,'(a)')
      if(masstype.eq.2) then
        write(lu,'(a)')
     * '  NOTE THAT YOU ARE USING AVARAGE ATOMIC MASSES!'
        write(lu,'(a)')
     * '  (THIS IS FOR INTERNAL CONSISTENCY BECAUSE'
        write(lu,'(a)')
     * '  AOFORCE ALSO USES AVARAGE ATOMIC MASSES)'
        write(lu,'(a)')
      end if
      call prog_type(mode,prtype,catype)
      write(lu,'(a,a)')
     * '  Electronic structure program used     : ',prtype
      write(lu,'(a,a)')
     * '  Type of calculation                   : ',catype
      write(lu,'(a,i5)')
     * '  No. of atoms                          : ',natoms
      write(lu,'(a,i5)')
     * '  No. of degrees of freedom             : ',nvar
      write(lu,'(a,i5)')
     * '  Max. no. of basis vectors             : ',maxnbm
      write(lu,'(a,i5)')
     * '  No. of displacements per mode         : ',naus
      write(lu,'(a,i5)')
     * '  SCF convergence parameter             : ',jscfc
      call rkeyint('akira_control','$disptype',dtype)
      if(.not.valdtype(dtype)) call errex('disptype not valid')
      if(dtype.eq.1) then
        write(lu,'(a,f14.8)')
     *   '  Norm of cartesian displacement vector : ',cstep
      else if(dtype.eq.2) then
        write(lu,'(a,/,a,f14.8)')
     *   '  Expected change in energy for ',
     *   '  displacement geometries (harm. app.)  : ',cstep
      else
        write(lu,'(a)') 'Unknown displacement type !'
      end if
      call rakiractrl('akira_control',rthres,rabsthres,dvthres,ecthres,
     *  roothmpr,g98it,g98bs,xmolout,tmout,printall,precond,genstart,
     *  rchthres,minnbt,iorth,snfout,natoms,mode,cstep,naus,iclean,
     *  icleanl,idbg,ipol,lastqmatom,irescp,restadf,sleeptime)
      write(*,*) 'akiraini: roothmpr: ',roothmpr
      if(rchthres.lt.0.0d0) rchthres = rthres * 1.0d-4
      othres=10.0d0**(-iorth)
      write(lu,'(A)')
      write(lu,'(A)') '  Convergence criteria: '
      write(lu,'(A)') '  --------------------- '
      write(lu,'(A,f14.8)')
     * '  |max. component of residuum vector|   : ',rthres
      if(rabsthres.gt.0.0d0)
     *write(lu,'(A,f14.8)')
     * '  norm of residuum vector/(3*natoms)    : ',rabsthres
      if(dvthres.gt.0.0d0)
     *write(lu,'(A,f14.8)')
     * '  change in wavenumber                  : ',dvthres
      if(ecthres.gt.0.0d0)
     *write(lu,'(A,f14.8)')
     * '  expansion coef. of last basis vector  : ',ecthres
      write(lu,'(A,e14.8)')
     * '  change of max. comp. of residuum vec. : ',rchthres
      write(lu,'(A,i14)')
     * '  orthonormalization parameter          : ',iorth
      write(lu,'(A,e14.8)')
     * '  => orthonormalization threshold       : ',othres
      if(roothmpr.eq.'trackgv') then
        write(lu,'(a)')
     * '  Root homing w.r.t. initial guess selected '
        write(lu,'(a)')
     * '  (tracking initial guess vector) '
      else if (roothmpr.eq.'testmin') then
        write(lu,'(a)')
     * '  Optimizing lowest eigenvalue; no root homing applied'
      else
        write(lu,'(a)')
     * '  Root homing w.r.t. to last approximate normal mode selected '
      end if
      write(lu,'(A)') '  Preconditioning scheme: '//precond(1:7)
      if(precond.eq.'backtra') then
        write(lu,'(A)') '  min. no. of vectors for backtransformation '
        write(lu,'(A,i14)')
     *   '  (unit matrix will be used before)         : ',minnbt
      end if
      write(lu,*)
      write(lu,*)

*---------------------------------------
* read basic thresholds from control
*---------------------------------------
      write(lu,'(a)')
     * '  Thresholds for this calculation as read from control:'
      write(lu,'(a)')
     * '  -----------------------------------------------------'
      write(lu,*)

* $scfconv
      call rkeyint('control','$scfconv',idummy)
      write(lu,'(a,e16.8)')
     *  '  Energy convergence threshold  10**(-$scfconv) : ',
     * 10.0d0**(-dble(idummy))

* $denconv
      dummy=-1000.0d0
      call rkeyreal('control','$denconv',dummy)
      if(dummy.gt.0.0d0) then
        write(lu,'(a,e16.8)')
     *  '  Density matrix convergence threshold $denconv : ',dummy
      else
        write(lu,'(a)')
     *  '  Density matrix convergence threshold $denconv :  default'
      end if

* $scftol
      dummy=-1000.0d0
      call rkeyreal('control','$scftol',dummy)
      if(dummy.gt.0.0d0) then
        write(lu,'(a,e16.8)')
     *  '  Integral evaluation threshold $scftol         : ',dummy
      else
        write(lu,'(a)')
     *  '  Integral evaluation threshold $scftol         :  default'
      end if

* Note: actual threshold is assumed to be 10**(-$drvtol)
*       (see Turbomole V3.0 manual, p. 193)
* $drvtol
      dummy=-1000.0d0
      call rkeyreal('control','$drvtol',dummy)
      if(dummy.gt.0.0d0) then
        write(lu,'(a,e16.8)')
     *  '  Derivative integral neglect threshold $drvtol : ',dummy
      else
        write(lu,'(a)')
     *  '  Derivative integral neglect threshold $drvtol :  default'
      end if

* Note: $convcr is not a standard keyword in TURBOMOLE but has
*       been introduced by J.N. in a local version of aoforce
* $convcr
      dummy=-1000.0d0
      call rkeyreal('control','$convcr',dummy)
      if(dummy.gt.0.0d0) then
        write(lu,'(a,e16.8)')
     *  '  Convergence threshold for Hessian $convcr     : ',dummy
      else
        write(lu,'(a)')
     *  '  Convergence threshold for Hessian $convcr     :  default'
      end if

* gradient norm
      inquire(file='job.last',exist=ex)
      if(ex) then
        dummy=-1.0d0
        open(unit=la,file='job.last')
102     read(la,'(A)',end=202) buf
        ipos=index(buf,'|maximum compo')
        if(ipos.ne.0) then
          read(buf(36:51),*) dummy
          read(la,'(A)',end=202) buf
          read(buf(36:51),*) dummy2
        end if
        goto 102
202     close(la)
        goto 300
      end if
      inquire(file='grad.out',exist=ex)
      if(ex) then
        dummy=-1.0d0
        open(unit=la,file='grad.out')
100     read(la,'(A)',end=200) buf
        ipos=index(buf,'|maximum compo')
        if(ipos.ne.0) then
          read(buf(36:51),*) dummy
          read(la,'(A)',end=200) buf
          read(buf(36:51),*) dummy2
        end if
        goto 100
200     close(la)
        goto 300
      end if
      inquire(file='gradient',exist=ex)
      if(ex) then
        dummy2=-1.0d0
        open(unit=la,file='gradient')
101     read(la,'(A)',end=201) buf
        ipos=index(buf,'|dE/dxyz| =')+11
        if(ipos.ne.11) read(buf(ipos:),*) dummy2
        goto 101
201     close(la)
      end if
300   if(dummy.ge.0) then
        write(lu,'(a,e14.6)')
     *  '  |maximum component of gradient|               : ',dummy
        if(dummy2.ge.0) write(lu,'(a,e14.6)')
     *  '  Norm of gradient                              : ',dummy2
      else
        write(lu,'(a)') '  Gradient norm unknown '
      end if

      write(lu,*)
      call flush(lu)

      if(mode.lt.20)
     * call molchar('control',natoms,icharge,mcharge)
      call pcoord(natoms,coord,icharge,mcharge,lu,mode)
      end
