
      subroutine akirainp(grad,istepfl,vmach,ic,normm,escf,pol,nbm)
*-----------------------------------------------------------------------
* written by J. Neugebauer, Uni Erlangen, 2002.
*-----------------------------------------------------------------------

#include "defs.h"
#include "param.h"

      real*8 normm(nvar*maxnbm)
      real*8 vmach(*),grad(*),dev
      real*8 escf(*),pol(*),ieigv(3)
      integer istepfl(*),ic(*),i,isum,ptmod,prmod,nbm
      integer izm,j
      logical gradtst,prnmod
      character*60 text

*----------------------------------------------------------------------
* read input: aoforce output for equilibrium geometry (in <control>)
*             1) basis vector coordinates
*----------------------------------------------------------------------
      call getnctm('akira_control',natoms,normm,
     * '$vibrational basis modes',maxnbm)

*----------------------------------------------------------------------
* transform cartesian normal modes to mass-weighted normal modes
*----------------------------------------------------------------------
      do i=1,maxnbm
        call nmod_c2m(normm(3*natoms*(i-1)+1),natoms,ic)
      end do

*----------------------------------------------------------------------
* print normal coordinates
*----------------------------------------------------------------------
      call rkeywd('akira_control','$prnmod',prnmod)
      do i=1,maxnbm
        if(prnmod) then
          write(text, '(a,i5)')'normal mode no. : ',i
          call printdmat(normm(3*natoms*(i-1)+1),nvar,1,text,
     *     'f20.12',ftape)
        end if
      end do

*----------------------------------------------------------------------
* read input: restart file
*----------------------------------------------------------------------
      call rrestart(vmach,grad,istepfl,isum,escf,pol,nbm)
      if(isum.ne.nstept) then
        write(*,*) 'isum, nstept: ',isum,nstept
        call errex('Not all calculations done !')
      end if

      end 
