      SUBROUTINE cslave(nbm)

******************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001 *
* modified by C. Herrmann, Uni Bonn, 2004-2005       *
* for Gaussian and ADF interface                     *
*                                                    *
* switch to f90 memory management                    *
* by J. Neugebauer, 2007                             *
******************************************************

#include "defs.h"
#include "param.h"

      integer nbm
      nvar=3*natoms

      call rkeyint(tempdir(1:lt)//'/akira_control','$maxnbm',maxnbm)
      if(nvar.lt.maxnbm) maxnbm=nvar

      if(mode.eq.4) then
*       ---------------------------------------------
*       mode 4: dscf, grad (for special motions)
*               (also: ridft, rdgrad)
*       ---------------------------------------------
        call rslavem4(nbm)

      else if(mode.eq.5) then
*       ---------------------------------------------
*       mode 5: dscf, mpgrad (for special motions)
*               (also: dscf, rimp2)
*       ---------------------------------------------
        call rslavem5(nbm)

      else if(mode.ge.20.and.mode.le.25.or.mode.eq.28) then
*       ---------------------------------------------
*       mode 20 - 25: DALTON calculations 
*       (SCF, MP2, MSCF, coupled cluster)
*       ---------------------------------------------
        call rslavemd(nbm)

      else if(mode.eq.10) then
*       -------------------------------------------------
*       mode 10: test mode, no calculations will be done
*       -------------------------------------------------
        call rslavem10(nbm)

      else if(mode.ge.30.and.mode.le.33) then
*       -------------------------------------------------
*       mode 30-33: GAUSSIAN calculations
*       -------------------------------------------------
        call rslavem30(nbm)

      else if(mode.ge.40.and.mode.lt.50) then
*       -------------------------------------------------
*       mode 40: ADF calculations
*       -------------------------------------------------
        call rslavem40(nbm)

       else if(mode.ge.60.and.mode.lt.70) then
*       -------------------------------------------------
*       mode 60: COMQUM calculations
*       -------------------------------------------------
        call rslavem60(nbm)

      else
        call errex('mode not available')

      end if

      return
      end
