#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      subroutine fsys(stepfl)

*     ---------------------------------------------------------
*     nonblocking receive for fsys records and for stop records
*
*     migrate to MachineModule by J. Neugebauer, 2007
*     ---------------------------------------------------------

      use MachineModule
      use PVMVarsModule

#include "defs.h"
#include "param.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

      type(type_machine), pointer :: mach,cmach
      integer needans
      integer stepfl(*)
      parameter (needans=6000)
      integer ibuf,info,ilen,i,j,ist,ien,now,last
      integer*4 irc4,icase4,ilen4,tid4,pid4
      character*255 text
      character*24 date
      character*40 name
      real*8 getreal,loadav
#ifdef AKIRA_MPI
      integer st(mpi_status_size)
      integer w,icase,icall,itype
      logical flag
      data w /mpi_comm_world/
#endif
      call secs(now)

88    continue

*     -------------------------------------------------------------
*     check for messages sent by the slave nodes via "mnotify"
*     -------------------------------------------------------------
#ifdef AKIRA_PVM
      call pvmfnrecv(-1,fsyscallpvm,ibuf)
      if (ibuf.ne.0) then
        call pvmfunpack(integer4,tid4,1,1,info)
        call pvmfunpack(integer4,pid4,1,1,info)
        call pvmfunpack(integer4,irc4,1,1,info)
        call pvmfunpack(integer4,icase4,1,1,info)
        call pvmfunpack(integer4,ilen4,1,1,info)
        ilen=ilen4
        call pvmfunpack(string,text,ilen,1,info)
        i=tid4
#endif
#ifdef AKIRA_MPI
      call mpi_iprobe(mpi_any_source,fsys_mpitag,w,flag,st,info)
      call mpierr('mpi_probe','fsys',info)
      if (flag) then
        call mpi_recv(icall,1,mpi_integer,mpi_any_source,
     *   fsys_mpitag,w,st,info)
        call mpierr('mpi_recv icall','fsys',info)
        tid4=icall
        i=icall
       
* receive call type
        CALL MPI_RECV(itype,1,MPI_INTEGER,i,501,w,st,info)
        CALL mpierr('MPI_RECV type','fsys',info)
       
        IF (itype.EQ.fsys_mnotify) THEN
         CALL MPI_RECV(j,1,MPI_INTEGER,i,502,w,st,info)
         CALL mpierr('MPI_RECV pid','fsys',info)
         pid4=j
         CALL MPI_RECV(j,1,MPI_INTEGER,i,503,w,st,info)
         CALL mpierr('MPI_RECV irc','fsys',info)
         irc4=j
         CALL MPI_RECV(j,1,MPI_INTEGER,i,504,w,st,info)
         CALL mpierr('MPI_RECV icase','fsys',info)
         icase4=j
         CALL MPI_RECV(j,1,MPI_INTEGER,i,505,w,st,info)
         CALL mpierr('MPI_RECV len','fsys',info)
         ilen4=j
         CALL clean(text)
         CALL MPI_RECV(text,j,MPI_CHARACTER,i,506,w,st,info)
         CALL mpierr('MPI_RECV cmd','fsys',info)
         ilen4=j
         ilen=ilen4
#endif
        nullify(cmach)
        call findnode_by_tid(cmach,i)
        if(.not.associated(cmach)) then
          write (*,102) 'FSYS ',info,tid4,pid4,irc4,icase4,
     *     ' ',text(1:ilen4)
          write (*,*) '###### unknown tid: ',tid4
          call print_nodes(machlist,jtape)
          goto 88
        end if
       
        mach => cmach
        mach%tmsg = now
       
*       ----------------------------------------------------------------
*       Note: average load reporting and cpu time reporting are done
*             by routines in fsystem.c
*       ----------------------------------------------------------------
        if (icase4.eq.1) then
          mach%tpid = pid4
          mach%trc  = 0
       
        else if (icase4.eq.3) then
*         ----------------------
*         average load reporting
*         ----------------------
          ist=1
          loadav=getreal(text,ist,ien)
          mach%load = DINT(100.0d0*loadav)
          mach%trc  = DINT(100.0d0*loadav)
          mach%tmsg = now
       
        else if (icase4.eq.4) then
*         ------------------
*         cpu time reporting
*         ------------------
          call setmach_pmsg(mach,text(1:ilen))
       
        else if (icase4.eq.6) then
*         ----------------------------
*         reporting debugging messages
*         ----------------------------
          write (idbg,*) '::: tid ',tid4,' pid ',pid4,' rc ',irc4,
     *                 ' waiting for ctok (in vain)'
          write (idbg,*) text(1:ilen4)
          call errex('token queue disabled')
       
        else if (icase4.eq.7) then
*        --------------
*        request ctoken
*        --------------
          call errex('token queue disabled')
       
        else if (icase4.eq.8) then
*         --------------
*         release ctoken
*         --------------
          call errex('token queue disabled')
       
        else if (icase4.eq.9) then
*         ----------------------------------------
*         node ready message (not used at present)
*         ----------------------------------------
          write (idbg,*) '::: tid ',tid4,irc4,text(1:ilen4)
*         if (irc4.eq.okok) then
*           mach%nodf='rdy'
*         else
*           mach%nodf='unf'
*         end if
       
        else if (icase4.eq.2) then
          call setmach_pmsg(mach,' ')
          mach%tpid = 0
          mach%trc  = irc4
       
        else
          call setmach_pmsg(mach,text(1:ilen))
          mach%trc  = irc4*10000+icase4
         
        end if
        if (iprintf.gt.0) then
          write (*,102) 'FSYS ',info,tid4,pid4,irc4,icase4,' ',
     &      text(1:ilen4)
        end if
102     format(a,5i10,2a)
        goto 88
      end if

** check for stop records
**
#ifdef AKIRA_PVM
       call pvmfnrecv(-1,taskstoppvm,ibuf)
       if (ibuf.ne.0) then
        call pvmfunpack(integer4,tid4,1,1,info)
        call pvmfunpack(integer4,irc4,1,1,info)
        if (tid4.eq.0) then
          write (*,*) 'pvmtaskexit received tid 0'
          call shutdown
        end if
#endif
#ifdef AKIRA_MPI
       if (itype.EQ.fsys_taskstop) THEN
         call MPI_RECV(j,1,MPI_INTEGER,i,601,w,st,info)
         call mpierr('MPI_RECV irc','fsys',info)
         irc4=j
#endif
         call fdate(date)
         nullify(cmach)
         call findnode_by_tid(cmach,i)
         if(.not.associated(cmach)) then
           write (*,102) 'FSYS ',info,tid4,irc4,' ',text(1:ilen4)
           call print_nodes(machlist,jtape)
           write (*,*) '###### unknown tid: ',tid4
           goto 88
         endif
         call remnode('node stopped',irc4,stepfl,mach%numb)
         goto 88
       end if
#ifdef AKIRA_MPI
       end if
#endif

#ifndef SNF_SMP
*      --------------------------------------------------------------
*      check if a node did not answer for more then <needans> seconds
*      --------------------------------------------------------------
       mach => machlist
       NodeLoop_: do
         if(.not.associated(mach)) exit NodeLoop_
         last=mach%tmsg
         if (mach%nodf == 'run' .and. last.ne.0) then
           if (now-last.gt.needans) then
             call getmach_name(mach,name)
             write (*,*) name(1:8),' did not answer for ',needans,
     *        ' seconds.'
             write (*,*) 'terminating node'
             mach%nodf = 'nans'
             mach%tmsg = 0
             call setmach_pmsg(mach,'timeout')
             call remnode('terminating node',mach_term,stepfl,mach%numb)
           end if
         end if
         mach => mach%next
       end do NodeLoop_
#endif
       return
       end
