***********************************************************************

 
      subroutine rgaussian(txt,normm,natoms,freq,nbm)
C
C read gaussian output
C
C written by J. Neugebauer, Uni Erlangen, 2003
C
      implicit none
#include "fconstants.h"
      integer natoms,nbm
      integer lu,i,j,nr,nc,ka,kb,kc,la,lb,lt,idum
      real*8 normm(3*natoms,nbm)
      real*8 freq(3*natoms),fqfc
      character*(*) txt
      character*(255) buf
      logical lnewvers
     
      external fqfc
      lu=1
      lnewvers = .false.
      call llen(txt,lt)
      open(unit=lu,file=txt(1:lt))
 
****
* look for frequencies
****
10    read(lu,'(a)',err=999,end=999) buf
       if(index(buf,'Harmonic frequencies (cm**-1)').ne.0) goto 20
      goto 10
20    read(lu,'(a)',err=999,end=999) buf
      read(lu,'(a)',err=999,end=999) buf

* -----------------------------------
* added for new gaussian version (g03)
* -----------------------------------
      if(index(buf,'normal coordinates').eq.0) then
        lnewvers=.true.
        read(lu,'(a)',err=999,end=999) buf
      end if

      nc=nbm
      nr=natoms
 
      ka=1
      kc=3
60    kb=min0(kc,nc)
      read(lu,'(a)',err=999,end=999) buf
      read(lu,'(a)',err=999,end=999) buf
      read(lu,'(a)',err=999,end=999) buf
      read(buf(16:),*) (freq(j),j=ka,kb)
      do i=1,6
        read(lu,'(a)',err=999,end=999) buf
      end do

* -----------------------------------
* added for new gaussian version (g03)
* -----------------------------------
      if(lnewvers) then
        read(lu,'(a)',err=999,end=999) buf
      end if

      la=1
70    lb=nr
      do i=la,lb
        read(lu,130) idum,idum,(normm(i*3-2,j),normm(i*3-1,j),
     *    normm(i*3,j),j=ka,kb)
      end do
      if (lb.eq.nr) goto 80
      goto 70
80    if (kb.eq.nc) then
         close(lu)
         return
      endif
      ka=kc+1
      kc=kc+3
      goto 60
 
130   format (2i4,3(2x,3f7.2))
999   close(lu)
      return
      end 

***********************************************************************
 
      subroutine pgaussian(txt,normm,natoms,coord,freq,ic,nbm)
C
C write g98 fake output
C
C written by J. Neugebauer, Uni Erlangen, 2002
C
      implicit none
#include "fconstants.h"
      integer natoms,nbm
      integer lu,i,j,ic(natoms),nr,nc,ka,kb,kc,la,lb,lt
      real*8 normm(3*natoms,nbm),coord(3,natoms)
      real*8 freq(3*natoms),fqfc
      character*(*) txt
     
      external fqfc
      lu=1
      call llen(txt,lt)
      open(unit=lu,file=txt(1:lt))
 
****
* print header
****
      write(lu,'(a)') ' Entering Gaussian System'
      write(lu,'(a)') ' *********************************************'
      write(lu,'(a)') ' Gaussian 98:'
      write(lu,'(a)') ' frequency fake output'
      write(lu,'(a)') ' *********************************************'
 
****
* print coordinates
****
      write(lu,*) '                        Standard orientation:'
      write(lu,*) '---------------------------------------------------'
     * //'-----------------'
      write(lu,*) ' Center     Atomic     Atomic              '//
     * 'Coordinates (Angstroms)'
      write(lu,*) ' Number     Number      Type              X'//
     *   '           Y           Z'
      write(lu,*) '---------------------------------------------------'
     * //'-----------------'
      do i=1,natoms
        write(lu,90) i,ic(i),0,coord(1,i)*bohr2ang,
     *   coord(2,i)*bohr2ang,coord(3,i)*bohr2ang
      end do
      write(lu,*) '---------------------------------------------------'
     * //'-----------------'
      write(lu,*) '    1 basis functions        1 primitive gaussians'
      write(lu,*) '    1 alpha electrons        1 beta electrons'
      write(lu,*)
 
****
* print normal modes
****
      write (lu,*) 'Harmonic frequencies (cm**-1), '//
     * 'IR intensities (KM/Mole),'
      write (lu,*) 'Raman scattering activities (A**4/amu), '//
     * 'Raman depolarization ratios,'
      write (lu,*) 'reduced masses (AMU), force constants '//
     * '(mDyne/A) and normal coordinates:'
      nc=nbm
      nr=natoms
 
C      ka=1
      ka=1
      kc=3
60    kb=min0(kc,nc)
      write (lu,100) (j,j=ka,kb)
      write (lu,105) ('   a',j=ka,kb)
      write (lu,110) ' Frequencies --',(freq(j),j=ka,kb)
      write (lu,110) ' Red. masses --',(0.0d0,j=ka,kb)
      write (lu,110) ' Frc consts  --',(fqfc(freq(j)),j=ka,kb)
      write (lu,110) ' IR Inten    --',(0.0d0,j=ka,kb)
      write (lu,110) ' Raman Activ --',(0.0d0,j=ka,kb)
      write (lu,110) ' Depolar     --',(0.0d0,j=ka,kb)
      write (lu,'(a75)') 'Atom AN      X      Y      Z        '//
     * 'X      Y      Z        X      Y      Z'
      la=1
70    lb=nr
      do i=la,lb
        write (lu,130) i,ic(i),(normm(i*3-2,j),normm(i*3-1,j),
     *    normm(i*3,j),j=ka,kb)
      end do
      if (lb.eq.nr) goto 80
      goto 70
80    if (kb.eq.nc) then
         write(lu,*) '  '
         close(lu)
         return
      endif
      ka=kc+1
      kc=kc+3
      goto 60
 
100   format (3(20x,i3))
105   format (3x,3(19x,a4))
110   format (a15,f11.4,12x,f11.4,12x,f11.4)
130   format (2i4,3(2x,3f7.2))
90    format(i5,i11,i14,4x,3f12.6)
      end 


