      subroutine getchar(symmetry,nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
*------------------------------------------------------------------
* ---------------------------------
* currently supported point groups: 
* ---------------------------------
* C1,Ci,Cs             |  (3)
* C2,C3,C4,C5,C6,C7,C8 |  (7)
* C2v,C3v,C4v,C5v,C6v  |  (5)
* C2h,C3h,C4h,C5h,C6h  |  (5)
* S4,S6,S8             |  (3)
* D2,D3,D4,D5,D6       |  (5)
* D2d,D3d,D4d,D5d,D6d  |  (5)
* D2h,D3h,D4h,D5h,D6h  |  (5)
* T,Td,Th,O,Oh,I,Ih    |  (7)
* ------------------------------------------
* => 45 point groups are currently supported
* ------------------------------------------
*
* all subroutines written by J. Neugebauer, Uni Erlangen, 2003
* all subroutines are based on the corresponding F90 subroutines
* by C. Kind and J. Neugebauer in the package SNF
*------------------------------------------------------------------
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,ls
      real*8 char(mxnsymel,mxirrep)
      character*7 symel(mxnsymel)
      character*5 irrep(mxirrep)
      character*3 symmetry
 
      call lower(symmetry)
      call slen(symmetry,ls)
      if(ls.eq.2) symmetry(3:3)=' '
      if(ls.eq.1) symmetry(2:3)='  '
      if(symmetry.eq.'c1 ') then
        call init_c1(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'ci ') then
        call init_ci(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'cs ') then
        call init_cs(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c2 ') then
        call init_c2(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c3 ') then
        call init_c3(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c4 ') then
        call init_c4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c5 ') then
        call init_c4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c6 ') then
        call init_c6(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c7 ') then
        call init_c7(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c8 ') then
        call init_c8(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'s4 ') then
        call init_s4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'s6 ') then
        call init_s6(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c2v') then
        call init_c2v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c3v') then
        call init_c3v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c4v') then
        call init_c4v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c5v') then
        call init_c5v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c6v') then
        call init_c6v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c2h') then
        call init_c2h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c3h') then
        call init_c3h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c4h') then
        call init_c4h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c5h') then
        call init_c5h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'c6h') then
        call init_c6h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d2 ') then
        call init_d2(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d3 ') then
        call init_d3(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d4 ') then
        call init_d4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d5 ') then
        call init_d5(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d6 ') then
        call init_d6(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d2d') then
        call init_d2d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d3d') then
        call init_d3d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d4d') then
        call init_d4d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d5d') then
        call init_d5d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d6d') then
        call init_d6d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d2h') then
        call init_d2h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d3h') then
        call init_d3h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d4h') then
        call init_d4h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d5h') then
        call init_d5h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'d6h') then
        call init_d6h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'t  ') then
        call init_t(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'td ') then
        call init_td(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'th ') then
        call init_th(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'o  ') then
        call init_o(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'oh ') then
        call init_oh(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'i  ') then
        call init_i(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else if(symmetry.eq.'ih ') then
        call init_ih(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      else
        stop 'point group not supported'
      end if
      return
      end

*=====================================================================
* C_1
*=====================================================================

      subroutine init_c1(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=1,snsymel=1)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,1) / 1.0d0 /
      data (ssymel(i),i=1,1) / 'cz1_1  ' /
      data (sirrep(i),i=1,1) / 'a    ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_2
*=====================================================================

      subroutine init_c2(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=2,snsymel=2)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,2) / 1.0d0, 1.0d0 /
      data (schar(i,2),i=1,2) / 1.0d0,-1.0d0 /
      data (ssymel(i),i=1,2) / 'cz1_1  ', 'cz2_1  ' /

      data (sirrep(i),i=1,2) / 'a    ','b    ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* S_8
*=====================================================================

      subroutine init_s8(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel

      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0,
     *   2.d0, 0.d0,-2.d0, 0.d0, 2.d0, 0.d0,-2.d0, 0.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','sz8_1  ','cz4_1  ','sz8_3  ',
     * 'cz2_1  ','sz8_5  ','cz4_3  ','sz8_7  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','b    ','e1   ','e2   ','e3   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* S_6
*=====================================================================

      subroutine init_s6(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=6)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel

      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   2.d0,-1.d0,-1.d0, 2.d0,-1.d0,-1.d0,
     *   1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *   2.d0,-1.d0,-1.d0,-2.d0, 1.d0, 1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz3_1  ','cz3_2  ',
     * 'sz2_1  ','sz6_5  ','sz6_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','eg   ','au   ','eu   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end


*=====================================================================
* C_3
*=====================================================================

      subroutine init_c3(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=2,snsymel=3)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,3)/ 1.0d0, 1.0d0, 1.0d0/
      data (schar(i,2),i=1,3)/ 2.0d0,-1.0d0,-1.0d0/
      data (ssymel(i),i=1,3) / 
     * 'cz1_1  ','cz3_1  ','cz3_2  '/

      data (sirrep(i),i=1,2) / 'a    ','e    ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end


*=====================================================================
* C_i
*=====================================================================

      subroutine init_ci(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=2,snsymel=2)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,2) / 1.0d0, 1.0d0 /
      data (schar(i,2),i=1,2) / 1.0d0,-1.0d0 /
      data (ssymel(i),i=1,2) / 'cz1_1  ', 'sz2_1  ' /

      data (sirrep(i),i=1,2) / 'ag   ','au   ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_s
*=====================================================================

      subroutine init_cs(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=2,snsymel=2)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,2) / 1.0d0, 1.0d0 /
      data (schar(i,2),i=1,2) / 1.0d0,-1.0d0 /
      data (ssymel(i),i=1,2) / 'cz1_1  ', 'sh     ' /

      data (sirrep(i),i=1,2) / 'a1   ','a2   ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_3v
*=====================================================================

      subroutine init_c3v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=3,snsymel=6)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,6)/ 1.0d0, 1.0d0, 1.0d0, 1.0d0, 1.0d0, 1.0d0/
      data (schar(i,2),i=1,6)/ 1.0d0, 1.0d0, 1.0d0,-1.0d0,-1.0d0,-1.0d0/
      data (schar(i,3),i=1,6)/ 2.0d0,-1.0d0,-1.0d0, 0.0d0, 0.0d0, 0.0d0/
      data (ssymel(i),i=1,6) / 
     * 'cz1_1  ', 'cz3_1  ','cz3_2  ', 'sv3_0  ', 'sv3_1', 'sv3_2' /

      data (sirrep(i),i=1,3) / 'a1   ','a2   ','e    ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_2v
*=====================================================================

      subroutine init_c2v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=4)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(i,1),i=1,4) / 1.0d0, 1.0d0, 1.0d0, 1.0d0 /
      data (schar(i,2),i=1,4) / 1.0d0, 1.0d0,-1.0d0,-1.0d0 /
      data (schar(i,3),i=1,4) / 1.0d0,-1.0d0, 1.0d0,-1.0d0 /
      data (schar(i,4),i=1,4) / 1.0d0,-1.0d0,-1.0d0, 1.0d0 /
      data (ssymel(i),i=1,4) / 
     * 'cz1_1  ', 'cz2_1  ','sv2_0  ', 'sd2_0  ' /

      data (sirrep(i),i=1,4) / 
     * 'a1   ','a2   ','b1   ','b2   ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_6d
*=====================================================================

      subroutine init_d6d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=9,snsymel=24)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      real*8 sqrt
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      intrinsic sqrt

      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0,-1.d0,
     *-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 2.d0, 0.d0, 0.d0, 1.d0, 
     * 1.d0, 0.d0, 0.d0,-1.d0,-1.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 
     * 2.d0, 1.d0, 1.d0,-1.d0,-1.d0,-2.d0,-2.d0,-1.d0,-1.d0, 1.d0, 
     * 1.d0, 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 
     * 0.d0, 0.d0, 0.d0, 0.d0, 2.d0, 0.d0, 0.d0,-2.d0,-2.d0, 0.d0, 
     * 0.d0, 2.d0, 2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 2.d0,-1.d0, 
     *-1.d0,-1.d0,-1.d0, 2.d0, 2.d0,-1.d0,-1.d0,-1.d0,-1.d0, 2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 
     * 0.d0, 0.d0, 2.d0, 0.d0, 0.d0, 1.d0, 1.d0, 0.d0, 0.d0,-1.d0, 
     *-1.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','sz12_1 ','sz12_11','cz6_1  ',
     * 'cz6_5  ','sz4_1  ','sz4_3  ','cz3_1  ',
     * 'cz3_2  ','sz12_5 ','sz12_7 ','cz2_1  ',
     * 'cx6_0  ','cx6_1  ','cx6_2  ','cx6_3  ',
     * 'cx6_4  ','cx6_5  ','sd12_0 ','sd12_1 ',
     * 'sd12_2 ','sd12_3 ','sd12_4 ','sd12_5 '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ','b2   ',
     * 'e1   ','e2   ','e3   ','e4   ','e5   '/

      schar(2,5)=sqrt(3.0d0)
      schar(3,5)=schar(2,5)
      schar(10,5)=-schar(2,5)
      schar(11,5)=-schar(2,5)
      schar(2,9)=-schar(2,5)
      schar(3,9)=-schar(2,5)
      schar(10,9)=schar(2,5)
      schar(11,9)=schar(2,5)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_5d
*=====================================================================

      subroutine init_d5d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=8,snsymel=20)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      real*8 sqrt
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      intrinsic sqrt

      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz5_1  ','cz5_4  ','cz5_2  ',
     * 'cz5_3  ','cx5_0  ','cx5_1  ','cx5_2  ',
     * 'cx5_3  ','cx5_4  ','sz2_1  ','sz10_3 ',
     * 'sz10_7 ','sz10_1 ','sz10_9 ','sd10_0 ',
     * 'sd10_1 ','sd10_2 ','sd10_3 ','sd10_4 '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1g  ','a2g  ','e1g  ','e2g  ',
     * 'a1u  ','a2u  ','e1u  ','e2u  '/

      schar(2,3)=2.0d0*cos(2.0d0*pi/5.0d0)
      schar(3,3)=schar(2,3)
      schar(4,3)=2.0d0*cos(4.0d0*pi/5.0d0)
      schar(5,3)=schar(4,3)
      schar(12,3)=schar(2,3)
      schar(13,3)=schar(2,3)
      schar(14,3)=schar(4,3)
      schar(15,3)=schar(4,3)
      
      schar(2,4)=schar(4,3)
      schar(3,4)=schar(4,3)
      schar(4,4)=schar(2,3)
      schar(5,4)=schar(2,3)
      schar(12,4)=schar(4,3)
      schar(13,4)=schar(4,3)
      schar(14,4)=schar(2,3)
      schar(15,4)=schar(2,3)
     
      schar(2,7)=schar(2,3)
      schar(3,7)=schar(2,3)
      schar(4,7)=schar(4,3)
      schar(5,7)=schar(4,3)
      schar(12,7)=-schar(2,3)
      schar(13,7)=-schar(2,3)
      schar(14,7)=-schar(4,3)
      schar(15,7)=-schar(4,3)
     
      schar(2,8)=schar(4,3)
      schar(3,8)=schar(4,3)
      schar(4,8)=schar(2,3)
      schar(5,8)=schar(2,3)
      schar(12,8)=-schar(4,3)
      schar(13,8)=-schar(4,3)
      schar(14,8)=-schar(2,3)
      schar(15,8)=-schar(2,3)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_4d
*=====================================================================

      subroutine init_d4d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=7,snsymel=16)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      real*8 sqrt
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      intrinsic sqrt

      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,-2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0,-2.d0,-2.d0, 0.d0, 0.d0, 2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,-2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','sz8_1  ','sz8_7  ','cz4_1  ',
     * 'cz4_3  ','sz8_3  ','sz8_5  ','cz2_1  ',
     * 'cx4_0  ','cx4_1  ','cx4_2  ','cx4_3  ',
     * 'sd8_0  ','sd8_1  ','sd8_2  ','sd8_3  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ','b2   ',
     * 'e1   ','e2   ','e3   '/

      schar(2,5)=sqrt(2.0d0)
      schar(3,5)=schar(2,5)
      schar(6,5)=-schar(2,5)
      schar(7,5)=-schar(2,5)
      schar(2,7)=-schar(2,5)
      schar(3,7)=-schar(2,5)
      schar(6,7)=schar(2,5)
      schar(7,7)=schar(2,5)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_3d
*=====================================================================

      subroutine init_d3d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=12)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0, 
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 1.d0, 1.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz3_1  ','cz3_2  ','cx3_0  ',
     * 'cx3_1  ','cx3_2  ','sz2_1  ','sz6_1  ',
     * 'sz6_5  ','sd6_0  ','sd6_1  ','sd6_2  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1g  ','a2g  ','eg   ','a1u  ',
     * 'a2u  ','eu   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_2d
*=====================================================================

      subroutine init_d2d(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *   1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 
     *   1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 
     *   2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','sz4_1  ','sz4_3  ','cz2_1  ',
     * 'cx2_0  ','cx2_1  ','sd4_0  ','sd4_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ','b2   ',
     * 'e    ' /

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_2h
*=====================================================================

      subroutine init_d2h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=8,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 
     *   1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 
     *   1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0, 
     *   1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 
     *   1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 
     *   1.d0,-1.d0,-1.d0, 1.d0,-1.d0, 1.d0, 1.d0,-1.d0, 
     *   1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0,-1.d0, 1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  ',
     * 'sz2_1  ','sh     ','sd2_0  ','sv2_0  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','b1g  ','b2g  ','b3g  ',
     * 'au   ','b1u  ','b2u  ','b3u  '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_6
*=====================================================================

      subroutine init_d6(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=12)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,
     * 2.d0, 1.d0, 1.d0,-1.d0,-1.d0,-2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0,-1.d0,-1.d0,-1.d0,-1.d0, 2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz6_1  ','cz6_5  ','cz3_1  ',
     * 'cz3_2  ','cz2_1  ','cx6_0  ','cx6_2  ',
     * 'cx6_4  ','cx6_1  ','cx6_3  ','cx6_5  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ','b2   ',
     * 'e1   ','e2   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_5
*=====================================================================

      subroutine init_d5(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=10)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz5_1  ','cz5_4  ','cz5_2  ',
     * 'cz5_3  ','cx5_0  ','cx5_1  ','cx5_2  ',
     * 'cx5_3  ','cx5_4  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','e1   ','e2   '/

      schar(2,3)=2.0d0*cos(2.0d0*pi/5.0d0)
      schar(3,3)=schar(2,3)
      schar(4,3)=2.0d0*cos(4.0d0*pi/5.0d0)
      schar(5,3)=schar(4,3)
      schar(2,4)=schar(4,3)
      schar(3,4)=schar(4,3)
      schar(4,4)=schar(2,3)
      schar(5,4)=schar(2,3)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_4
*=====================================================================

      subroutine init_d4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,
     * 2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz4_1  ','cz4_3  ','cz2_1  ',
     * 'cx4_0  ','cx4_2  ','cx4_1  ','cx4_3  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ',
     * 'b2   ','e    '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_3
*=====================================================================

      subroutine init_d3(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=3,snsymel=6)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz3_1  ','cz3_2  ','cx3_0  ',
     * 'cx3_1  ','cx3_2  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','e    '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_2
*=====================================================================

      subroutine init_d2(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=4)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0, 1.d0,-1.d0,-1.d0, 
     *   1.d0,-1.d0, 1.d0,-1.d0, 
     *   1.d0,-1.d0,-1.d0, 1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','b1   ','b2   ','b3   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* S_4
*=====================================================================

      subroutine init_s4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=3,snsymel=4)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0,-1.d0, 1.d0,-1.d0, 
     *   2.d0, 0.d0,-2.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','sz4_1  ','cz2_1  ','sz4_3  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','b    ','e    '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_5
*=====================================================================

      subroutine init_c5(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=3,snsymel=5)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz5_1  ','cz5_2  ','cz5_3  ','cz5_4  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','e1   ','e2   '/
      
      schar(2,2)=2*cos(2*pi/5)
      schar(3,2)=2*cos(4*pi/5)
      schar(4,2)=schar(3,2)
      schar(5,2)=schar(2,2)
      schar(2,3)=schar(3,2)
      schar(3,3)=schar(2,2)
      schar(4,3)=schar(2,2)
      schar(5,3)=schar(3,2)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_6h
*=====================================================================

      subroutine init_c6h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=8,snsymel=12)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0,
     * 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0,
     * 2.d0, 1.d0,-1.d0,-2.d0,-1.d0, 1.d0,
     * 2.d0, 1.d0,-1.d0,-2.d0,-1.d0, 1.d0,
     * 2.d0,-1.d0,-1.d0, 2.d0,-1.d0,-1.d0,
     * 2.d0,-1.d0,-1.d0, 2.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0,
     *-1.d0, 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,
     * 2.d0, 1.d0,-1.d0,-2.d0,-1.d0, 1.d0,
     *-2.d0,-1.d0, 1.d0, 2.d0, 1.d0,-1.d0,
     * 2.d0,-1.d0,-1.d0, 2.d0,-1.d0,-1.d0,
     *-2.d0, 1.d0, 1.d0,-2.d0, 1.d0, 1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz6_1  ','cz3_1  ','cz2_1  ',
     * 'cz3_2  ','cz6_5  ','sz2_1  ','sz3_2  ',
     * 'sz6_5  ','sh     ','sz6_1  ','sz3_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','bg   ','e1g  ','e2g  ',
     * 'au   ','bu   ','e1u  ','e2u  '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_5h
*=====================================================================

      subroutine init_c5h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=10)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz5_1  ','cz5_2  ','cz5_3  ',
     * 'cz5_4  ','sh     ','sz5_1  ','sz5_7  ',
     * 'sz5_3  ','sz5_9  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ai   ','e1i  ','e2i  ','aii  ',
     * 'e1ii ','e1ii '/

      schar(2,2)=2.0d0*cos(2.0d0*pi/5.0d0)
      schar(3,2)=2.0d0*cos(4.0d0*pi/5.0d0)
      schar(4,2)=schar(3,2)
      schar(5,2)=schar(2,2)
      schar(7,2)=schar(2,2)
      schar(8,2)=schar(3,2)
      schar(9,2)=schar(3,2)
      schar(10,2)=schar(2,2)
      schar(2,3)=schar(3,2)
      schar(3,3)=schar(2,2)
      schar(4,3)=schar(2,2)
      schar(5,3)=schar(3,2)
      schar(7,3)=schar(3,2)
      schar(8,3)=schar(2,2)
      schar(9,3)=schar(2,2)
      schar(10,3)=schar(3,2)
      schar(2,5)=schar(2,2)
      schar(3,5)=schar(3,2)
      schar(4,5)=schar(3,2)
      schar(5,5)=schar(2,2)
      schar(7,5)=-schar(2,2)
      schar(8,5)=-schar(3,2)
      schar(9,5)=-schar(3,2)
      schar(10,5)=-schar(2,2)
      schar(2,6)=schar(3,2)
      schar(3,6)=schar(2,2)
      schar(4,6)=schar(2,2)
      schar(5,6)=schar(3,2)
      schar(7,6)=-schar(3,2)
      schar(8,6)=-schar(2,2)
      schar(9,6)=-schar(2,2)
      schar(10,6)=-schar(3,2)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_4h
*=====================================================================

      subroutine init_c4h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0,
     *   2.d0, 0.d0,-2.d0, 0.d0, 2.d0, 0.d0,-2.d0, 0.d0,
     *   1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *   1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0,-1.d0, 1.d0,
     *   2.d0, 0.d0,-2.d0, 0.d0,-2.d0, 0.d0, 2.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz4_1  ','cz2_1  ','cz4_3  ',
     * 'sz2_1  ','sz4_3  ','sh     ','sz4_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','bg   ','eg   ','au   ',
     * 'bu   ','eu   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_3h
*=====================================================================

      subroutine init_c3h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=6)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   2.d0,-1.d0,-1.d0, 2.d0,-1.d0,-1.d0,
     *   1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *   2.d0,-1.d0,-1.d0,-2.d0, 1.d0, 1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz3_1  ','cz3_2  ','sh     ',
     * 'sz3_1  ','sz3_2  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ai   ','ei   ','aii  ','eii  '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_2h
*=====================================================================

      subroutine init_c2h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=4)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0,
     *   1.d0,-1.d0, 1.d0,-1.d0,
     *   1.d0, 1.d0,-1.d0,-1.d0,
     *   1.d0,-1.d0,-1.d0, 1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','sz2_1  ','sh     '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','bg   ','au   ','bu   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_8
*=====================================================================

      subroutine init_c8(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *   2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *   2.d0, 0.d0,-2.d0, 2.d0,-2.d0, 0.d0, 0.d0, 0.d0,
     *   2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

C Kontrollieren ...
      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz8_1  ','cz4_1  ','cz2_1  ',
     * 'cz4_3  ','cz8_3  ','cz8_5  ','cz8_7  '/
C Kontrollieren ...

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','b    ','e1   ','e2   ','e3   '/

      schar(2,3)=2.0d0*cos(2.0d0*pi/8.0d0)
      schar(6,3)=-schar(2,3)
      schar(7,3)=-schar(2,3)
      schar(8,3)=schar(2,3)
      schar(2,5)=-schar(2,3)
      schar(6,5)=schar(2,3)
      schar(7,5)=schar(2,3)
      schar(8,5)=-schar(2,3)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_7
*=====================================================================

      subroutine init_c7(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=7)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz7_1  ','cz7_2  ','cz7_3  ',
     * 'cz7_4  ','cz7_5  ','cz7_6  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','e1   ','e2   ','e3   '/

      schar(2,2)=2.0d0*cos(2.0d0*pi/7.0d0)
      schar(3,2)=2.0d0*cos(4.0d0*pi/7.0d0)
      schar(4,2)=2.0d0*cos(6.0d0*pi/7.0d0)
      schar(5,2)=schar(4,2)
      schar(6,2)=schar(3,2)
      schar(7,2)=schar(2,2)
      schar(3,2)=schar(3,2)
     
      schar(2,3)=schar(3,2)
      schar(3,3)=schar(4,2)
      schar(4,3)=schar(2,2)
      schar(5,3)=schar(2,2)
      schar(6,3)=schar(4,2)
      schar(7,3)=schar(3,2)
     
      schar(2,4)=schar(4,2)
      schar(3,4)=schar(2,2)
      schar(4,4)=schar(3,2)
      schar(5,4)=schar(3,2)
      schar(6,4)=schar(2,2)
      schar(7,4)=schar(4,2)

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_6
*=====================================================================

      subroutine init_c6(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=6)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0,-1.d0, 1.d0,-1.d0, 1.d0,-1.d0, 
     *   2.d0, 1.d0,-1.d0,-2.d0,-1.d0, 1.d0, 
     *   2.d0,-1.d0,-1.d0, 2.d0,-1.d0,-1.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz6_1  ','cz3_1  ','cz2_1  ',
     * 'cz3_2  ','cz6_5  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','b    ','e1   ','e2   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_4
*=====================================================================

      subroutine init_c4(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=3,snsymel=4)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0,-1.d0, 1.d0,-1.d0, 
     *   2.d0, 0.d0,-2.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz4_1  ','cz2_1  ','cz4_3  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','b    ','e    '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_6v
*=====================================================================

      subroutine init_c6v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=12)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0, 1.d0, 1.d0,-1.d0,-1.d0,-2.d0,
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0,-1.d0,-1.d0,-1.d0,-1.d0, 2.d0, 
     * 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz6_1  ','cz6_5  ','cz3_1  ','cz3_2  ',
     * 'cz2_1  ','sv6_0  ','sv6_1  ','sv6_2  ','sd6_0  ',
     * 'sd6_1  ','sd6_2  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ','b2   ','e1   ','e2   '/

      do i=1,nirrep
        schar(3,i)=schar(2,i)
        schar(5,i)=schar(4,i)
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_5v
*=====================================================================

      subroutine init_c5v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=4,snsymel=10)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *   1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *   2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz5_1  ','cz5_4  ','cz5_2  ','cz5_3  ',
     * 'sv5_0  ','sv5_1  ','sv5_2  ','sv5_3  ','sv5_4  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','e1   ','e2   '/

      schar(2,3)=2.d0*cos(2.d0*pi/5.d0)
      schar(2,4)=2.d0*cos(4.d0*pi/5.d0)
      schar(4,3)=schar(2,4)
      schar(4,4)=schar(2,3)
      do i=1,nirrep
        schar(3,i)=schar(2,i)
        schar(5,i)=schar(4,i)
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* C_4v
*=====================================================================

      subroutine init_c4v(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=8)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep)
     *  /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 
     *   1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 
     *   1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 
     *   1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 
     *   2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz4_1  ','cz4_3  ','cz2_1  ','sv4_0  ','sv4_1  ',
     * 'sd4_0  ','sd4_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','b1   ','b2   ','e    '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_4h
*=====================================================================

      subroutine init_d4h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=10,snsymel=16)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep) 
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,
     * 2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,
     *-1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0,
     * 1.d0,-1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,
     *-1.d0, 1.d0, 1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0,
     * 2.d0, 0.d0, 0.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 0.d0, 0.d0, 2.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz4_1  ','cz4_3  ','cz2_1  ','cx4_0  ','cx4_2  ',
     * 'cx4_1  ','cx4_3  ','sz2_1  ','sz4_1  ','sz4_3  ','sh     ',
     * 'sv4_0  ','sv4_1  ','sd4_0  ','sd4_1  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1g  ','a2g  ','b1g  ','b2g  ','eg  ',
     * 'a1u  ','a2u  ','b1u  ','b2u  ','eu  '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_3h
*=====================================================================

      subroutine init_d3h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=12)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep) 
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,
     * 2.d0,-1.d0,-1.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 1.d0, 1.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz3_1  ','cz3_2  ','cx3_0  ','cx3_1  ','cx3_2  ',
     * 'sh     ','sz3_1  ','sz3_2  ','sv3_0  ','sv3_1  ','sv3_2  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1i  ','a2i  ','ei   ','a1ii ','a2ii ','eii  '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_5h
*=====================================================================

      subroutine init_d5h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=8,snsymel=20)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,snsymel),j=1,snirrep) 
     */1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     *-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     * 2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz5_1  ','cz5_4  ','cz5_2  ','cz5_3  ','cx5_0  ',
     * 'cx5_1  ','cx5_2  ','cx5_3  ','cx5_4  ','sh     ','sz5_1  ',
     * 'sz5_4  ','sz5_3  ','sz5_2  ','sv5_0  ','sv5_1  ','sv5_2  ',
     * 'sv5_3  ','sv5_4  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1i  ','a2i  ','e1i  ','e2i  ','a1ii ','a2ii ',
     * 'e1ii ','e2ii '/
      
      schar(2,3)=2.0d0*cos(2.0d0*pi/5.0d0)
      schar(2,4)=2.0d0*cos(4.0d0*pi/5.0d0)
      schar(2,7)=schar(2,3)
      schar(2,8)=schar(2,4)
      schar(4,3)=schar(2,4)
      schar(4,4)=schar(2,3)
      schar(4,7)=schar(4,3)
      schar(4,8)=schar(4,4)
      schar(12,3)=schar(2,3)
      schar(12,4)=schar(2,4)
      schar(12,7)=-schar(2,3)
      schar(12,8)=-schar(2,4)
      schar(14,3)=schar(4,3)
      schar(14,4)=schar(4,4)
      schar(14,7)=-schar(4,3)
      schar(14,8)=-schar(4,4)
      do i=1,nirrep
        schar(3,i)=schar(2,i)
        schar(5,i)=schar(4,i)
        schar(13,i)=schar(12,i)
        schar(15,i)=schar(14,i) 
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* D_6h
*=====================================================================

      subroutine init_d6h(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=12,snsymel=24)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data ((schar(i,j),i=1,24),j=1,12) 
     * /1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *  1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *  1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     * -1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *  1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0,-1.d0,
     * -1.d0, 1.d0, 1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *  1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0,
     * -1.d0,-1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     * -1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,
     * -1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 2.d0, 1.d0, 1.d0,-1.d0,
     * -1.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 2.d0, 1.d0,
     *  1.d0,-1.d0,-1.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *  2.d0,-1.d0,-1.d0,-1.d0,-1.d0, 2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *  0.d0, 0.d0, 2.d0,-1.d0,-1.d0,-1.d0,-1.d0, 2.d0, 0.d0, 0.d0,
     *  0.d0, 0.d0, 0.d0, 0.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *  1.d0, 1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * -1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0,
     *  1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0,
     * -1.d0,-1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0,
     *  1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0, 1.d0, 1.d0,
     *  1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0,
     * -1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0, 1.d0,
     *  1.d0,-1.d0,-1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0,-1.d0, 1.d0,
     *  1.d0,-1.d0,-1.d0, 1.d0, 1.d0, 1.d0, 1.d0,-1.d0,-1.d0,-1.d0,
     *  2.d0, 1.d0, 1.d0,-1.d0,-1.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     *  0.d0, 0.d0,-2.d0,-1.d0,-1.d0, 1.d0, 1.d0, 2.d0, 0.d0, 0.d0,
     *  0.d0, 0.d0, 0.d0, 0.d0, 2.d0,-1.d0,-1.d0,-1.d0,-1.d0, 2.d0,
     *  0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,-2.d0, 1.d0, 1.d0, 1.d0,
     *  1.d0,-2.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0/
      data (ssymel(i),i=1,24) / 
     * 'cz1_1  ','cz6_1  ','cz6_5  ','cz3_1  ','cz3_2  ','cz2_1  ',
     * 'cx6_0  ','cx6_2  ','cx6_4  ','cx6_1  ','cx6_3  ','cx6_5  ',
     * 'sz2_1  ','sz3_1  ','sz3_2  ','sz6_1  ','sz6_5  ','sh     ',
     * 'sd6_0  ','sd6_1  ','sd6_2  ','sv6_0  ','sv6_1  ','sv6_2  '/

      data (sirrep(i),i=1,12) / 
     * 'a1g  ','a2g  ','b1g  ','b2g  ','e1g  ','e2g  ',
     * 'a1u  ','a2u  ','b1u  ','b2u  ','e1u  ','e2u  '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* Td
*=====================================================================

      subroutine init_td(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=24)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
 
      data (schar(1,j),j=1,5) / 1.d0, 1.d0, 2.d0, 3.d0, 3.d0 /
      data (schar(2,j),j=1,5) / 1.d0, 1.d0, 2.d0,-1.d0,-1.d0 /
      data (schar(5,j),j=1,5) / 1.d0, 1.d0,-1.d0, 0.d0, 0.d0 /
      data (schar(13,j),j=1,5) / 1.d0,-1.d0, 0.d0, 1.d0,-1.d0 /
      data (schar(19,j),j=1,5) / 1.d0,-1.d0, 0.d0,-1.d0, 1.d0 / 

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  ',
     * 'o1301  ','o1302  ','o1303  ','o1304  ',
     * 'o2301  ','o2302  ','o2303  ','o2304  ',
     * 'p1401  ','p1402  ','p1403  ','p3401  ',
     * 'p3402  ','p3403  ','p1101  ','p1102  ',
     * 'p1103  ','p1104  ','p1105  ','p1106  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','e    ',
     * 't1   ','t2   '/

      do j=1,nirrep
        schar(3,j)=schar(2,j)
        schar(4,j)=schar(2,j)
        do i=6,12
           schar(i,j)=schar(5,j)
        end do
        do i=14,18
           schar(i,j)=schar(13,j)
        end do
        do i=20,24
           schar(i,j)=schar(19,j)
        end do
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end
*=====================================================================
* T
*=====================================================================

      subroutine init_t(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=3,snsymel=12)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(1,j),j=1,3) / 1.d0, 2.d0, 3.d0 /
      data (schar(2,j),j=1,3) / 1.d0, 2.d0,-1.d0 /
      data (schar(5,j),j=1,3) / 1.d0,-1.d0, 0.d0 /
      data (schar(9,j),j=1,3) / 1.d0,-1.d0, 0.d0 /

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  ',
     * 'o1301  ','o2302  ','o1303  ','o2304  ',
     * 'o2301  ','o1302  ','o2303  ','o1304  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','e    ','t    '/

      do j=1,nirrep
        schar(3,j)=schar(2,j)
        schar(4,j)=schar(2,j)
        do i=6,8
           schar(i,j)=schar(5,j)
        end do
        do i=10,12
           schar(i,j)=schar(9,j)
        end do
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* Th
*=====================================================================

      subroutine init_th(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=6,snsymel=24)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(1,j),j=1,6) / 1.d0, 2.d0, 3.d0, 1.d0, 2.d0, 3.d0 /
      data (schar(2,j),j=1,6) / 1.d0, 2.d0,-1.d0, 1.d0, 2.d0,-1.d0 /
      data (schar(5,j),j=1,6) / 1.d0,-1.d0, 0.d0, 1.d0,-1.d0, 0.d0 /
      data (schar(9,j),j=1,6) / 1.d0,-1.d0, 0.d0, 1.d0,-1.d0, 0.d0 /

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  ',
     * 'o1301  ','o1302  ','o1303  ','o1304  ',
     * 'o2301  ','o2302  ','o2303  ','o2304  ',
     * 'sz2_1  ','sh     ','sv2_0  ','sd2_0  ',
     * 'p1601  ','p1602  ','p1603  ','p1604  ',
     * 'p3601  ','p3602  ','p3603  ','p3604  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','eg   ','tg   ',
     * 'au   ','eu   ','tu   '/

      do j=1,nirrep
        schar(3,j)=schar(2,j)
        schar(4,j)=schar(2,j)
        do i=6,8
           schar(i,j)=schar(5,j)
        end do
        do i=10,12
           schar(i,j)=schar(9,j)
        end do
      end do
      do i=1,12
        do j=1,3
          schar(i+12,j)=schar(i,j)
          schar(i+12,j+3)=-schar(i,j)
        end do
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* Oh
*=====================================================================

      subroutine init_oh(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=10,snsymel=48)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(1,j),j=1,5) / 1.d0, 1.d0, 2.d0, 3.d0, 3.d0 /
      data (schar(2,j),j=1,5) / 1.d0, 1.d0, 2.d0,-1.d0,-1.d0 /
      data (schar(5,j),j=1,5) / 1.d0, 1.d0,-1.d0, 0.d0, 0.d0 /
      data (schar(13,j),j=1,5)/ 1.d0,-1.d0, 0.d0, 1.d0,-1.d0 /
      data (schar(19,j),j=1,5)/ 1.d0,-1.d0, 0.d0,-1.d0, 1.d0 /

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  ',
     * 'o1301  ','o1302  ','o1303  ','o1304  ',
     * 'o2301  ','o2302  ','o2303  ','o2304  ',
     * 'o1401  ','o1402  ','o1403  ','o3401  ',
     * 'o3402  ','o3403  ','o1201  ','o1202  ',
     * 'o1203  ','o1204  ','o1205  ','o1206  ',
     * 'sz2_1  ','sh     ','sv2_0  ','sd2_0  ',
     * 'p1601  ','p1602  ','p1603  ','p1604  ',
     * 'p5601  ','p5602  ','p5603  ','p5604  ',
     * 'p1401  ','p1402  ','p1403  ','p3401  ',
     * 'p3402  ','p3403  ','p1101  ','p1102  ',
     * 'p1103  ','p1104  ','p1105  ','p1106  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1g  ','a2g  ','eg   ',
     * 't1g  ','t2g  ',
     * 'a1u  ','a2u  ','eu   ',
     * 't1u  ','t2u  '/

      do j=1,nirrep
        schar(3,j)=schar(2,j)
        schar(4,j)=schar(2,j)
        do i=6,12
           schar(i,j)=schar(5,j)
        end do
        do i=14,18
           schar(i,j)=schar(13,j)
        end do
        do i=20,24
           schar(i,j)=schar(19,j)
        end do
      end do

      do i=1,24
        do j=1,5
          schar(i+24,j)=schar(i,j)
          schar(i,j+5)=schar(i,j)
          schar(i+24,j+5)=-schar(i,j)
        end do
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* O
*=====================================================================

      subroutine init_o(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=24)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
  
      data (schar(1,j),j=1,5) / 1.d0, 1.d0, 2.d0, 3.d0, 3.d0 /
      data (schar(2,j),j=1,5) / 1.d0, 1.d0, 2.d0,-1.d0,-1.d0 /
      data (schar(5,j),j=1,5) / 1.d0, 1.d0,-1.d0, 0.d0, 0.d0 /
      data (schar(13,j),j=1,5)/ 1.d0,-1.d0, 0.d0, 1.d0,-1.d0 /
      data (schar(19,j),j=1,5)/ 1.d0,-1.d0, 0.d0,-1.d0, 1.d0 /

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ','cz2_1  ','cx2_0  ','cx2_1  ',
     * 'o1301  ','o1302  ','o1303  ','o1304  ',
     * 'o2301  ','o2302  ','o2303  ','o2304  ',
     * 'o1401  ','o1402  ','o1403  ','o3401  ',
     * 'o3402  ','o3403  ','o1201  ','o1202  ',
     * 'o1203  ','o1204  ','o1205  ','o1206  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a1   ','a2   ','e    ',
     * 't1   ','t2   '/

      do j=1,nirrep
        schar(3,j)=schar(2,j)
        schar(4,j)=schar(2,j)
        do i=6,12
           schar(i,j)=schar(5,j)
        end do
        do i=14,18
           schar(i,j)=schar(13,j)
        end do
        do i=20,24
           schar(i,j)=schar(19,j)
        end do
      end do

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* Ih
*=====================================================================

      subroutine init_ih(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=10,snsymel=120)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep),c5(2)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
      c5(1)=2.d0*cos(pi/5.d0)
      c5(2)=2.d0*cos(pi/5.d0*3.d0)

      data (schar(1,j),j=1,5)  /1.d0, 3.d0, 3.d0, 4.d0, 5.d0/
      schar(2,1) = 1.d0
      schar(2,2) = c5(1)
      schar(2,3) = c5(2)
      data (schar(2,j),j=4,5)  /-1.d0,0.d0/
      schar(14,1)=1.d0
      schar(14,2)=c5(2)
      schar(14,3)=c5(1)
      data (schar(14,j),j=4,5) /-1.d0,0.d0/
      data (schar(26,j),j=1,5) /1.d0,0.d0,0.d0,1.d0,-1.d0/
      data (schar(46,j),j=1,5) /1.d0,-1.d0,-1.d0,0.d0,1.d0/
C------------------------------------------------------------------
C copy characters for symmetry elements belonging to the same class
C------------------------------------------------------------------
      do j=1,nirrep
        do i=3,13
           schar(i,j)=schar(2,j)
           schar(i+12,j)=schar(14,j)
        end do
        do i=27,45
           schar(i,j)=schar(26,j)
        end do
        do i=47,60
           schar(i,j)=schar(46,j)
        end do
      end do

C-----------------------------------------------------------------
C copy characters for additional symmetry elements and
C analogous representations
C-----------------------------------------------------------------

      do i=1,60
        do j=6,10
          schar(i+60,j-5)=schar(i,j-5)
          schar(i,j)=schar(i,j-5)
          schar(i+60,j)=-schar(i,j-5)
        end do
      end do

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ',
     * 'i1501  ','i1502  ','i1503  ','i1504  ','i1505  ','i1506  ',
     * 'i4501  ','i4502  ','i4503  ','i4504  ','i4505  ','i4506  ',
     * 'i2501  ','i2502  ','i2503  ','i2504  ','i2505  ','i2506  ',
     * 'i3501  ','i3502  ','i3503  ','i3504  ','i3505  ','i3506  ',
     * 'i1301  ','i1302  ','i1303  ','i1304  ','i1305  ','i1306  ',
     * 'i1307  ','i1308  ','i1309  ','i1310  ',
     * 'i2301  ','i2302  ','i2303  ','i2304  ','i2305  ','i2306  ',
     * 'i2307  ','i2308  ','i2309  ','i2310  ',
     * 'i1201  ','i1202  ','i1203  ','i1204  ','i1205  ','i1206  ',
     * 'i1207  ','i1208  ','i1209  ','i1210  ','i1211  ','i1212  ',
     * 'i1213  ','i1214  ','i1215  ',
     * 'sz2_1  ',
     * 'j3001  ','j3002  ','j3003  ','j3004  ','j3005  ','j3006  ',
     * 'j7001  ','j7002  ','j7003  ','j7004  ','j7005  ','j7006  ',
     * 'j1001  ','j1002  ','j1003  ','j1004  ','j1005  ','j1006  ',
     * 'j9001  ','j9002  ','j9003  ','j9004  ','j9005  ','j9006  ',
     * 'j1601  ','j1602  ','j1603  ','j1604  ','j1605  ','j1606  ',
     * 'j1607  ','j1608  ','j1609  ','j1610  ',
     * 'j5601  ','j5602  ','j5603  ','j5604  ','j5605  ','j5606  ',
     * 'j5607  ','j5608  ','j5609  ','j5610  ',
     * 'j1101  ','j1102  ','j1103  ','j1104  ','j1105  ','j1106  ',
     * 'j1107  ','j1108  ','j1109  ','j1110  ','j1111  ','j1112  ',
     * 'j1113  ','j1114  ','j1115  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'ag   ','t1g  ','t2g  ','fg   ','hg   ',
     * 'au   ','t1u  ','t2u  ','fu   ','hu   '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

*=====================================================================
* I
*=====================================================================

      subroutine init_i(nirrep,irrep,symel,char,nsymel,
     * mxnsymel,mxirrep)
      implicit none
#include "fconstants.h"
      integer nirrep,nsymel,mxnsymel,mxirrep,i,snirrep,snsymel,j
      parameter(snirrep=5,snsymel=60)
      real*8 char(mxnsymel,mxirrep),schar(snsymel,snirrep),c5(2)
      character*7 symel(mxnsymel),ssymel(snsymel)
      character*5 irrep(mxirrep),sirrep(snirrep)
      nirrep=snirrep
      nsymel=snsymel
      c5(1)=2.d0*cos(pi/5.d0)
      c5(2)=2.d0*cos(pi/5.d0*3.d0)

      data (schar(1,j),j=1,5)  /1.d0, 3.d0, 3.d0, 4.d0, 5.d0/
      schar(2,1) = 1.d0
      schar(2,2) = c5(1)
      schar(2,3) = c5(2)
      data (schar(2,j),j=4,5)  /-1.d0,0.d0/
      schar(14,1)=1.d0
      schar(14,2)=c5(2)
      schar(14,3)=c5(1)
      data (schar(14,j),j=4,5) /-1.d0,0.d0/
      data (schar(26,j),j=1,5) /1.d0,0.d0,0.d0,1.d0,-1.d0/
      data (schar(46,j),j=1,5) /1.d0,-1.d0,-1.d0,0.d0,1.d0/
C------------------------------------------------------------------
C copy characters for symmetry elements belonging to the same class
C------------------------------------------------------------------
      do j=1,nirrep
        do i=3,13
           schar(i,j)=schar(2,j)
           schar(i+12,j)=schar(14,j)
        end do
        do i=27,45
           schar(i,j)=schar(26,j)
        end do
        do i=47,60
           schar(i,j)=schar(46,j)
        end do
      end do

      data (ssymel(i),i=1,snsymel) / 
     * 'cz1_1  ',
     * 'i1501  ','i1502  ','i1503  ','i1504  ','i1505  ','i1506  ',
     * 'i4501  ','i4502  ','i4503  ','i4504  ','i4505  ','i4506  ',
     * 'i2501  ','i2502  ','i2503  ','i2504  ','i2505  ','i2506  ',
     * 'i3501  ','i3502  ','i3503  ','i3504  ','i3505  ','i3506  ',
     * 'i1301  ','i1302  ','i1303  ','i1304  ','i1305  ','i1306  ',
     * 'i1307  ','i1308  ','i1309  ','i1310  ',
     * 'i2301  ','i2302  ','i2303  ','i2304  ','i2305  ','i2306  ',
     * 'i2307  ','i2308  ','i2309  ','i2310  ',
     * 'i1201  ','i1202  ','i1203  ','i1204  ','i1205  ','i1206  ',
     * 'i1207  ','i1208  ','i1209  ','i1210  ','i1211  ','i1212  ',
     * 'i1213  ','i1214  ','i1215  '/

      data (sirrep(i),i=1,snirrep) / 
     * 'a    ','t1   ','t2   ','f    ','h    '/

      do i=1,nirrep
        irrep(i)=sirrep(i)
        do j=1,nsymel
          char(j,i)=schar(j,i)
        end do
      end do
      do i=1,nsymel
        symel(i)=ssymel(i)
      end do
      end

