      subroutine getfile(name,mynode,pnode,info)

c     ====================================================
c     purpose: copy files from master to slave using
c              scp/cp
c
c     variables used from common blocks:
c     - tempdir,mydir,lt,lm,mytid            
c
c     - replaced mydir by workdir (J. Neugebauer, 09/2005)
c     - changed again by C. Herrmann
c     ====================================================

      implicit none
#include "param.h"
      character*(*) name,mynode,pnode
      character*255 b1,b2
      integer info,l,irc
      integer xeq

c     --------------------------------------
c     check if master and slave are the same
c     --------------------------------------
      call clean(b2)
      if (mynode.eq.pnode) then

c       ------------
c       copy locally
c       ------------
        b2='cp '
        l=3

      else

c       ----------------
c       copy from master
c       ----------------
        b2='scp '//masterid(1:li)//':'
        call llen(b2,l)

      end if

c     --------------------
c     write command string
c     --------------------
      b1=b2(1:l)//mydir(1:lm)//'/'//name//' '//tempdir(1:lt)
CCH      b1=b2(1:l)//workdir(1:lworkdir)//'/'//name//' '//tempdir(1:lt)
      call llen(b1,l)

c     ---------------
c     execute command
c     ---------------
      irc=xeq(b1(1:l))

c     ----------------------------------------------------------
c     error handling: store status value as last digit in <info>
c     ----------------------------------------------------------
      if (irc.GT.0) irc=2
      if (irc.LT.0) irc=3
      if (irc.EQ.0) irc=1
      info=10*info+irc

      return
      end
