      subroutine getortspace(rspace,dimio,dim,work,trarot)
      implicit none
      integer dim,dimio,i,j,count,iin,iout
      real*8 rspace(dim,dim),work(dim,dim),thres,ovl,trarot(dim,6)
      parameter(thres=1.0d-6)
      logical para
      
      iin = dimio
      if(dimio.eq.dim) then
        dimio = 0
        do i = 1, dim
          do j = 1, dim
            rspace(i,j) = 0.0d0
          end do
        end do
        return
      end if

*------------------
* initialize
*------------------

      do i = 1, dim
        do j = 1, dim
          work(i,j) = 0.0d0
        end do
      end do

*------------------
* set up full space
*------------------

      do i = 1, dim
        work(i,i) = 1.0d0
      end do
      dimio = dim

*-----------------------------------
* orthogonalize full space to rspace
*-----------------------------------

      do j = 1, dim
        do i = 1, iin
          call gramschmidt(rspace(1,i),work(1,j),dim,para,ovl,thres)
        end do
      end do
      call skipvec(work,dim,dim,count,1.0d-2)
      dimio = dim - count

*------------------------------
* orthogonalize to trarot modes
*------------------------------

      do j = 1, 6
        do i = 1, dimio
          call gramschmidt(trarot(1,j),work(1,i),dim,para,ovl,thres)
        end do
      end do
      call skipvec(work,dim,dimio,count,1.0d-2)
      dimio = dimio - count

*--------------------------------------------------
* make sure that 'work' contains an orthonormal set
*--------------------------------------------------

      do j = 1, dimio
        do i = 1, j-1
          call gramschmidt(work(1,i),work(1,j),dim,para,ovl,thres)
        end do
      end do
      call skipvec(work,dim,dimio,count,1.0d-2)
      dimio = dimio - count

*-----------------------------
* copy vectors to rspace array
*-----------------------------

      do i = 1, dimio
        do j = 1, dim
          rspace(j,i) = work(j,i)
        end do
      end do

*---------------------------
* check no. of basis vectors
*---------------------------

      iout = dimio
      write(*,*) '** getortspace: no. of input vectors     : ',iin
      write(*,*) '** getortspace: no. of output vectors    : ',iout
      if(iout.ne.(dim-iin-6)) then
        write(*,*) '** something is wrong: total dimension is: ',dim
      end if

      end 
