#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      subroutine inicomm(mytid,tid0,ipe)

* ---------------------------------------------
* initialize communications system
* returns own TID in mytid, parent TID in tid0
* ipe is zero if this is the master process
*
* comments added by J. Neugebauer, 2007
* ---------------------------------------------

      use MachineModule

#include "defs.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

      integer mytid,tid0,ipe
* local
      integer info,read

#ifdef AKIRA_MPI
      CALL MPI_INIT(info)
      CALL mpierr('MPI_INIT','inicomm',info)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ipe,info)
      CALL mpierr('MPI_COMM_RANK','inicomm',info)
      mytid=ipe
      tid0=0
#endif

#ifdef DEBUG
      WRITE (idbg,*) 'MPI initialized - ipe=',ipe
      CALL flush(idbg)
#endif

#ifdef AKIRA_PVM

* ------------------------------------------------
* PVM part; may me tuned by means of file PVM_INIT
* 
* note: In first call to pvmfmytid, mytid will be
*       < 0 if no pvmd is running.
*       In that case, call pvmfstartpvmd and 
*       pvmfmytid again to see if start of pvmd
*       was successful
* ------------------------------------------------

      read=0
      call pvmfmytid ( mytid )
      write (idbg,*) 'inicomm | mytid = ',mytid
      call flush(idbg)

      if (mytid.lt.0) then
        write (idbg,*) 'inicomm | pvmd not running => calling startpvmd'
        call pvmfstartpvmd('PVM_INIT',1,info)
        if (info.ne.0) then
          call pvmfperror('trying to start pvmd')
          call errex('error trying to start pvmd')
        endif
      else
        write (idbg,*) 'inicomm | pvmd already running'
      endif

      call pvmfmytid ( mytid )
      write (idbg,*) 'inicomm | second check: mytid = ',mytid
      if(mytid.lt.0) then
        write (*,*) 'pvmd not running - cannot start it'
        call errex('cannot start pvm')
      endif

      call pvmfparent( tid0  )
      ipe=mytid
      if (tid0 .EQ. PVMNOPARENT) ipe=0
#endif

      call init_machlist

      return
      end
