      subroutine jacobid(rvec,vvec,xmat,epsilon,nvar,vtemp,
     * printall)
*-------------------------------------------------------------
* calculate the expression
*
* epsilon = (v(i)*X^-1 r(i)) / (v(i)*X^-1 v(i))
*
* with an approximation X for (H - lambda)
*-------------------------------------------------------------

#include "defs.h"

      integer nvar
      real*8 rvec(nvar),vvec(nvar),xmat(nvar,nvar),epsilon
      real*8 rnom(1),rdnom(1),vtemp(nvar),thres
      parameter(thres=1.0d-5)
      logical printall
      
C      if(printall) then
C        call printdmat(vvec,nvar,1,'v(i)','f22.11',idbg)
C        call printdmat(rvec,nvar,1,'r(i)','f22.11',idbg)
C        call printdmat(xmat,nvar,nvar,'xmat','f22.11',idbg)
C      end if

*----------------------------------------------------------------
* T = v(i)*X^-1
*----------------------------------------------------------------

      call dgemm('N','N',1,nvar,nvar,1.0D0,vvec,1,
     * xmat,nvar,0.d0,vtemp,1)
      if(printall) then
        call printdmat(vtemp,nvar,1,'v(i)*X^-1','f22.11',idbg)
      end if

*----------------------------------------------------------------
* rnom = T r(i)
*----------------------------------------------------------------

      call dgemm('N','N',1,1,nvar,1.0D0,vtemp,1,
     * rvec,nvar,0.d0,rnom,1)

*----------------------------------------------------------------
* rdnom = T v(i)
*----------------------------------------------------------------

      call dgemm('N','N',1,1,nvar,1.0D0,vtemp,1,
     * vvec,nvar,0.d0,rdnom,1)

      if(abs(rdnom(1)).lt.thres) then
        write(ftape,*) '** jacobid: vX^{-1}v = ',rdnom(1)
        write(ftape,*) '** Division by zero encountered'
        epsilon=0.0d0
      else
        epsilon=rnom(1)/rdnom(1)
      end if

      if(printall) then
        write(idbg,*) 'vX^{-1}r = ',rnom(1)
        write(idbg,*) 'vX^{-1}v = ',rdnom(1)
        write(idbg,*) 'epsilon  = ',epsilon
      end if

      return
      end
