#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      PROGRAM akira
* 
* data collector and evaluation program
*
* by J. Neugebauer, M. Reiher, University of Erlangen-Nuernberg, 2002
*
* f90 memory management by J. Neugebauer, 2007
*

#include "defs.h"
#include "param.h"

      integer ierr,ipe,t1,t2
      logical nodeav

#include "version.h"

      call secs(t1)
      iomeg=0
      inrec=0
      iin=0
      ierr=0
      iscfc=8
      naus=2
      pmch=0
      isuhf=0
      pvmmch=0

      call inicomm(mytid,tid0,ipe)           ! initialize communication
      if (ipe.eq.0) then                     ! th master process
        iosl=idbg
        call imaster                          ! initialize master
        call nodeini                          ! initialize slave processes
        call rdparm                           ! read input
#ifdef AKIRA_PVM
        call rduse(nodeav)                    ! read PVM configuration options
        if(.not.nodeav) call errex('no nodes present in USE_NODES')
#endif
       
        call basic_input                      ! initialize basic input parameters
        call master                           ! run master scheduler
        call shutdown                         ! shutdown virtual computer
*=============
* time control
*=============
        call secs(t2)
        call wtime(t2-t1,'in akira',jtape)
        call wtime(t2-t1,'in akira',ftape)
        close(ftape)
*=============
      else
        iosl=43
        call islave                          ! run slave process
      endif
      call termcomm                          ! terminate program
* program will not return
      stop 'miracle in main program'
      END
