      subroutine modcontrol(tmpcl,anffast,logcl,cstep,numderiv,mode,
     * rpaconv,disptype,proj,masstype,maxnbm,scfconv,dalmw,nbmo)
*
* modify akira_control, and, if present, Turbomole control file
*
* written by J. Neugebauer, Uni Erlangen, 2002
* modified by C. Herrmann, Uni Jena 02.05.2005
* ($scfinstab is not removed from control any more)
* modified by C. Herrmann, ETH Zurich 30.05.2007
*

      implicit none
      integer numderiv,lu,nrow,mxrow,masstype,i,mode,rpaconv,disptype
      integer maxnbm,dalmw,scfconv,nbmo
      parameter(mxrow=4000000)
      real*8 cstep
      logical tmpcl,logcl,anffast,proj
      character*132 buf,cbuf(mxrow)
      integer lcbuf(mxrow)
      lu=1
      call testfile('akira_control')
      nrow=0
      open(unit=lu,file='akira_control',err=999)
100   read (lu,'(A)',err=998,end=800) buf
101   if((index(buf,'$tempdirclean').ne.0).or.
     * (index(buf,'$logdirclean').ne.0).or.
     * (index(buf,'$dalmw').ne.0).or.
     * (index(buf,'$numderiv').ne.0).or.
     * (index(buf,'$disptype').ne.0).or.
     * (index(buf,'$masstype').ne.0).or.
     * (index(buf,'$anffast').ne.0).or.
     * (index(buf,'$anfmode').ne.0).or.
     * (index(buf,'$maxnbm').ne.0).or.
     * (index(buf,'$northo').ne.0).or.
     * (index(buf,'$cstep').ne.0).or. 
     * (index(buf,'$prtrarot').ne.0)) then
        goto 100
CCH      else if(index(buf,'$scfinstab').ne.0) then
CCH110     read(lu,'(A)',err=998,end=800) buf
CCH        if(index(buf,'$').eq.0) then
CCH          goto 110
CCH        else
CCH          goto 101
CCH        end if
      else if(index(buf,'$end').ne.0) then
        rewind(lu)
        do i=1,nrow
          write(lu,'(A)') cbuf(i)(1:lcbuf(i))
        end do
        if(dalmw.gt.0.and.mode.ge.20.and.mode.lt.30) 
     *   write(lu,'(A,i20)') '$dalmw ',dalmw
        write(lu,'(A,f14.8)') '$cstep ',cstep
        write(lu,'(A,i3)') '$numderiv ',numderiv
        write(lu,'(A,i3)') '$disptype',disptype
        write(lu,'(A,i3)') '$masstype',masstype
        write(lu,'(A,i5)') '$maxnbm',maxnbm
        write(lu,'(A,i5)') '$northo',nbmo
        if(tmpcl) write(lu,'(A)') '$tempdirclean'
        if(logcl) write(lu,'(A)') '$logdirclean'
        if(anffast) write(lu,'(A)') '$anffast'
        if(mode.ne.1) write(lu,'(A,i3)') '$anfmode ',mode
        if(proj) write(lu,'(A)') '$prtrarot'
        write(lu,'(A)') '$end'
        goto 800
      else
        nrow=nrow+1
        if(nrow.gt.mxrow) then
          write(*,*) '** modcontrol: too many rows in akira_control'
          stop
        end if
        cbuf(nrow)(1:132)=buf(1:132)
        call llen(cbuf(nrow),lcbuf(nrow))
      end if
      goto 100

800   close(lu)

      if(mode.lt.20) then
      call testfile('control')
      nrow=0
      open(unit=lu,file='control',err=997)
200   read (lu,'(A)',err=996,end=900) buf
201   if((index(buf,'$scfconv').ne.0).or.
     * (index(buf,'$rpaconv').ne.0)) then
        goto 200
      else if(index(buf,'$end').ne.0) then
        rewind(lu)
        do i=1,nrow
          write(lu,'(A)') cbuf(i)
        end do
        write(lu,'(A,i3)') '$scfconv ',scfconv
        if(mode.eq.2) write(lu,'(A,i3)') '$rpaconv ',rpaconv
        if(mode.eq.2) write(lu,'(A)') '$scfinstab polly'
        write(lu,'(A)') '$end'
        goto 900
      else
        nrow=nrow+1
        if(nrow.gt.mxrow) then
          write(*,*) '** modcontrol: too many rows in control'
          stop
        end if
        cbuf(nrow)(1:132)=buf(1:132)
      end if
      goto 200

900   close(lu)
      end if


      return

996   write(*,*) '** modcontrol: Error while reading control'
      close(lu)
      goto 1000
997   write(*,*) '** modcontrol: could not open control'
      close(lu)
998   write(*,*) '** modcontrol: Error while reading akira_control'
      close(lu)
      goto 1000
999   write(*,*) '** modcontrol: could not open akira_control'
      close(lu)
1000  return
      end

C=======================================================================
  
      subroutine rdefcontrol(tmpcl,anffast,logcl,cstep,numderiv,mode,
     * rpaconv,convcr)

*-------------------------------------------------------------
* read AKIRA keywords from akira_control file
*
* written by J. Neugebauer, Uni Erlangen, 2002
* modified by C. Herrmann, ETH Zurich, 05/30/07
*-------------------------------------------------------------

      implicit none
      integer numderiv,lui,mode,rpaconv,lst,ii
      real*8 cstep,convcr
      logical tmpcl,logcl,anffast,ex
      character*264 buf
      character*3 symtext
      lui=1
      rpaconv=5
      convcr=1.0d-10
      inquire(exist=ex,file='akira_control')
      if(ex) then
      open(unit=lui,file='akira_control',err=998)
100   read (lui,'(A)',end=800) buf
      if(index(buf,'$tempdirclean').ne.0) tmpcl=.true.
      if(index(buf,'$logdirclean').ne.0) logcl=.true.
      if(index(buf,'$anffast').ne.0) anffast=.true.
      if(index(buf,'$anfmode').ne.0) then
        ii=index(buf,'$anfmode')
        read(buf(ii+9:),*) mode
      end if
      if(index(buf,'$rpaconv').ne.0) then
        read(buf(9:),*) rpaconv
      end if
      if(index(buf,'$convcr').ne.0) then
        read(buf(8:),*) convcr
      end if
      if(index(buf,'$cstep').ne.0) read(buf(7:),*) cstep
      if(index(buf,'$numderiv').ne.0) read(buf(10:),*) numderiv
      if(index(buf,'$symmetry').ne.0) then
        call clean(symtext)
        read(buf(11:),*) symtext
        call upper(symtext)
        if(index(symtext,'C1').eq.0) then
          call slen(symtext,lst)
          write(buf,'(a)') 'CAUTION! Symmetry is '//symtext(1:lst)//
     *     '! This can only be used##if the calculation is restricted'//
     *     ' to an irreducible##representation which preserves this '//
     *     'symmetry'
          call llen(buf,lst)
          call serror('rdefcontrol',4,buf(1:lst),6)
        end if
      end if
       
      goto 100

800   close(lui)
      return
998   write(*,*) '** rdefcontrol: Error while reading akira_control'
      close(lui)
      end if
      end

C=======================================================================

      subroutine getpolfreq(cname,ipol,omeg,iomeg,mxomeg)

*-------------------------------------------------------------
* read number of polarizabilities, number of frequencies and
* frequencies for calculation of polarizabilities from control
*
* written by J. Neugebauer, Uni Erlangen, 2002
*-------------------------------------------------------------

      implicit none
      integer ipol,iomeg,mxomeg,lu,lcname,i,ldum,mxitem,ien,ist
      parameter(mxitem=12)
      character*(*) cname
      character*255 item(mxitem)
      character*255 b1
      real*8 omeg(mxomeg),getreal
      logical ex
      external getreal

      ipol=0
      iomeg=0
      do i=1,mxomeg
        omeg(i)=0.0d0
      end do
      lu=1
      call slen(cname,lcname)
      inquire(file=cname(1:lcname),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=cname)
100   read (lu,'(a)',end=999) b1
      if(index(b1,'$scfinstab').ne.0) then
        if(index(b1,'polly').ne.0) then
          ipol=1
        else if(index(b1,'dynpol').ne.0) then
          call split(b1,item,mxitem)
          do iomeg=3,mxitem
            IF (item(iomeg)(1:1).EQ.' ') goto 150
            ist=1
            omeg(iomeg-2)=getreal(item(iomeg),ist,ien)
          end do
          iomeg=mxitem+1
150       iomeg=iomeg-3
          if(iomeg.ne.0) goto 999
200       read (lu,'(a)',end=999) b1
          if(index(b1,'$').eq.0) then
            call split(b1,item,mxitem)
            do iomeg=1,mxitem-2
              IF (item(iomeg)(1:1).EQ.' ') GOTO 300
              ist=1
              omeg(iomeg)=getreal(item(iomeg),ist,ien)
            end do
            iomeg=mxitem-1
300         iomeg=iomeg-1
          end if
        end if
      end if
      goto 100
999   close(lu)
      if(iomeg.ne.0) ipol=iomeg
      end

C**********************************************************************

      subroutine wrnctm(fname,natoms,normm,maxnbm,text)
*
* write normal coordinates to akira_control file
*
* written by J. Neugebauer, Uni Erlangen, 2002
* modified by C. Herrmann, ETH Zurich, 05/30/2007
*
      implicit none
      integer lu,nrow,mxrow,i,natoms,maxnbm,lf,lt
      real*8 normm(3*natoms,maxnbm)
      parameter(mxrow=40000)
      character*132 buf,cbuf(mxrow)
      character*(*) fname,text
      lu=1
      call llen(text,lt)
      call llen(fname,lf)
CCH      call testfile(fname(1:lf))
      nrow=0
      write(41,*) '** wrnctm: writing modes to file: ',fname(1:lf)
      open(unit=lu,file=fname(1:lf),err=999)
100   read (lu,'(A)',err=998,end=800) buf
101   if((index(buf,text(1:lt)).ne.0)) then
110     read(lu,'(A)',err=998,end=800) buf
        if(index(buf,'$').eq.0) then
          goto 110
        else
          goto 101
        end if
      else if(index(buf,'$end').ne.0) then
        rewind(lu)
        do i=1,nrow
          write(lu,'(A)') cbuf(i)
        end do
        call wrnmodes(natoms,normm,maxnbm,text(1:lt),lu)
        write(lu,'(A)') '$end'
        goto 800
      else
        nrow=nrow+1
        if(nrow.gt.mxrow) then
          write(*,*) '** modcontrol: too many rows in control'
          stop
        end if
        cbuf(nrow)(1:132)=buf(1:132)
      end if
      goto 100

800   close(lu)
      return

998   write(*,*) '** wrnctm: Error while reading control'
      close(lu)
      goto 1000
999   write(*,*) '** wrnctm: could not open control'
      close(lu)
1000  return
      end

C**********************************************************************

      subroutine wrnmodes(natoms,normmod,maxnbm,text,ucf)
**
*     written by J. Neugebauer, Uni Erlangen, 2002
*     
*     write normal coordinates to unit <ucf>
**
#include "defs.h"
      character*(*) text
      character(len=255) form,buf
      integer natoms,i,j,ucf,kbuf,i2,i2end,nvar,nd,maxnbm
      integer kend,lt
      real*8 normmod(3*natoms,maxnbm)
      parameter(nd=5)
      nvar=3*natoms
      form='(5x,5f15.10)'
C      write(ucf,'(a)') '$vibrational basis modes'
      write(ucf,'(a)') text
      i2end=maxnbm/nd
      if(mod(maxnbm,nd).ne.0) i2end=i2end+1
      do i=1,nvar
        do i2=1,i2end
         kend=i2*nd
         if(i2.eq.i2end) kend=maxnbm
         kbuf=(i2-1)*nd+1
         write(ucf,form) (normmod(i,j),j=kbuf,kend)
        end do
      end do
      return
      end

C**********************************************************************

      subroutine rnscrfi
*
* rename scratch files in case of Turbomole MP2 calculations, e.g.,
* file=/scratch/halfint    -->     file=halfint
*
* (program is executed in /scratch anyway, but several jobs may be
* running on one node)
*
* written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer lu,nrow,mxrow,i,iscr,lbuf
      parameter(mxrow=40000)
      character*132 buf,cbuf(mxrow)
      lu=1
      call testfile('control')
      nrow=0
      open(unit=lu,file='control',err=999)
100   read (lu,'(A)',err=998,end=800) buf
      nrow=nrow+1
      iscr=index(buf,'file=/scratch/')
101   if(iscr.ne.0) then
        call clean(cbuf(nrow))
        call llen(buf,lbuf)
        cbuf(nrow)(1:iscr+4)=buf(1:iscr+4)
        cbuf(nrow)(iscr+5:iscr+5+(lbuf-iscr+14))=buf(iscr+14:lbuf)
      else if(index(buf,'$end').ne.0) then
        rewind(lu)
        do i=1,nrow-1
          write(lu,'(A)') cbuf(i)
        end do
        write(lu,'(A)') '$end'
        goto 800
      else
        if(nrow.gt.mxrow) then
          write(*,*) '** rnscrfi: too many rows in control'
          stop
        end if
        cbuf(nrow)(1:132)=buf(1:132)
      end if
      goto 100

800   close(lu)
      return

998   write(*,*) '** rnscrfi: Error while reading control'
      close(lu)
      goto 1000
999   write(*,*) '** rnscrfi: could not open control'
      close(lu)
1000  return
      end

