#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      SUBROUTINE pgetstr(t,s,tid,l,id,irc)

#include "defs.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

      INTEGER tid,l,irc,id
      CHARACTER*(*) s,t
      INTEGER w
#ifdef AKIRA_MPI
      INTEGER st(MPI_STATUS_SIZE)
      CHARACTER*(MPI_MAX_PROCESSOR_NAME) mpiname
#endif

#ifdef AKIRA_MPI
      w=MPI_COMM_WORLD
#endif

#ifdef DEBUG
      WRITE (idbg,*) '@pgetstr@ ',id,'{',tid,'} [',t,']'
      CALL flush(idbg)
#endif

#ifdef AKIRA_MPI
C***  CALL MPI_RECV(l,1,MPI_INTEGER,tid,id,w,st,irc)
C***  CALL mpierr('MPI_RECV pgetstr',t,irc)
      CALL MPI_RECV(s,l,MPI_CHARACTER,tid,id,w,st,irc)
      CALL mpierr('MPI_RECV pgetstr',t,irc)
#endif

#ifdef AKIRA_PVM
      CALL PVMFRECV(tid,0,w)
      CALL clean(s)
      CALL PVMFUNPACK(STRING,s,l,1,irc)
      IF (irc.NE.0) CALL PVMFPERROR(t,irc)
#endif
      RETURN
      END





      SUBROUTINE pputstr(t,s,tid,l,id,irc)

#include "defs.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

      INTEGER tid,l,irc,id
      CHARACTER*(*) s,t
      INTEGER w
#ifdef AKIRA_MPI
      INTEGER st(MPI_STATUS_SIZE)
#endif

#ifdef DEBUG
      WRITE (idbg,*) '@pputstr@ ',id,'{',tid,'} [',t,']'
      CALL flush(idbg)
#endif

#ifdef AKIRA_MPI
      w=MPI_COMM_WORLD
#ifdef AKIRA_MPI_SSEND
C***  CALL MPI_SSEND(l,1,MPI_INTEGER,tid,id,w,irc)
      CALL MPI_SSEND(s,l,MPI_CHARACTER,tid,id,w,irc)
      CALL mpierr('MPI_SSEND pputstr',t,irc)
#else
C***  CALL MPI_SEND(l,1,MPI_INTEGER,tid,id,w,irc)
      CALL MPI_SEND(s,l,MPI_CHARACTER,tid,id,w,irc)
      CALL mpierr('MPI_SEND pputstr',t,irc)
#endif
#endif

#ifdef AKIRA_PVM
      CALL PVMFINITSEND(PVMDATADEFAULT,w)
      CALL PVMFPACK(STRING, s, l, 1, irc )
      IF (irc.NE.0) CALL PVMFPERROR(t,irc)
      CALL PVMFSEND( tid, 0, irc )
      IF (irc.NE.0) CALL PVMFPERROR(t,irc)
#endif

      RETURN
      END
