
      subroutine rcoord(tempname,inatoms,co,ic)
C
C     read TURBOMOLE coord file and determine
C     nuclear charge numbers
C
C     inatoms = number of atoms
C     co     = cartesian coordinates of atoms
C     ic     = nuclear charge numbers (integer)
C
C     written by J. Neugebauer, Uni Erlangen, 01/2002
C
#include "defs.h"
      double precision co(3,*)
      integer ic(*),i,lu,find_nucl_charge,ltmp,mxitem,inatoms,a,b
      character*(*) tempname
      character*2   element
      character*255 b1
      PARAMETER (mxitem=12)
      CHARACTER*128 item(mxitem)
      logical  optdone
      external find_nucl_charge
      lu=1
      call slen(tempname,ltmp)
      write(iosl,*) 'rcoord: reading coordinates from file: ',
     * tempname(1:ltmp)
      call flush(iosl)
      open (unit=lu,file=tempname(1:ltmp),status='unknown',err=1001)
1       read (lu,'(a)',end=999) b1
       call flush(iosl)
        call split(b1,item,mxitem)
        if (item(1).eq.'$coord') goto 2
        if (item(1).eq.'Optimization'.and.item(2).eq.'completed.')
     1      optdone = .true.
        if (item(1).eq.'Standard'.and.item(2).eq.'orientation:'
     1      .and.optdone) goto 5
      goto 1
2     continue
      inatoms=0
3       read (lu,'(a)',end=999) b1
       call flush(iosl)
        if(b1(1:1).eq.'$') goto 4
        inatoms=inatoms+1
        read(b1,*) co(1,inatoms), co(2,inatoms), co(3,inatoms), element
        ic(inatoms)=find_nucl_charge(element)
      goto 3
5     continue
      inatoms = 0
4     continue
      write(iosl,*) 'rcoord: inatoms = ',inatoms
      call flush(iosl)
999   close(lu)
1001  continue
      return
      end

!**************************************************************

      subroutine pcoord(natoms,co,ic,mcharge,out,mode)
C
C     print molecule information
C
C     written by J. Neugebauer, Uni Erlangen, 01/2002

      implicit none
      double precision co(3,*),find_mass
      integer ic(*),i,out,j,mcharge,natoms,mode
      character*2   find_element
      external find_element,find_mass
      write(out,*)
      write(out,*) ' General Molecule Information: '
      write(out,*) ' ----------------------------- '
      write(out,*)
      write(out,'("    No El  AN",12x,"m",15x,"x",15x,"y",15x,"z")')
      do i=1,natoms
        write(out,'(''  '',i4,1x,a2,1x,i3,f13.6,3f16.8)') i,
     * find_element(ic(i)),ic(i),find_mass(ic(i)),
     * (co(j,i),j=1,3)
      end do
      write(out,*)
      if(mode.lt.30) then
        write(out,'(1x,a,i5)') ' Molecular charge: ',mcharge
        write(out,'(1x,a)')    ' ----------------- '
        write(out,*)
      end if
      return
      end

!**************************************************************

      subroutine wcoord(tempname,natoms,co,ic)
C
C     write TURBOMOLE coord file
C
C     written by J. Neugebauer, Uni Erlangen, 01/2002

      implicit none
      double precision co(3,*)
      integer ic(*),i,lu,natoms
      character*(*) tempname
      character*2   find_element
      external find_element
      lu=44
      open (unit=lu,file=tempname,status='unknown',err=1001)
      write(44,'(''$coord'')')
      do i=1,natoms
        write(lu,300) co(1,i), co(2,i), co(3,i), find_element(ic(i))
      enddo
      write(44,'(''$end'')')
      close(lu)
300   format(3f18.10,5x,a2)
1001  return
      end

!**************************************************************

      subroutine wcoordcq(tempname,lastqmatom,co,elinfo)
C
C     write TURBOMOLE coord file for comqum calculations
C
C     written by C. Herrmann, Northwestern University, 2007, 
C     based on wcoord by J. Neugebauer, Uni Erlangen, 01/2002

      implicit none
      double precision co(3,*)
      integer i,lu,lastqmatom
      character*(*) tempname,elinfo(*)
      character*2   find_element
      external find_element
      lu=44
      open (unit=lu,file=tempname,status='unknown',err=1001)
      write(44,'(''$coord'')')
      do i=1,lastqmatom
        write(lu,300) co(1,i), co(2,i), co(3,i), elinfo(i)
      enddo
      write(44,'(''$end'')')
      close(lu)
300   format(3f18.10,5x,a10)
1001  return
      end

