#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      SUBROUTINE rdparm

*
* read input parameters; called from imaster
*
#include "defs.h"
#include "param.h"

      character*255 b1
      integer i,intgr,ierr,l,lmy

* read input, unless already done so
      if (inrec.eq.0) call readin

      write (*,*)
      write (*,*) '========================================='
      write (*,*) '== AKIRA INPUT PARAMETERS FROM DCINPUT =='
      write (*,*) '========================================='
      write (*,*)
      ierr=0

c     ------------------------------------------------------
c     MYDIR: the current working directory
c     ------------------------------------------------------
      mydir='*MYDIR?'
      call rdir('MYDIR',mydir,lm,0,ierr)
      write (*,*) 'MYDIR        ',mydir(1:lm)

c     ------------------------------------------------------
c     TITLE: title of calculation
c     ------------------------------------------------------
      call readv('TITLE',title,mydir(1:lm))
      write (*,*) 'TITLE        ',title(1:60)

***   obsolete default for node-local directories on SR8000
***   call tmpdir(tempdir)
      tempdir=mydir
      tempdir(lm+1:lm+4)='/tmp'
      call rdir('TMPDIR',tempdir,lt,0,ierr)
      write (*,*) 'TMPDIR       ',tempdir(1:lt)

      logdir=mydir
      logdir(lm+1:lm+4)='/log'
      call rdir('LOGDIR',logdir,ll,1,ierr)
      write (*,*) 'LOGDIR       ',logdir(1:ll)

      call readv('ARPATH',arpath,' ')
      call slen(arpath,lar)
      if (lar.gt.0) then
        write (*,*) 'ARPATH       ',arpath(1:lar)
        call errex('ARPATH option has been disabled')
      end if

      CALL readv('PROGDIR',turbodir,' ')
      CALL slen(turbodir,lb)
      IF (lb.GT.0) WRITE (*,*) 'PROGDIR     ',turbodir(1:lb)
      IF (lb.GT.0) THEN
       turbodir(lb+1:lb+1)='/'
       lb=lb+1
      ENDIF

#ifndef AKIRA_SERIAL
c     ------------------------------------------------------
c     DCPATH: full name of snfdc binary to be used on slaves
c     ------------------------------------------------------
      CALL readv('DCPATH',dcdir,'akira')
      CALL slen(dcdir,ldc)
      WRITE (*,*) 'DCPATH       ',dcdir(1:ldc)

c     ------------------------------------------------------
c     CHOOSENOPT: options for choose_nodes script
c     ------------------------------------------------------
      call clean(cnopt)
      call rkeystr('DCINPUT','CHOOSENOPT',cnopt)
      call llen(cnopt,lnopt)
      write (*,*) 'CHOOSENOPT   ',cnopt(1:lnopt)
#endif


c     ------------------------------------------------------
c     CRAP_OK: override safety checks for certain parameters
c              (e.g., scfconv, cstep)
c     ------------------------------------------------------
      icrap=0
      CALL readv('CRAP_OK',b1,'no')
      CALL slen(b1,l)
      WRITE (*,*) 'CRAP_OK      ',b1(1:l)
      IF (b1(1:6).NE.'no') icrap=1

      CALL readv('UPDATE',b1,'3')
      CALL slen(b1,l)
      updopt=intgr(b1,l,20)

#ifdef AKIRA_PVM
      if(updopt.ne.3) then
        WRITE (*,*) 'UPDATE       ',b1(1:l)
        WRITE (*,*) 'virtual machine update option(s) [UPDATE] :'
        IF (MOD(updopt,2).GE.1) then
          WRITE (jtape,*) 'remove        processes on vbsy nodes'
        else
          WRITE (jtape,*) 'do not remove processes on vbsy nodes'
        end if
        IF (MOD(updopt,4).GE.2) then
          WRITE (jtape,*) 'add           processes on idle nodes'
        else
          WRITE (jtape,*) 'do not add    processes on idle nodes'
        end if
      end if
#endif

      CALL readv('PREFIX',b1,'TMP%')
      CALL slen(b1,l)
      WRITE (*,*) 'PREFIX       ',b1(1:l)
      IF (l.GT.0) THEN
       logdir=logdir(1:ll)//b1(1:l)
       ll=ll+l
      ENDIF
      IF (ierr.NE.0) CALL errex('error encountered in input')

#ifdef DEBUG
      CALL readv('MXSTEP',b1,'0')
      i=0
      mxstep=intgr(b1,i,20)
      IF (mxstep.GT.0) THEN
       WRITE (jtape,*) 'maximal number of steps per node :',mxstep
      ENDIF
#endif

      CALL readv('FSYS',b1,'0')
      CALL slen(b1,l)
      WRITE (*,*) 'FSYS         ',b1(1:l)
      i=0
      iprintf=intgr(b1,i,20)

#ifndef AKIRA_SERIAL
      CALL readv('CHANNELS',b1,'0')
      CALL slen(b1,l)
      WRITE (*,*) 'CHANNELS     ',b1(1:l)
      i=0
      ierr=intgr(b1,i,20)
      IF (ierr.GT.0) then
        write(*,*) 'CHANNELS option ignored in DCINPUT'
        write(*,*) 'ARCHIVING has been disabled'
C        CALL setmax_ctok(ierr)
      end if
#endif

      CALL clean(restart)
      restart=mydir(1:lm)//'/restart.akira'
      dcstat =mydir(1:lm)//'/TMPdcstat'

      WRITE (*,*)
      WRITE (*,*) '========================================='
      RETURN
      END
