      subroutine rduse(nodeav)
* -------------------------------------------------------------------------
* remove all dead and unfit nodes, read  USE_NODES file and spawn all nodes
* specified there, unless a suitable number of processes is already running
* on the node in question.
*
* comments added by J. Neugebauer, 2007
* -------------------------------------------------------------------------

      use MachineModule

#include "defs.h"
#include "param.h"

      type(type_machine), pointer :: mach,cmach
      integer lu
      character*255 rec,item(mxitem)
      character*40 name
      integer i,l,kp,np,intgr,valid,maxp
      logical yes,nodeflag,nodeav

      nodeav=.true.
      nodeflag=.false.
      lu=1
      call clean(rec)
      call cmd_remove(rec)

*     -----------------------------------------------------------
*     check if there is a file USE_NODES
*     -----------------------------------------------------------
      inquire (file='USE_NODES',exist=yes)
      if (.not.yes) then
        write (idbg,*) '  rduse| file USE_NODES not present'
        write (jtape,*) '########'
        write (jtape,*) '######## file USE_NODES not present'
        write (jtape,*) '########'
        nodeav=.false.
        return
      endif

*     -----------------------------------------------------------
*     read the USE_NODES file
*     -----------------------------------------------------------
      open (unit=lu,file='USE_NODES',status='unknown')
      write (idbg,*) '  rduse| reading file USE_NODES'

      ReadFile_: do
        read (lu,'(a)',end=99) rec
        call split(rec,item,mxitem)
       
*       -----------------------------------------------------------
*       found a node ?
*       -----------------------------------------------------------
        if (item(1).eq.'node') then
          nodeflag=.true.
          write (idbg,*) '  rduse| ',rec(1:60)
          np=0
       
*         -----------------------------------------------------------
*         kp   = no. of jobs available for jobs on that node
*         maxp = total no. of jobs acceptable on that node
*         -----------------------------------------------------------
          kp=intgr(item(3),i,20)
          maxp=intgr(item(4),i,20)
          if (maxp.eq.0) maxp=1
       
*         -----------------------------------------------------------
*         set p to current
*         -----------------------------------------------------------
          nullify(mach)
          mach => machlist
          call llen(item(2),l)
       
*         -----------------------------------------------------------
*         loop over machines in machine_list
*         -----------------------------------------------------------
          NodeLoop_: do
            if(.not.associated(mach)) exit NodeLoop_
           
*           -----------------------------------------------------------
*           get name of machine and compare to current machine name
*           -----------------------------------------------------------
            call getmach_name(mach,name)
            if (name(1:l).eq.item(2)(1:l)) then
              valid=0
              if(mach%cmd == 'vbsy') mach%cmd = '----'
              if(mach%nodf == 'rdy') valid = valid + 1
              if(mach%nodf == 'wait') valid = valid + 1
              if(mach%nodf == 'run') valid = valid + 1
              if (valid.gt.0) then
                call findnode_by_name(pvmmachlist,cmach,name)
                if(associated(cmach)) cmach%mxlo=maxp*150

*               -----------------------------------------------------------
*               JN: check: should np be increased if cmach not associated ?
*               -----------------------------------------------------------
                np=np+1
              end if
            endif
            mach => mach%next
          end do NodeLoop_
       
          kp=kp-np
          if (kp.gt.0) then
            write (idbg,*)
     *     '       | creating ',kp,' more process(es) on ',item(2)(1:20)
            do i=1,kp
              call add_node(machlist,item(2),' ')
              cmach => current_mach
              cmach%mxlo=maxp*150
            end do
          end if
        end if
      end do ReadFile_

99    close (unit=lu)
      if (.not.nodeflag) then
        write (idbg,*) '  rduse| no nodes present in file USE_NODES'
        nodeav=.false.
      end if

      write (idbg,*) '  rduse| nodes from file USE_NODES:'
      call print_nodes(machlist,idbg)

      return
      end
