#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      subroutine remnode(msg,imsg,stepfl,machnumb)

*     ------------------------------------------------
*     remove node
*
*     migrate to MachineModule by J. Neugebauer, 2007
*     ------------------------------------------------

      use MachineModule

#include "defs.h"
#include "param.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

      type(type_machine), pointer :: mach,cmach
      integer stepfl(*)
      integer imsg,mbuf,machnumb
      character*(*) msg
      character*24 date
      integer j,k,mbua,info
      character*40 myname
      character*255 cmd
      character*20 cpid
      integer*4 iwhat
      integer i,ist,tid,tpid,xeq
#ifdef AKIRA_MPI
      integer w,st(mpi_status_size)
      data w /mpi_comm_world/
#endif

      nullify(mach)
      call findnode_by_num(mach,machnumb)
      call getmach_name(mach,myname)
      call fdate(date)
      write (jtape,'(a,a,i10,x,a,x,a,x,i3)')
     .     date,'!! ',mach%numb,myname(1:10),msg,imsg
      if (imsg.eq.0) then
        mach%nodf = 'done'
      else
        mach%nodf = 'dead'
      endif
      mach%cmd = '----'
      i   = mach%stpa
      j   = mach%stpb
      tid = mach%tid

*     --------------------------------------------------
*     look for node with name mach%name in list of 
*     machines already included in PVM
*     --------------------------------------------------
      call findnode_by_name(pvmmachlist,cmach,mach%name)
      ist=0
      if (associated(cmach)) ist=cmach%usag
      if (imsg.gt.0 .and. i.gt.0) then
        stepfl(i)=0
        do k=i,j
          stepfl(k)=0
        enddo
      endif
      if (imsg.eq.mach_term) then
        tpid=mach%tpid
        if (tpid.ne.0) then
          write (jtape,*) i,tid,tpid,' still running on ',myname
          write (jtape,'(a,a,i10)')
     &         date,'!! trying to kill task ',tpid
          write (cpid,'(i20)') tpid
          call clean(cmd)
          cmd='dc_killtask '//mach%name//' '//cpid//' tmp_dc_killtask'
          info=xeq(cmd)
          write (jtape,'(a,a,i10)')
     &         date,'!! returncode was ',info
        endif
      endif
      iwhat=-1
#ifdef AKIRA_MPI
      call mpi_send(iwhat,1,mpi_integer,tid,409,w,info)
      call mpierr('mpi_send iwhat','remnode',info)
#endif
#ifdef AKIRA_PVM
      call pvmfinitsend(pvmdatadefault,mbuf)
      call pvmfpack( integer4, iwhat, 1, 1, info )
      call pvmfsend( tid, 0, info )
      write (jtape,'(''percentage of work done on node '',
     * a20,f10.2)') myname,100.*float(ist)/float(nstept)
#endif
      return
      end
