      subroutine resicheck(isel,rvec,mxres,jr,iti,evec,nbm,dcsel,onsel,
     * olam,oisel,avib,norm,oldnorm)
*-----------------------------------------------------------
* perform check of residuum vector and related convergence
* control parameters
*
* written by J. Neugebauer, 2003-2004
*-----------------------------------------------------------

#include "defs.h"
#include "param.h"

      integer isel(mxnsel),jr,iti,nbm,i,onsel,oisel(mxnsel)
      real*8 norm,dotprod,rvec(nvar,maxnbm),mxres(mxnsel),prec
      real*8 oldnorm(mxnsel),evec(maxnbm,maxnbm),dvib,qfc2freq,
     *       olam(maxnbm),avib(maxnbm)
      logical dcsel
      external dotprod,qfc2freq

       norm=dotprod(rvec(1,isel(jr)),rvec(1,isel(jr)),nvar)
       norm=sqrt(norm)/dble(3*natoms)
       write(ftape,*)
       write(ftape,'(2x,a)')
     *'----------------------------------------------------------------'
       write(ftape,'(2x,a,i5)')
     * 'Convergence control parameters for selected vector ',jr
       write(ftape,'(2x,a,i5,a)')
     * '(now vector no. ',isel(jr),')'
       write(ftape,'(2x,a)')
     *'----------------------------------------------------------------'
       mxres(jr)=0.0d0
       do i=1,nvar
         mxres(jr)=max(mxres(jr),abs(rvec(i,isel(jr))))
       end do
       if(norm.gt.1.0d-7) then
         write(ftape,'(2x,a,f16.8)')
     *     '|r|/(3*natoms)             = ',norm
       else
         write(ftape,'(2x,a,e16.8)')
     *     '|r|/(3*natoms)             = ',norm
       end if
       prec=oldnorm(jr)-norm
       if(abs(prec).gt.1.0d-7) then
         write(ftape,'(2x,a,f16.8)')
     *     '(|r_old| - |r|)            = ',prec
       else
         write(ftape,'(2x,a,e16.8)')
     *     '(|r_old| - |r|)            = ',prec
       end if
       if(mxres(jr).gt.1.0d-7) then
         write(ftape,'(2x,a,f16.8)')
     *     '|r_max|                    = ',mxres(jr)
       else
         write(ftape,'(2x,a,e16.8)')
     *     '|r_max|                    = ',mxres(jr)
       end if
       prec=evec(nbm-(onsel-jr),isel(jr))
       if(abs(prec).gt.1.0d-7) then
         write(ftape,'(2x,a,f16.8)')
     *     'coef. of last basis vector = ',prec
       else
         write(ftape,'(2x,a,e16.8)')
     *     'coef. of last basis vector = ',prec
       end if
       write(ftape,'(2x,a,f16.2)')
     *     'current wavenumber [1/cm]  = ',avib(isel(jr))
       dvib=qfc2freq(olam(oisel(jr)))
       write(ftape,'(2x,a,f16.2)')
     *     'last wavenumber [1/cm]     = ',dvib
       dvib=avib(isel(jr))-dvib
       write(ftape,'(2x,a,f16.2)')
     *     'wavenumber change          = ',dvib

*----------------------------------------------------------------
* vector converged (or no improvement) ?
*----------------------------------------------------------------

       call convcontrol(rthres,rabsthres,dvthres,ecthres,norm,
     *   oldnorm(jr),mxres(jr),prec,dvib,dcsel,ftape,iti,jr,rchthres)

      end


******************************************************************

      subroutine convcontrol(rthres,rabsthres,dvthres,ecthres,norm,
     *    oldnorm,mxres,ec,dvib,csel,ftape,iti,jno,rchthres)
*
* check convergence control parameters
*
* written by J. Neugebauer, Uni Erlangen, 2003
*
      implicit none
      real*8 rthres,rabsthres,dvthres,ecthres,norm,oldnorm,mxres,ec
      real*8 dvib,rchthres
      integer ftape,jno,iti
      logical csel,rconv,rabsconv,dvconv,ecconv

      rconv=.false.
      rabsconv=.false.
      dvconv=.false.
      ecconv=.false.
      csel=.false.

      if(mxres.lt.rthres) then
        rconv=.true.
        write(ftape,'(2x,a,i4,a)')
     *   'Vector ',jno,' : max. component of residuum converged!'
      end if
      if(rabsthres.gt.0.0d0) then
        if(norm.lt.rabsthres) then
          rabsconv=.true.
          write(ftape,'(2x,a,i4,a)')
     *     'Vector ',jno,' : norm of residuum converged!'
        end if
      else
        rabsconv=.true.
      end if
      if(dvthres.gt.0.0d0) then
        if(abs(dvib).lt.dvthres) then
          write(ftape,'(2x,a,i4,a)')
     *     'Vector ',jno,' : wavenumber converged!'
          dvconv=.true.
        end if
      else
        dvconv=.true.
      end if
      if(ecthres.gt.0.0d0) then
        if(abs(ec).lt.ecthres) then
          write(ftape,'(2x,a,i4,a)')
     *     'Vector ',jno,' : expansion coefficient converged!'
          ecconv=.true.
        end if
      else
        ecconv=.true.
      end if
      csel=(rconv.and.rabsconv.and.dvconv.and.ecconv)
      if(csel) then
        write(ftape,*)
        write(ftape,'(2x,a,i4,a,i5)')
     *   'Vector ',jno,' converged in iteration No.',iti
        call flush(ftape)
      else if(abs(oldnorm-norm).lt.rchthres) then
        write(ftape,*)
        write(ftape,'(2x,a,i5,a,i5)')
     *   'Vector ',jno,' did not improve in iteration No.',iti
        write(ftape,'(2x,a)')
     *   'No new basis vector will be generated for this vector'
        csel=.true.
      end if
      end
