      subroutine wrestart(vmach,gra,istepfl,escf,pol,nbm)

**************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2002, 2003
**************************************************

#include "defs.h"
#include "param.h"
      character*255 form,form2
      integer istepfl(*),jomeg,dtype
      real*8 gra(*),escf(*),pol(mxomeg,*)
      real*8 vmach(*)
      integer i,j,k,in1,ires,imin,nbm
      character*24 date
#include "version.h"

      data form /'(4d20.10)'/
      data form2 /'(4d24.14)'/

      in1=88
      open (unit=in1,file=restart,status='unknown')
      write (in1,'(a)') title
      write (in1,'(a)') form
      write (in1,'(14i5)') ivers,mode,nvar,jscfc,naus,iomeg,riflag
      write (in1,form) cstep
      write (in1,'(a)') mydir(1:lm)
      write (in1,'(a)') tempdir(1:lm)
      do i=1,nbm
       j=(i-1)*naus
       write (in1,'(24i3)') i,(istepfl(k),k=j+1,j+naus)
       write (in1,'(12a8)') (vmach(k),k=j+1,j+naus)
      end do
 
*----------------------------------------------------
* write energies for equilibrium and displacement 
* geometries
*----------------------------------------------------
      write (in1,*) 'energy equilibrium structure'
      write (in1,form2) escf(maxnstept+1)
      do i=1,nbm
        write (in1,*) 'energies mode',i
        j=(i-1)*naus
        write (in1,form2) (escf(k),k=j+1,j+naus)
      end do

      if(mode.ge.1.and.mode.le.60.and.mode.ne.2) then
*----------------------------------------------------
* write gradients for displacement geometries
*----------------------------------------------------
        do i=1,nbm
          write (in1,*) 'gradients mode',i
          j=(i-1)*naus*nvar
          write (in1,form) (gra(k),k=j+1,j+naus*nvar)
        end do
      end if

      call fdate(date)
      write (in1,'(a)') date
      close (in1)
      return
      end

      subroutine rrestart(vmach,gra,istepfl,isum,escf,pol,nbm)

**************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2002, 2003
**************************************************

#include "defs.h"
#include "param.h"
      integer istepfl(*),jomeg
      character*255 form,buf,form2
      integer i,j,k,isum,jvers,mmode,iaus,in1,nbm
      logical ex
      real*8 pstep
      real*8 vmach(*),pol(mxomeg,*)
      real*8 gra(*),escf(*)
#include "version.h"
      data form2 /'(4d24.14)'/

      in1=88
      inquire (file=restart,exist=ex)
      if (.not.ex) return

      open (unit=in1,file=restart,status='old')
      rewind(in1)
      read(in1,'(a)')
      read(in1,'(a)') form
      read(in1,'(14i5)') jvers,mmode,nvar,jscfc,iaus,iomeg,riflag
      i=ivers/10
      j=jvers/10
      if (jvers.lt.1) then
       write (*,*) '****** incompatible versions '
       write (*,*) '****** version on restart file :',jvers
       write (*,*) '****** current program version :',ivers
       call errex('incompatible restart file')
      endif
      if (mode.ne.mmode) then
       write (*,*) '****** <control> file has been changed:'
       write (*,*) '****** mode on restart file :',mmode
       write (*,*) '****** current program mode :',mode
       call errex('incompatible restart file')
      endif
      if (naus.ne.iaus) then
       write (*,*) '****** <control> file has been changed:'
       write (*,*) '****** restart file is using ',iaus,' point formula'
       write (*,*) '****** current program is using ',naus,
     * ' point formula'
       call errex('incompatible restart file')
      endif
      read (in1,form) pstep
      if (dabs(cstep-pstep).gt.1.d-6) then
       write (*,*) '****** cstep has been changed:'
       write (*,*) '****** cstep on restart file     :',pstep
       write (*,*) '****** current program cstepmode :',cstep
       call errex('incompatible restart file')
      endif
      if (mode.lt.20.and.iabs(iscfc-jscfc).gt.0) then
       write (*,*) '****** scfconv has been changed:'
       write (*,*) '****** scfconf on restart file     :',jscfc
       write (*,*) '****** current program scfconv :',iscfc
       call errex('incompatible restart file')
      endif
      read (in1,'(a)') 
      read (in1,'(a)') 
      do i=1,nbm
       j=(i-1)*naus
       read (in1,'(24i3)') k,(istepfl(k),k=j+1,j+naus)
       read (in1,'(12a8)') (vmach(k),k=j+1,j+naus)
      enddo

*--------------------------------------------------------
* read energies for displacement structures
*--------------------------------------------------------

      read (in1,'(a)') buf
      read (in1,form2) escf(maxnstept+1)
      do i=1,nbm
       read (in1,'(a)')
       j=(i-1)*naus
       read (in1,form2) (escf(k),k=j+1,j+naus)
      end do

      if(mode.ge.1.and.mode.le.60.and.mode.ne.2) then
*--------------------------------------------------------
* read gradients for displacement structures
*--------------------------------------------------------
        do i=1,nbm
          read (in1,'(a)')
          j=(i-1)*naus*nvar
          read (in1,form) (gra(k),k=j+1,j+naus*nvar)
        enddo
      end if
 
      isum=0
      do i=1,nstept
         if(istepfl(i).eq.-1) istepfl(i)=0 
         isum=isum+istepfl(i) 
      enddo

      write(iosl,*)'% already done',100.*float(isum)/float(nstept)

      close (in1)
      return
      end

******************************************************************************
 
      subroutine wrhesscu(ucf,hessc,jstepa)
*
* write cartesian hessian to unit <un>
*
* written by J. Neugebauer, Uni Erlangen, 2002
*
#include "defs.h"
#include "param.h"
      character(len=255) form,buf
      integer i,j,ucf,kbuf,i2,i2end,nd,fll
      integer kend,imode,idir,im,ipre
      integer*4 jstepa
      real*8 hessc(nvar,nvar)
      parameter(nd=5)
      external imode,ipre
      form='(i2,i3,5f15.10)'
      im=imode(jstepa,naus)
      idir=ipre(jstepa,naus)
      write(ucf,'(a,i6)') '$jstepa',jstepa
      write(ucf,'(a,i6)') '$modeno',im
      write(ucf,'(a,i6)') '$prefac',idir
      write(ucf,'(a)') '$hessian (projected)'
      i2end=nvar/nd
      if(mod(nvar,nd).ne.0) i2end=i2end+1
      do i=1,nvar
        do i2=1,i2end
         kend=i2*nd
         if(i2.eq.i2end) kend=nvar
         kbuf=(i2-1)*nd+1
         write(ucf,form) i,i2,(hessc(i,j),j=kbuf,kend)
        end do
      end do
      end
 
******************************************************************************
 
      subroutine rehesscu(ucf,hessc,jstepa)
*
* read cartesian hessian from unit <un>
*
* written by J. Neugebauer, Uni Erlangen, 2002
*
#include "defs.h"
#include "param.h"
      character(len=255) form,buf
      integer i,j,ucf,kbuf,i2,i2end,nd,fll
      integer kend
      integer*4 jstepa,jstepb
      real*8 hessc(nvar,nvar)
      parameter(nd=5)
      form='(5x,5f15.10)'
10    read(ucf,'(a)',err=900,end=900) buf
      if(index(buf,'$jstepa').eq.0) goto 10
      read(buf(8:),*,err=900,end=900) jstepb
      if(jstepa.ne.jstepb) goto 950
15    read(ucf,'(a)',err=900,end=900) buf
      if(index(buf,'$hessian (projected)').eq.0) goto 15
      i2end=nvar/nd
      if(mod(nvar,nd).ne.0) i2end=i2end+1
      do i=1,nvar
        do i2=1,i2end
         kend=i2*nd
         if(i2.eq.i2end) kend=nvar
         kbuf=(i2-1)*nd+1
         read(ucf,form) (hessc(i,j),j=kbuf,kend)
        end do
      end do
      return
900   write(jtape,'(a,i5)') '** rehesscu: error while reading step: ',
     * jstepa
      stop 
950   write(jtape,'(a,i5,a,i5)') '** rehesscu: expected step ',jstepa,
     * ' but found step ',jstepb
      stop
      end
 
******************************************************************************

      subroutine winirestart(istepfl,escf,nbm)

**************************************************
* write initial restart file
*
* written by J. Neugebauer, Uni Erlangen, 2001
**************************************************

#include "defs.h"
#include "param.h"
      CHARACTER*255 form,form2
      INTEGER istepfl(*),jomeg
      REAL*8 escf
      INTEGER i,j,k,in1,ires,imin,nbm
      CHARACTER*24 date
#include "version.h"
      DATA form /'(4D20.10)'/
      DATA form2 /'(4D24.14)'/
      in1=88
      OPEN (unit=in1,file=restart,STATUS='UNKNOWN')
      WRITE (in1,'(A)') 'title'
      WRITE (in1,'(A)') form
      WRITE (in1,'(14I5)') ivers,mode,nvar,jscfc,naus,iomeg,riflag
      WRITE (in1,form) cstep
      WRITE (in1,'(A)') 'mydir'
      WRITE (in1,'(A)') 'tempdir'
      DO i=1,nbm
       j=(i-1)*naus
       WRITE (in1,'(24I3)') i,(istepfl(k),k=j+1,j+naus)
       WRITE (in1,'(12A8)') ('--------',k=j+1,j+naus)
      ENDDO
      WRITE (in1,*) 'energy equilibrium structure'
      WRITE (in1,form2) escf
      DO i=1,nbm
       WRITE (in1,*) 'energies mode',i
       j=(i-1)*naus
       WRITE (in1,form2) (0.0d0,k=j+1,j+naus)
      END DO

      if(mode.ge.1.and.mode.le.60.and.mode.ne.2) then
        DO i=1,nbm
         WRITE (in1,*) 'gradients mode',i
         j=(i-1)*naus*nvar
         WRITE (in1,form) (0.0d0,k=j+1,j+naus*nvar)
        ENDDO
      end if

      CALL fdate(date)
      WRITE (in1,'(A)') date
      CLOSE (in1)
      RETURN
      END
