      subroutine serres(nit,cpu,wall,energy,gcpu,gwall,ggrad,ia,nbm)
*-------------------------------------------------------
* serial version of getres.r: get results and store them
* on restart file
* modified by C. Herrmann, Uni Jena 02.05.2005 
* (exc. state gradients)
*
* f90 memory management by J. Neugebauer, 2007
*-------------------------------------------------------

      use RestartModule

#include "defs.h"
#include "param.h"
    
      real*8, allocatable ::  pol(:,:,:,:)
      real*8 ggrad(nvar),cpu,wall,gcpu,gwall,energy,gsum,se
      integer nit,nse,ia,jomeg,icmp,iaus,m,j,i,nbm
      character*24 date

      allocate(pol(mxomeg,8,naus,nvar))
      pol = 0.0d0
      gsum=0.0d0
      do j=1,nvar
         gsum=gsum+ggrad(j)**2
      end do
      se=wall+gwall
      nse=se

      write(*,'(A)')       '----------------------------------------'
      write(*,'(A,i15)')   'STEP NO.            : ',ia
      write(*,'(A,f15.2)') 'CPU TIME            : ',cpu+gcpu
      write(*,'(A,f15.2)') 'WALL TIME           : ',wall+gwall
      write(*,'(A,i15)')   'NO. OF ITERATIONS   : ',nit
      write(*,'(A,f15.8)') 'ELEC. ENERGY        : ',energy
      write(*,'(A)')       '----------------------------------------'

*     -----------------------------------------------------------
*     CH: removed energy check for excited state calculations
*     (energy > 0 is acceptable, since reference is ground state)
*     -----------------------------------------------------------
      if (energy.ge.0.d0.and.rpast.eq.0) then
*       ----------------------
*       shut down the process
*       ----------------------
        write (*,'(a20,d20.10)') ' invalid energy:',energy
        call errex('invalid energy')
      end if
      if(gsum.gt.1.0d0) then
        write(*,*) 'WARNING! invalid gsum: ',gsum
        write(*,*) 'unless you have specified a very large cstep value'
        write(*,*) 'this is a reason to worry'
      end if
      call fdate(date)
      write (jtape,109) date,' (serial mode) <- ',masterid(1:9),ia
109   format(a,a,' ',a,' return step ',i3)
      call flush(jtape)

      istepfl(ia) = 1
      iaus=MOD(ia,naus)
      IF (iaus.EQ.0) iaus=naus
      m=ia/naus
      if(mod(ia,naus).ne.0) m=m+1
      do icmp=1,nvar
        grad(icmp,iaus,m)=ggrad(icmp)
      end do
      escf(ia) = energy

      call wrestart(vmach,grad,istepfl,escf,pol,nbm)

      deallocate(pol)

      end
 
