      subroutine serstuff(stepfl,vmach,escf,first,nbm)

****************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
* slightly adapted for excited state gradients by
* C. Herrmann, Uni Jena 04/2005
*
* cleaned up by J. Neugebauer, 2007
****************************************************

#include "defs.h"
#include "param.h"
*
* stepfl I4  status flags for each point
* vmach  R8  machine name for each point
*

      integer stepfl(*),now,nbm
      real*8 vmach(*),escf(*)

* declare integers to be packed and unpacked as INTEGER*4 for T3E compatibility

      character*255 b1
      character*8 localhost
      character*24 date
      integer info,xeq,irc,iclean,icleanl,info2
      integer i,k,l,idum,ize,ipe,j,iready,lres
      logical first,parafreq,valmod
      
      call secs(now)
      localhost='loclhost'
      
*---------------------------------------------
* create TMP directory and receive input files
* if this is the first step
* CAUTION: always synchronize with islave.r
*---------------------------------------------
      if(first) then
        call clean(b1)
        call slen(tempdir,lt)
        call slen(mydir,lm)
        call slen(arpath,lar)
        call slen(turbodir,lb)
        masterid='localhost'
        call slen(masterid,li)
        b1(1:lt)=tempdir(1:lt)
        call augnum(tempdir,b1(1:lt)//'/TMP',now)
        call slen(tempdir,lt)
        info=xeq('mkdir '//tempdir(1:lt))
        first = .false.

c-----------------
** akira_control
c-----------------

        info=0
        write (iosl,*) 'get akira_control from ','localhost'
        call getfile('akira_control','localhost','localhost',info)
        call rakiractrl(tempdir(1:lt)//'/akira_control',rthres,
     *  rabsthres,dvthres,ecthres,
     *  roothmpr,g98it,g98bs,xmolout,tmout,printall,precond,genstart,
     *  rchthres,minnbt,iorth,snfout,natoms,mode,cstep,naus,iclean,
     *  icleanl,idbg,ipol,lastqmatom,irescp,restadf,sleeptime)
       
        write (iosl,*) 'serstuff: read akira_control, mode is ',mode
        call flush(iosl)

        if (.not.valmod(mode)) then
           write(iosl,*) 'islave: No such program mode: ',mode
           stop
        end if
        
        parafreq=.false.
        call rkeywd(tempdir(1:lt)//'/control','$parafreq',parafreq)
        if(parafreq) 
     &   call getfile('MACHINES','localhost','localhost',info)

*=======================================================================
*=======================================================================
* HERE COME THE INPUT FILES
* CAUTION: always synchronize with islave.r, spawn.r, basic_input.r (okok)!!!
*=======================================================================
*=======================================================================

**=============================================
** modes 1-19 reserved for: TURBOMOLE
** (mode 10 is a test mode for parallelization)
**=============================================

        if(mode.gt.0.and.mode.lt.20.or.(mode.ge.60.and.mode.lt.70)) then

**------------------
** file no. 1: control                                           
**------------------

        call getfile('control','localhost','localhost',info)

        if(mode.lt.60) then
          call rcontrol(tempdir(1:lt)//'/control',rpast,smult,natoms,
     *    jscfc,isuhf,riflag)
        else
          call rcontrol(tempdir(1:lt)//'/control',rpast,smult,
     *    lastqmatom,jscfc,isuhf,riflag)
        end if

**------------------
** file no. 2: basis
**------------------

          call getfile('basis','localhost','localhost',info)

**---------------------
** file no. 3: auxbasis
**---------------------

          if(riflag.eq.1) then
            call getfile('auxbasis','localhost','localhost',info)
          end if

**------------------------------------
** file no. 4: mos or (alpha and beta)
**------------------------------------

          if(isuhf.eq.0) then
            call getfile('mos','localhost','localhost',info)
          else
            call getfile('alpha','localhost','localhost',info)
            call getfile('beta','localhost','localhost',info)
          end if

**=============================================
** modes 20-29 reserved for: DALTON
**=============================================

        else if(mode.ge.20.and.mode.lt.30) then
          call getfile('molecule.dal','localhost','localhost',info)

**=============================================
** modes 30-39 reserved for: GAUSSIAN
**=============================================

        else if(mode.ge.30.and.mode.lt.40) then
          call getfile('akira.com','localhost','localhost',info)

**=============================================
** modes 40-49 reserved for: ADF
**=============================================

        else if(mode.ge.40.and.mode.lt.50) then
          call getfile('adf.in','localhost','localhost',info)
          if(irescp.gt.0) then
             call llen(restadf,lres)
             call getfile(restadf(1:lres),'localhost','localhost',info)
          end if
          if(lastqmatom.ne.natoms) then
             call getfile('mm.restart','localhost','localhost',info)
          end if

**=============================================
** modes 50-59 reserved for: MOLPRO
** (to be implemented one day)
**=============================================

        end if
**=============================================
** modes 60-69 reserved for: COMQUM
**=============================================
        if(mode.ge.60.and.mode.lt.70) then
          info2=0
          call getfile('comqum.dat','localhost','localhost',info2)
          call getfile('pointcharges','localhost','localhost',info2)
          call getfile('prmcrd3','localhost','localhost',info2)
          call getfile('prmtop1','localhost','localhost',info2)
          call getfile('prmtop2','localhost','localhost',info2)
          call getfile('prmtop3','localhost','localhost',info2)
          call getfile('sander.in1','localhost','localhost',info2)
          call getfile('sander.in2','localhost','localhost',info2)
          call getfile('sander.in3','localhost','localhost',info2)
        end if

        WRITE (iosl,*) '** islave: got all program-specific input '
     *  //'files !! '
        CALL flush(iosl)


**=============================================
** now copy coord file
**============================================

        CALL getfile('coord','localhost','localhost',info)
        write(iosl,*) 'islave: coord copied, info=',info
        CALL flush(iosl)

c======================================================
c make backup copies  
c======================================================
        if (info.eq.okok) then
        if(mode.lt.20.or.(mode.ge.60.and.mode.lt.70)) then
         if (isuhf.eq.0) then
          call clean(b1)
          b1=tempdir(1:lt)//'/mos'
          call llen(b1,l)
          irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
         else
          call clean(b1)
          b1=tempdir(1:lt)//'/alpha'
          call llen(b1,l)
          irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
          call clean(b1)
          b1=tempdir(1:lt)//'/beta'
          call llen(b1,l)
          irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
         end if
        end if
         call clean(b1)
         b1=tempdir(1:lt)//'/coord'
         call llen(b1,l)
         irc=xeq('mv '//b1(1:l)//' '//b1(1:l)//'.ori')
          if(mode.ge.60.and.mode.lt.70) then
            call clean(b1)
            b1=tempdir(1:lt)//'/prmcrd3'
            call llen(b1,l)
            irc=xeq('mv '//b1(1:l)//' '//b1(1:l)//'.ori')
          end if
        end if
        write (iosl,*) '>>> input files copied, result is ',info
        call flush(iosl)
        iready=info
        if (iready.ne.okok.or.(mode.eq.60.and.info2.ne.okok2)) 
     &    call errex('** error while copying input files')
      else
*--------------------------------------------------------
* akira_control must be copied in every step, since it contains
* the new set of basis vectors
*--------------------------------------------------------
        info=0
        write (iosl,*) 'get new akira_control from ','localhost'
        call getfile('akira_control','localhost','localhost',info)
        if(info.ne.1)
     &    call errex('** error while copying new akira_control file')
      end if
 
100     call howmany_noprc(ize,ipe,stepfl)
        if(ize.eq.0 .and. ipe.eq.0) goto 101

*-----------------------
* determine current step
* CAUTION: at the beginning of the calculation, all
* unfinished steps must be set from -1 to 0 !!!
*-----------------------

        do i=1,nstept
          if(stepfl(i).eq.0) then
            isstep=i
            stepfl(i)=-1
            read(localhost(1:8),'(A8)') vmach(i)
            goto 91
          end if
          if(i.eq.nstept) goto 91
        end do
91      continue
       
        write(idbg,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>'
        write(idbg,'(1x,a,i5,a,a8)') '>>> AKIRA: starting step ',
     &    isstep,' on ',vmach(isstep)
        write(idbg,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>'
        call fdate(date)
        write(jtape,'(A,A,1X,A,A,I4,A,I4)')
     &    date,' (serial mode) -> ',masterid(1:9),' sending step',isstep
        call flush(jtape)

        call cslave(nbm)

      goto 100
101   continue

      return
      end
