#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      subroutine shutdown
*     ======================================================
*     modified by J. Neugebauer, Uni Erlangen, 2001
* 
*     migrate to MachineModule by J. Neugebauer, 2007
*     ======================================================

      use MachineModule

#include "defs.h"
#include "param.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

      type(type_machine), pointer :: mach,cmach
      integer i,k,xeq,tid,tpid,iwhat,info,l,mbuf
      character*255 cmd
      character*20 cpid
      character*40 myname
#ifdef AKIRA_MPI
      integer w
      data w /MPI_COMM_WORLD/
#endif
#ifdef DEBUG
      write (*,*) '@shutdown@ enter'
#endif

*     --------------------------
*     read last pending messages
*     --------------------------
      call fsys

*     ------------------------------------
*     send all slaves the terminate signal
*     ------------------------------------
      iwhat=-1
      nullify(mach)
      mach => machlist
      NodeLoop_: do 
        if(.not.associated(mach)) exit NodeLoop_
        select case(mach%nodf)
        case('dead','done')
          goto 951
        end select
        call getmach_name(mach,myname)
        nullify(cmach)
        call findnode_by_name(pvmmachlist,cmach,mach%name)
        k=mach%tid
        l=0
        if(associated(cmach)) l=cmach%usag
        if(k.gt.0) then
          write (idbg,*) 'shutdow| sending finish signal to tid ',k
#ifdef AKIRA_MPI
#ifdef AKIRA_MPI_SSEND
          call mpi_ssend(iwhat,1,mpi_integer,k,409,w,info)
          call mpierr('mpi_ssend iwhat','parstuff',info)
#else
          call mpi_send(iwhat,1,mpi_integer,k,409,w,info)
          call mpierr('mpi_send iwhat','parstuff',info)
#endif
#endif
#ifdef AKIRA_PVM
          call pvmfinitsend(pvmdatadefault,mbuf)
          call pvmfpack( integer4, iwhat, 1, 1, info )
          call pvmfsend(k, 0, info )
#endif
        end if
        if (l.gt.0) then
          write (jtape,'(''% work done on node '',a20,f10.2)')
     &      mach%name,100.*float(l)/float(nstept)
        end if
951     mach => mach%next
      end do NodeLoop_

#ifdef AKIRA_PVM
      nullify(mach)
      mach => machlist
      NodeLoop2_: do
        if(.not.associated(mach)) exit NodeLoop2_
        if (mach%tpid.gt.0) then
          tid=mach%tid
          tpid=mach%tpid
          call getmach_name(mach,myname)
          write (*,*) i,tid,tpid,' still running on ',myname
          write (cpid,'(i20)') tpid
          call clean(cmd)
          cmd='dc_killtask '//myname//' '//cpid//' tmp_dc_killtask'
          info=xeq(cmd)
        endif
        mach => mach%next
      end do NodeLoop2_
#endif
      return
      end
