#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

      subroutine spawn(machnumb,ktape)
*     ===========================================================
*     spawn process i
*     extended akira version using MachineModule by J. Neugebauer
*     based on original version by B.A. Hess
*
*     still needs to be done: change myname to mach%name
*     ===========================================================

      use MachineModule

#include "defs.h"
#include "param.h"

#ifdef AKIRA_PVM
#include "fpvm3.h"
#endif

#ifdef AKIRA_MPI
#include "mpif.h"
#endif

#ifdef AKIRA_MPI
      integer st(MPI_STATUS_SIZE)
#endif

      type(type_machine), pointer :: mach,qmach
      integer info,mbuf,machnumb
      integer*4 iready,kvers,iready2
      integer i,idum,j,l,ibuf,speed,newtid,ipe,iprc,w,ktape
      integer lsnfdc,lres
      character*40 myname,name
      character*255 tmpnode,lognode,newarch,b,snfdc
      logical parafreq,valmod
      integer iclean,icleanl

      call findnode_by_num(mach,machnumb)
      if(.not.associated(mach)) call errex('stale pointer in spawn')
      call print_node(mach,idbg)

*     ---------------------------------------------------
*     only spawn if node is waiting and cmd == 0
*     (cmd /= 0 means node is terminating/killed)
*     ---------------------------------------------------
      if(mach%nodf /= 'wait') return
      if(mach%cmd /= '----') then
        mach%nodf = 'remo'
        return
      end if

*     -----------------------------------
*     individually specified directories?
*     -----------------------------------
      call getmach_name(mach,myname)
      call llen(myname,l)
      call readv('TMPDIR('//myname(1:l)//')',tmpnode,tempdir)
      call readv('LOGDIR('//myname(1:l)//')',lognode,logdir)
      call readv('DCPATH('//myname(1:l)//')',snfdc,dcdir)
      call setmach_pmsg(mach,'spawn wait                              ')
      mach%nodf = 'unf'

      write (idbg,*) '@spawn@ spawning akira process #',
     * mach%numb,' on ',myname(1:l)

#ifdef AKIRA_MPI
      newtid=mach%tid
#endif

#ifdef AKIRA_PVM
*     -----------------------------------------------------
*     host already member of virtual machine ?
*     (i.e., is it in the pvmmch list ?)
*
*     check if there is a node entry in the virtual machine
*     => loop over nodes in pvmmch list
*     -----------------------------------------------------
      nullify(qmach)
      qmach => pvmmachlist
      PVMmachines_: do
        if(.not.associated(qmach)) then
       
*         ----------------------------------------------
*         no; try to add the node to the virtual machine
*         ----------------------------------------------
          write (idbg,*) 'spawn  | adding ',myname(1:l),' to PVM'
          call pvmfaddhost(myname(1:l),info)
       
          if (info.lt.0) then
            write (jtape,*) myname(1:l),': cannot add node to PVM'
            mach%nodf = 'pvme'
            return
          else
            write (idbg,*) 'spawn  | ... added ',myname(1:l),' to PVM'
          end if
       
*         ----------------------------------------------
*         add node to list of PVM members and exit loop
*         ----------------------------------------------
          call add_node(pvmmachlist,myname(1:l),' ')
          current_mach%mxlo=150
          exit PVMmachines_
       
        end if
       
*       -----------------------------------------------------------
*       get name of PVM machine at q and compare to <myname>
*       -----------------------------------------------------------
        if (qmach%name.eq.myname) then
          write (idbg,*) 'spawn  | machine already in vm : ',myname(1:l)
          exit PVMmachines_
        end if
        qmach => qmach%next
       
      end do PVMmachines_

      call llen(snfdc,lsnfdc)
      write (idbg,*) '@spawn@ ',snfdc(1:lsnfdc)
      write(*,*) 'akira: ',snfdc(1:lsnfdc)
      call pvmfspawn(snfdc(1:lsnfdc),pvmhost, myname(1:l),1,newtid,info)
      write (idbg,*) '@spawn@ return: tid=',newtid,' info=',info
      call flush(idbg)
      if (info.lt.0.oR.newtid.LT.0) then
        write (jtape,*) '*Error* pvmfspawn ',myname(1:l)
        write (jtape,*) '*Error* newtid=',newtid,' info=',info
        if(newtid .lt. 0) then
          write (jtape,*) '* newtid < 0 may indicate that your akira-'
          write (jtape,*) '  binary is not in the default PVM-PATH '
        end if
        if(info .lt. 0) then
          write (jtape,*) '* info < 0 indicates communication problems'
          write (jtape,*) '  (e.g., very slow network, pvm abort etc.)'
        end if
        call setmach_pmsg(mach,'comm problems                        ')
        call pvmfperror('spawn',info)
        return
      endif

      mach%tid = newtid
#endif

#ifdef DEBUG
      write (*,*) '@spawn@ spawning process for tid ',newtid
#endif
      call pputstr('spawn: logdir',logdir,newtid,255,401,info)
      call pputstr('spawn: turbodir',turbodir,newtid,255,402,info)
      call pputstr('spawn: arpath',arpath,newtid,255,403,info)
      call pputstr('spawn: masterid',masterid,newtid,255,404,info)
      call pputstr('spawn: tmpnode',tmpnode,newtid,255,405,info)
      call pputstr('spawn: mydir',mydir,newtid,255,406,info)
      call pputstr('spawn: masternode',masternode,newtid,40,407,info)
#ifdef AKIRA_MPI
      call pgetstr('spawn: myname',myname,newtid,40,408,info)
      call setmach_name(mach,myname)
#endif
#ifdef AKIRA_PVM
      call pputstr('spawn: myname',myname,newtid,40,408,info)
#endif

#ifndef SNF_SCP
** akira_control

      call sfile('akira_control',newtid,info)
      parafreq=.false.

      call rakiractrl('akira_control',rthres,rabsthres,dvthres,ecthres,
     *  roothmpr,g98it,g98bs,xmolout,tmout,printall,precond,genstart,
     *  rchthres,minnbt,iorth,snfout,natoms,mode,cstep,naus,iclean,
     *  icleanl,idbg,ipol,lastqmatom,irescp,restadf,sleeptime)

      write (idbg,*) 'spawn: read akira_control, mode is ',mode
      call flush(idbg)

      if (.not.valmod(mode)) then
        write(idbg,*) 'spawn: No such program mode: ',mode
        stop
      end if

** MACHINES (for parallel turbomole run)

      call rkeywd('akira_control','$parafreq',parafreq)
      if(parafreq) call sfile('MACHINES',newtid,info)

*==============================================================================
* HERE GO THE INPUT FILES ...
* CAUTION: always synchronize with islave.r, serstuff.r, basic_input.r (okok) !
*==============================================================================

**=============================================
** modes 1-19 reserved for: TURBOMOLE 
** and COMQUM (Turbomole + Amber QM/MM interface)
** (mode 10 is a test mode for parallelization)
** NOTE: control is already copied here
**=============================================

      if(mode.gt.0.and.mode.lt.20.or.(mode.gt.60.and.mode.lt.70)) then

**------------------
** file no. 1: control
**------------------

        call sfile('control',newtid,info)

        if(mode.lt.60) then
          call rcontrol('control',rpast,smult,natoms,
     *    jscfc,isuhf,riflag)
        else
          call rcontrol('control',rpast,smult,lastqmatom,
     *    jscfc,isuhf,riflag)
        end if


**------------------
** file no. 2: basis
**------------------

        call sfile('basis',newtid,info)

**---------------------
** file no. 3: auxbasis
**---------------------

        if(riflag.eq.1) call sfile('auxbasis',newtid,info)


**------------------------------------
** file no. 4: mos or (alpha and beta)
**------------------------------------

        if(isuhf.eq.0) then
          call sfile('mos',newtid,info)
        else
          call sfile('alpha',newtid,info)
          call sfile('alpha',newtid,info)
        end if

**=============================================
** modes 20-29 reserved for: DALTON
**=============================================

      else if(mode.ge.20.and.mode.lt.30) then
        call sfile('molecule.dal',newtid,info)


**=============================================
** modes 30-39 reserved for: GAUSSIAN
**=============================================

      else if(mode.ge.30.and.mode.lt.40) then
        call sfile('akira.com',newtid,info)

**=============================================
** modes 40-49 reserved for: ADF
**=============================================

      else if(mode.ge.40.and.mode.lt.50) then
        call sfile('adf.in',newtid,info)
        if(irescp.gt.0) then
           call llen(restadf,lres)
           call sfile(restadf(1:lres),newtid,info)
        end if
CCH        if(lastqmatom.ne.natoms) then
CCH          call sfile('mm.restart',newtid,info)
CCH        end if
**=============================================
** modes 50-59 reserved for: MOLPRO
** (to be implemented one day)
**=============================================

**=============================================
** modes 60-69 reserved for: COMQUM
**=============================================
      else if(mode.ge.60.and.mode.lt.70) then
        call sfile('comqum.dat',newtid,info)
        call sfile('pointcharges',newtid,info)
        call sfile('prmcrd3',newtid,info)
        call sfile('prmtop1',newtid,info)
        call sfile('prmtop2',newtid,info)
        call sfile('prmtop3',newtid,info)
        call sfile('sander.in1',newtid,info)
        call sfile('sander.in2',newtid,info)
        call sfile('sander.in3',newtid,info)
      end if

      write (idbg,*) 'spawn  | sent program-specific input files'

      call sfile('coord',newtid,info)
#endif
      write (idbg,*) 'spawn  | waiting for answer from ',newtid
      call flush(idbg)
#ifdef AKIRA_MPI
      w=MPI_COMM_WORLD
      call MPI_RECV(iready,1,MPI_INTEGER,newtid,407,w,st,info)
      call mpierr('MPI_RECV iready','spawnmpi',info)
      if(mode.eq.60) then
        call MPI_RECV(iready2,1,MPI_INTEGER,newtid,407,w,st,info)
        call mpierr('MPI_RECV iready2','spawnmpi',info)
      end if
      call MPI_RECV(kvers,1,MPI_INTEGER,newtid,408,w,st,info)
      call mpierr('MPI_RECV kvers','spawnmpi',info)
#endif

#ifdef AKIRA_PVM
      call PVMFRECV(newtid,0,ibuf)
      call PVMFUNPACK(INTEGER4,iready,1,1,info)
      if(mode.eq.60) call PVMFUNPACK(INTEGER4,iready2,1,1,info)
      kvers=0
      call PVMFUNPACK(INTEGER4,kvers,1,1,info)
#endif
      write (ktape,*) myname,' ',newtid,' ',iready,kvers
      write (idbg,*) 'node with tid: ',newtid,' is: ',myname,' ',iready,
     & kvers
      write (idbg,*) 'iready, okok: ', iready, okok
      if(mode.eq.60) write (idbg,*) 'iready2, okok2: ', iready2, okok2
      call flush(idbg)
      if (iready.eq.okok) then
        mach%nodf = 'rdy'
        write (idbg,*) 'input successfully completed, node is ready'
      else
        write (idbg,*) 'copying of input files incomplete, '//
     *                 'node not ready'
      end if
      call flush(idbg)

      return
      end
