      subroutine getsymelmat(symel,symelmat)
*-----------------------------------------------------------------
* all subroutines are based on the corresponding F90 subroutines
* by C. Kind and J. Neugebauer from the SNF package.
*
* all subroutines written by J. Neugebauer, Uni Erlangen, 2003
*-----------------------------------------------------------------
      implicit none
      integer ipos,ax_order,ndreh,ls,ax_number
      real*8 symelmat(3,3)
      character(len=132) errbuff
      character*7 symel
      external slen
      if(index('ijop',symel(1:1)).ne.0) then
        ax_order=index('1234567890',symel(3:3))
        ndreh=index('123456789',symel(2:2))
        ax_number=10*index('123456789',symel(4:4))+
     *            index('123456789',symel(5:5))
        if(ax_order*ndreh*ax_number.eq.0) then
          call clean(errbuff)
          write(errbuff,*) 'Could not find symmetry element: ',symel
          call serror('symel_mat',2,errbuff,6)
        end if
        call icsym(symelmat,ax_order,ndreh,ax_number,symel(1:1))
      else
        if(.not.symel(1:2).eq.'sh') then
          ipos=index(symel,'_')+1
          if(ipos.eq.5) then
            read(symel(3:3),'(i1)') ax_order
          else if(ipos.eq.6) then
            read(symel(3:4),'(i2)') ax_order
          else 
            call serror('getsymelmat',2,'Unknown symmetry element',6)
          end if
          call slen(symel,ls)
          if(ls.eq.ipos) then
            read(symel(ipos:ls),'(i1)') ndreh
          else if(ls.eq.ipos+1) then
            read(symel(ipos:ls),'(i2)') ndreh
          else 
            call serror('getsymelmat',2,'Unknown symmetry element',6)
          end if
        end if
        if(symel(1:2).eq.'cz') then
          call cnz(symelmat,ax_order,ndreh)
        else if(symel(1:2).eq.'sz') then
          call snz(symelmat,ax_order,ndreh)
        else if(symel(1:2).eq.'cx') then
          call c2x(symelmat,ax_order,ndreh)
        else if(symel(1:2).eq.'cy') then
          call c2y(symelmat,ax_order,ndreh)
        else if(symel(1:2).eq.'sv') then
          call sigmav(symelmat,ax_order,ndreh)
        else if(symel(1:2).eq.'sd') then
          call sigmad(symelmat,ax_order,ndreh)
        else if(symel(1:2).eq.'sh') then
          call sigmah(symelmat)
        end if
      end if
      end

*-------------------------------------------
* C_n^p
*-------------------------------------------
      subroutine cnz(cnz_p,ax_order,ndreh)
      implicit none
#include "fconstants.h"
      integer ax_order,ndreh
      real*8 cnz_p(3,3)

      cnz_p(1,1)= cos(dble(ndreh)*2.0d0*pi/dble(ax_order))
      cnz_p(1,2)=-sin(dble(ndreh)*2.0d0*pi/dble(ax_order))
      
      cnz_p(1,3)= 0.d0
      cnz_p(2,1)=-cnz_p(1,2)
      cnz_p(2,2)= cnz_p(1,1)
      cnz_p(2,3)= 0.d0
      cnz_p(3,1)= 0.d0
      cnz_p(3,2)= 0.d0
      cnz_p(3,3)= 1.d0
      end

*-------------------------------------------
* S_n
*-------------------------------------------
      subroutine snz(snz_p,ax_order,ndreh)
      implicit none
      integer ax_order,ndreh
      real*8 snz_p(3,3)
      call cnz(snz_p,ax_order,ndreh)
      snz_p(3,3)=-1.d0
      end

*-------------------------------------------
* C_2(x)^p
*-------------------------------------------
      subroutine c2x(c2x_p,ax_order,ndreh)
      implicit none
      integer ax_order,ndreh
      real*8 c2x_p(3,3),hmat(3,3),tmat(3,3),cx2mat(3,3)
      data cx2mat
     * / 1.0d0, 0.0d0, 0.0d0,
     *   0.0d0,-1.0d0, 0.0d0,
     *   0.0d0, 0.0d0,-1.0d0 /
      call cnz(hmat,2*ax_order,ndreh)
      call matmul3d('t','n',hmat,cx2mat,tmat)
      call matmul3d('n','n',tmat,hmat,c2x_p)
      end

*-------------------------------------------
* C_2(y)^p
*-------------------------------------------
      subroutine c2y(c2y_p,ax_order,ndreh)
      implicit none
      integer ax_order,ndreh
      real*8 c2y_p(3,3),hmat(3,3),tmat(3,3),cy2mat(3,3)
      data cy2mat
     * / 1.0d0, 0.0d0, 0.0d0,
     *   0.0d0,-1.0d0, 0.0d0,
     *   0.0d0, 0.0d0,-1.0d0 /
      call cnz(hmat,2*ax_order,2*ndreh+1)
      call matmul3d('t','n',hmat,cy2mat,tmat)
      call matmul3d('n','n',tmat,hmat,c2y_p)
      end

*-------------------------------------------
* sigma_v
*-------------------------------------------
      subroutine sigmav(smat,ax_order,ndreh)
      implicit none
      integer ax_order,ndreh
      real*8 smat(3,3),hmat(3,3),tmat(3,3),sxzmat(3,3)
      data sxzmat
     * / 1.0d0, 0.0d0, 0.0d0,
     *   0.0d0,-1.0d0, 0.0d0,
     *   0.0d0, 0.0d0, 1.0d0 /
      call cnz(hmat,ax_order,ndreh)
      call matmul3d('t','n',hmat,sxzmat,tmat)
      call matmul3d('n','n',tmat,hmat,smat)
      end

*-------------------------------------------
* sigma_d
*-------------------------------------------
      subroutine sigmad(smat,ax_order,ndreh)
      implicit none
      integer ax_order,ndreh
      real*8 smat(3,3),hmat(3,3),tmat(3,3),sxzmat(3,3)
      data sxzmat
     * / 1.0d0, 0.0d0, 0.0d0,
     *   0.0d0,-1.0d0, 0.0d0,
     *   0.0d0, 0.0d0, 1.0d0 /
      call cnz(hmat,2*ax_order,2*ndreh+1)
      call matmul3d('t','n',hmat,sxzmat,tmat)
      call matmul3d('n','n',tmat,hmat,smat)
      end

*-------------------------------------------
* sigma_h
*-------------------------------------------
      subroutine sigmah(smat)
      implicit none
      integer i,j
      real*8 smat(3,3),shmat(3,3)
      data shmat
     * / 1.0d0, 0.0d0, 0.0d0,
     *   0.0d0, 1.0d0, 0.0d0,
     *   0.0d0, 0.0d0,-1.0d0 /
      do i=1,3
        do j=1,3
          smat(i,j)=shmat(i,j)
        end do
      end do
      end

*----------------------------------------------------------------------------

      subroutine icsym(smat,ax_order,ndreh,ax_number,ijc)
*----------------------------------------------------------------------------
* this function provides the transformation matrices for the symmtry elements
* of icosahedral and cubic point groups. The coordinates specify points
* which define - together with O(0,0,0) - rotation axes.
*
* written by J. Neugebauer, Universitaet Erlangen-Nuernberg, 05/2001
* F77 version by J. Neugebauer, Universitaet Erlangen-Nuernberg, 05/2003
*----------------------------------------------------------------------------
      implicit none
#include "fconstants.h"
      real*8 c3i(3,10),c2i(3,15),c5i(3,6)
      real*8 phi,c4o(3,3),c2o(3,6),c3o(3,4),smat(3,3)
      integer i,j
      character*1 ijc
      integer ax_order,ax_number,ndreh

      data ((c2i(i,j),i=1,3),j=1,15)
     */0.42532540417602d0,-0.30901699437495d0, 0.85065080835204d0,
     * 0.42532540417602d0, 0.30901699437495d0, 0.85065080835204d0,
     *-0.16245984811645d0, 0.50000000000000d0, 0.85065080835204d0,
     *-0.52573111211913d0, 0.00000000000000d0, 0.85065080835204d0,
     *-0.16245984811645d0,-0.50000000000000d0, 0.85065080835204d0,
     * 0.85065080835204d0, 0.00000000000000d0, 0.52573111211913d0,
     * 0.26286555605957d0, 0.80901699437495d0, 0.52573111211914d0,
     *-0.68819096023559d0, 0.50000000000000d0, 0.52573111211913d0,
     *-0.68819096023559d0,-0.50000000000000d0, 0.52573111211913d0,
     * 0.26286555605957d0,-0.80901699437495d0, 0.52573111211914d0,
     * 0.58778525229247d0,-0.80901699437495d0, 0.00000000000000d0,
     * 0.95105651629515d0,-0.30901699437494d0, 0.00000000000000d0,
     * 0.95105651629515d0, 0.30901699437494d0, 0.00000000000000d0,
     * 0.58778525229247d0, 0.80901699437495d0, 0.00000000000000d0,
     * 0.00000000000000d0, 1.00000000000000d0, 0.00000000000000d0/
      data ((c3i(i,j),i=1,3),j=1,10)
     */0.60706199820669d0, 0.00000000000000d0, 0.79465447229177d0,
     * 0.18759247408508d0, 0.57735026918962d0, 0.79465447229177d0,
     *-0.49112347318842d0, 0.35682208977309d0, 0.79465447229177d0,
     *-0.49112347318842d0,-0.35682208977309d0, 0.79465447229177d0,
     * 0.18759247408508d0,-0.57735026918962d0, 0.79465447229177d0,
     * 0.79465447229177d0,-0.57735026918962d0,-0.18759247408508d0,
     * 0.98224694637685d0, 0.00000000000000d0, 0.18759247408508d0,
     * 0.79465447229177d0, 0.57735026918962d0,-0.18759247408508d0,
     * 0.30353099910334d0, 0.93417235896272d0, 0.18759247408508d0,
     *-0.30353099910334d0, 0.93417235896272d0,-0.18759247408508d0/
      data ((c5i(i,j),i=1,3),j=1,6)
     */0.00000000000000d0, 0.00000000000000d0, 1.00000000000000d0,
     * 0.72360679774998d0,-0.52573111211913d0, 0.44721359549996d0,
     * 0.72360679774998d0, 0.52573111211913d0, 0.44721359549996d0,
     *-0.27639320225002d0, 0.85065080835204d0, 0.44721359549996d0,
     *-0.89442719099992d0, 0.00000000000000d0, 0.44721359549996d0,
     *-0.27639320225002d0,-0.85065080835204d0, 0.44721359549996d0/
      data ((c4o(i,j),i=1,3),j=1,3)
     */1.00000000000000d0, 0.00000000000000d0, 0.00000000000000d0,
     * 0.00000000000000d0, 1.00000000000000d0, 0.00000000000000d0,
     * 0.00000000000000d0, 0.00000000000000d0, 1.00000000000000d0/
      data ((c2o(i,j),i=1,3),j=1,6)
     */1.00000000000000d0, 1.00000000000000d0, 0.00000000000000d0,
     *-1.00000000000000d0, 1.00000000000000d0, 0.00000000000000d0,
     * 1.00000000000000d0, 0.00000000000000d0, 1.00000000000000d0, 
     * 0.00000000000000d0,-1.00000000000000d0,-1.00000000000000d0, 
     * 1.00000000000000d0, 0.00000000000000d0,-1.00000000000000d0, 
     * 0.00000000000000d0,-1.00000000000000d0, 1.00000000000000d0/
      data ((c3o(i,j),i=1,3),j=1,4)
     */1.00000000000000d0, 1.00000000000000d0, 1.00000000000000d0,
     * 1.00000000000000d0, 1.00000000000000d0,-1.00000000000000d0, 
     * 1.00000000000000d0,-1.00000000000000d0,-1.00000000000000d0, 
     *-1.00000000000000d0, 1.00000000000000d0,-1.00000000000000d0/

      phi=2.d0*pi*dble(ndreh)/dble(ax_order)
      if(ijc.eq.'i') then
        if(ax_order.eq.2) then
          call initrtm(c2i(1,ax_number),phi,smat)
        else if(ax_order.eq.3) then
          call initrtm(c3i(1,ax_number),phi,smat)
        else if(ax_order.eq.5) then
          call initrtm(c5i(1,ax_number),phi,smat)
        else
          call serror('icsym',2,'No such symmetry element!',6)
        end if
      else if(ijc.eq.'j') then
        if(ax_order.eq.1) then
          call rotref(c2i(1,ax_number),phi,smat)
        else if(ax_order.eq.6) then
          call rotref(c3i(1,ax_number),phi,smat)
        else if(ax_order.eq.10) then
          call rotref(c5i(1,ax_number),phi,smat)
        else
          call serror('icsym',2,'No such symmetry element!',6)
        end if
      else if(ijc.eq.'o') then
        if(ax_order.eq.2) then
          call initrtm(c2o(1,ax_number),phi,smat)
        else if(ax_order.eq.3) then
          call initrtm(c3o(1,ax_number),phi,smat)
        else if(ax_order.eq.4) then
          call initrtm(c4o(1,ax_number),phi,smat)
        else
          call serror('icsym',2,'No such symmetry element!',6)
        end if
      else if(ijc.eq.'p') then
        if(ax_order.eq.1) then
          call rotref(c2o(1,ax_number),phi,smat)
        else if(ax_order.eq.6) then
          call rotref(c3o(1,ax_number),phi,smat)
        else if(ax_order.eq.4) then
          call rotref(c4o(1,ax_number),phi,smat)
        else 
          call serror('icsym',2,'No such symmetry element!',6)
        end if
      else
        call serror('icsym',2,'No such symmetry element!',6)
      end if
      end

c------------------------------------------------------------------

      subroutine initrtm(ps2,phi,rotm)
 
c-------------------------------------------------------------------
c sets up the rotation matrix for a rotation by an angle phi [rad]
c around an axis defined by the points O(0,0,0) and ps(x,y,z)
c
c source: Simon L. Altmann, Peter Herzig, Point-Group Theory Tables,
c         Oxford Science Publications, Clarendon Press, Oxford 1994,
c         p. 57.
c
c written by J. Neugebauer 05/2001
c-------------------------------------------------------------------
      implicit none
#include "fconstants.h"
      double precision   ps(3),s1,s2,ps2(3)
      double precision   phi,sin,length
      double precision   rotm(3,3)
      integer i,j
      logical pflag
      parameter (pflag=.false.)
      intrinsic sin
    
      s1=sin(phi/2.0d0)
      s1=2.d0*s1**2
    
      s2=sin(phi)
      length=sqrt(ps2(1)**2+ps2(2)**2+ps2(3)**2)
      if(length.le.1.d-14) then
        call serror('initrtm',2,'rotation setup failed since P1 = 0',6)
      end if
      do i=1,3
        ps(i)=ps2(i)/length
      end do
 
c------------------------------------------------------------------
c set up rotation matrix
c------------------------------------------------------------------
 
      rotm(1,1)=1.d0-(ps(2)**2+ps(3)**2)*s1
      rotm(1,2)=-ps(3)*s2+ps(1)*ps(2)*s1
      rotm(1,3)= ps(2)*s2+ps(3)*ps(1)*s1
      rotm(2,1)= ps(3)*s2+ps(1)*ps(2)*s1
      rotm(2,2)=1.d0-(ps(3)**2+ps(1)**2)*s1
      rotm(2,3)=-ps(1)*s2+ps(2)*ps(3)*s1
      rotm(3,1)=-ps(2)*s2+ps(3)*ps(1)*s1
      rotm(3,2)= ps(1)*s2+ps(2)*ps(3)*s1
      rotm(3,3)=1.d0-(ps(1)**2+ps(2)**2)*s1
 
c------------------------------------------------------------------
c write rotation matrix if pflag is set
c------------------------------------------------------------------
 
      if(pflag) then
        write(*,*)
        write(*,*)
        write(*,'(a,3f20.14)') 'Rot. matrix ',(ps(i),i=1,3)
        write(*,'(a,f20.14,a)') 'phi = ', phi/2.d0/pi*360,''
        write(*,'(a)') '------------------------------'
        do i=1,3
          write(*,'(3f20.14)') (rotm(i,j),j=1,3)
        end do
      end if
    
      end

*************************************************************

      subroutine rotref(ps,phi,rotm)
c--------------------------------------------------------------------
c sets up the matrix for an operation 
c Sn^k (==> angle phi = 2*pi*k/n) 
c around an axis defined by the points O(0,0,0) and ps
c
c source: Simon L. Altmann, Peter Herzig, Point-Group Theory Tables,
c         Oxford Science Publications, Clarendon Press, Oxford 1994,
c         p. 57.
c
c written by J. Neugebauer 05/2001
c Fortran 77 version by J. Neugebauer, 02/2002
c-------------------------------------------------------------------
  
      implicit none
#include "fconstants.h"
      double precision ps(3),p2p,p2m,py(3),pz(3)
      double precision sin,mirz(3,3),rotsy(3,3),rotsz(3,3),auxm(3,3)
      double precision rota(3,3),phim,thetam,atan,mirphi(3,3),rotm(3,3)
      double precision ps2(3),length,scr1,sqrt,asin,acos,phi
      double precision tmat1(3,3),tmat2(3,3)
      logical pflag
      parameter(pflag=.false.)
      intrinsic sin,atan,sqrt,asin,acos
      integer i,j,n,k
  
c-------------------------------------------------------------------
c 1. choose xy-plane as mirror plane. 
c 2. rotate mirror plane by an angle phim around y-axis, then
c 3. by an angle thetam around z-axis to get the mirror plane 
c    perpendicular to the rotation axis. 
c 4. perform rotation and reflection.
c-------------------------------------------------------------------

c------------------------------------------------------------------
c 1.
c------------------------------------------------------------------

      data ((mirz(i,j),i=1,3),j=1,3) 
     * / 1.d0, 0.d0, 0.d0, 
     *   0.d0, 1.d0, 0.d0, 
     *   0.d0, 0.d0,-1.d0 /
   
c------------------------------------------------------------------
c 2.
c------------------------------------------------------------------

      data py / 0.d0, 1.d0, 0.d0 /
      data pz / 0.d0, 0.d0, 1.d0 /
   
c-------------------------------------------------------------------
c set up matrix for rotation of mirror plane (xy as defined by mirz)
c around y-axis; rotation angle phim = angle between choosen 
c rotation axis and z-axis
c-------------------------------------------------------------------

      length=sqrt(ps(1)**2+ps(2)**2+ps(3)**2)
      if(length.le.1.d-14) then
        write (*,*) 'ERROR! ps = O = (0,0,0)'
        stop
      end if

      scr1=sqrt(ps(1)**2+ps(2)**2)

      phim=-sign(1.d0,ps(3))*asin(scr1/length)
      call initrtm(py,phim,rotsy)
      
C      auxm=matmul(matmul(transpose(rotsy),mirz),rotsy)
      call matmul3d('t','n',rotsy,mirz,tmat1)
      call matmul3d('n','n',tmat1,rotsy,auxm)
      if(pflag) then
        write(*,*)
        write(*,*)
        write(*,'(a,3f20.14)') 'Intermediate Reflection matrix ',
     *   (ps(i),i=1,3)
        write(*,'(a)') '------------------------------'
        do i=1,3
          write(*,'(3f20.14)') (auxm(i,j),j=1,3)
        end do 
      end if
   
c-------------------------------------------------------------------
c set up matrix for rotation of mirror plane (xy as defined by mirz)
c around z-axis; rotation angle phim = arctan(ps(1)/ps(3))
c-------------------------------------------------------------------

       if(scr1.le.1.d-14) then
         thetam=0.d0
       else
         thetam=-sign(1.d0,ps(2))*acos(ps(1)/scr1)
       end if
       call initrtm(pz,thetam,rotsz)
       
C       mirphi=matmul(matmul(transpose(rotsz),auxm),rotsz)
       call matmul3d('t','n',rotsz,auxm,tmat1)
       call matmul3d('n','n',tmat1,rotsz,mirphi)
       if(pflag) then
         write(*,*)
         write(*,*)
         write(*,'(a,3f20.14)') 'Reflection matrix ',(ps(i),i=1,3)
         write(*,'(a)') '------------------------------'
         do i=1,3
           write(*,'(3f20.14)') (mirphi(i,j),j=1,3)
         end do 
       end if

c------------------------------------------------------------------
c 3.
c------------------------------------------------------------------

c------------------------------------------------------------------
c set up rotation matrix
c------------------------------------------------------------------

      do i=1,3
        ps2(i)=ps(i)/length
      end do
      call initrtm(ps2,phi,rota)


c------------------------------------------------------------------
c 4.
c------------------------------------------------------------------
C      rotm = matmul(mirphi,rota)
      call matmul3d('n','n',mirphi,rota,rotm)
      if(pflag) then
        write(*,*)
        write(*,*)
        write(*,'(a,3f20.14)') 'Rot. matrix ',(ps(i),i=1,3)
        write(*,'(a,i4,a,i4)') 'Sn^k, n = ',n,' k = ',k
        write(*,'(a)') '------------------------------'
      end if
      do i=1,3
        if(pflag) write(*,'(3f20.14)') (rotm(i,j),j=1,3)
      end do
 
      return
      end 
