      subroutine symmc(natoms,coord,ic,dvec,dsvec,nbmf,count)
*-----------------------------------------------------------
* generate symmetry coordinates for this molecule
*
* written by J. Neugebauer, Uni Erlangen, 2003
*-----------------------------------------------------------
      implicit none
      integer natoms,nsymel,i,j,mxnsymel,l,il,iat
      integer mxirrep,nirrep,selir,nbmf
      parameter(mxnsymel=120,mxirrep=12)
      real*8 coord(3,natoms),dvec(3,natoms,nbmf),dotprod,sqrt
      real*8 dsvec(3,natoms),char(mxnsymel,mxirrep),zthres,ovl
      parameter(zthres=1.d-6)
      integer ic(natoms),count
      character*132 buf
      character*7 symel(mxnsymel)
      character*5 irrep(mxirrep)
      character*3 symmetry
      logical para
      intrinsic sqrt
      external dotprod

      count=0
*---------------------
* determine symmetry
*---------------------
      write(*,*)
      write(*,*) ' Enter symmetry of molecule: '
      read(*,*) buf
      symmetry=buf(1:3)
      call getchar(symmetry,nirrep,irrep,symel,char,nsymel,mxnsymel,
     * mxirrep)
      
10    write(*,*)
      write(*,*) ' Please select one of the following irreps'
      write(*,*) ' by typing the corresponding number: '
      write(*,*)

      do i=1,nirrep
        write(*,'(i3,3x,a5)') i,irrep(i)
      end do
      write(*,*)
      read(*,*,err=10,end=10) selir
      if(selir.lt.1.or.selir.gt.nirrep) then
        write(*,*) 'Invalid irrep no.'
        goto 10
      end if

      do 100 l=1,3*natoms
        count=count+1
        do i=1,natoms
          do j=1,3
            dvec(j,i,count)=0.0d0
            dsvec(j,i)=0.0d0
          end do
        end do
        iat=(l+2)/3
        il=l-3*(iat-1)
        dsvec(il,iat)=1.0d0
C        call printdmat(dsvec,3,natoms,'initial vector','f14.7',6)

        call projector(natoms,coord,nsymel,symel,dvec(1,1,count),dsvec,
     *    char(1,selir))
        if(sqrt(dotprod(dvec(1,1,count),dvec(1,1,count),3*natoms)).lt.
     *    zthres) then
          write(*,*) 'Zero vector is removed from set'
          count=count-1
        else
          write(*,*)'Orthogonalization of new symmetry basis vector ...'
          do i=1,count-1
            call gramschmidt(dvec(1,1,i),dvec(1,1,count),3*natoms,para,
     &        ovl,zthres)
            if(para) then
              write(*,'(2x,a)')
     *         'Linear dependence detected for new basis vector'
              write(*,*)
               write(*,'(2x,a)')
     *           'I will remove this vector from the basis set'
              count=count-1
              goto 100
            end if
          end do
        end if
100   end do

      write(*,*) 'No. of basis vectors found in this irrep: ',count
      end
