      subroutine wdal(tdr,jstepa,natoms,ic,co)
  
*     written by J. Neugebauer, Uni Erlangen, 2002

#include "defs.h"
      integer info, system,ounit,ltd,jstepa,natoms,ldmn,ic(natoms)
      character*(*) tdr
      character*255 tmpc,fname
      character*24 dmname
      real*8 co(3,natoms)
      parameter(ounit=1)
      logical ex
* variables for basis set
      integer mxatt,mxl,mxc,mxp
      parameter(mxatt=20,mxl=7,mxc=20,mxp=30)
      integer natt,nlqz(mxatt),ncon(mxl,mxatt),nprim(mxc,mxl,mxatt)
      integer ibc(mxatt),lqn(mxl,mxatt)
      real*8 coef(mxp,mxc,mxl,mxatt),expo(mxp,mxc,mxl,mxatt)

 
      call llen(tdr,ltd)
*      inquire(file='mos',exist=ex)
*      if(ex) then
*        call rmfile2('mos.tmp',1)
*        info=system('mv mos mos.tmp')
*        if(info.ne.0) goto 900
*      end if
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.MOPUN'
      call rmfile2(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.dalton'
      call rmfile2(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.mol'
      call rmfile2(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/basedscript.tmp'
      call rmfile2(fname,1)
      write(iosl,*) 'wdal: calling rbas'
      call rbas(mxatt,mxl,mxc,mxp,natt,nlqz,ncon,nprim,coef,expo,tdr,
     * ibc,lqn)
      call wdalton(tdr,natoms,co,ic,mxatt,mxl,mxc,mxp,natt,nlqz,ncon,
     * nprim,coef,expo,jstepa,ibc)
      open(unit=ounit,file=fname)
       call augnum(dmname,'molecule',jstepa)
       call llen(dmname,ldmn)
       tmpc='cp '//tdr(1:ltd)//'/molecule.dal '
     * //tdr(1:ltd)//'/'//dmname(1:ldmn)//'.dal'
       write(ounit,'(a)') tmpc
      close(ounit)
      call exscript(fname,info)
      write(iosl,*) 'exit from wdal'
      return
900   write(iosl,*) '** wdal: error while creating molecule.mol'
      stop
      end

*************************************************************************
 
      subroutine exscript(rfile,info)
*
*     make script rfile executable and execute it.
*
*     written by J. Neugebauer, University of Erlangen, 2001
 
#include "defs.h"
      character*(*) rfile
      character*255 tmpchar
      integer info,system,lrfile
      logical ex
 
      call llen(rfile,lrfile)
      call clean(tmpchar)
      tmpchar='chmod u+x '//rfile(1:lrfile)
      info=system(tmpchar)
      if(info.ne.0) goto 900
      write(iosl,'(2a)') '** exscript: executing ',rfile(1:lrfile)
      write(*,'(72(''*''))')
      info=system(rfile(1:lrfile))
      if(info.ne.0) goto 900
      write(iosl,'(72(''*''))')
      return
900   write(iosl,'(2a)') '** exscript: could not execute ',
     *rfile(1:lrfile)
C      stop
      end
 
C************************************************************************
 
      subroutine rmfile2(rfile,mode)
*
*     if rfile exists, then remove it. if mode = 1, move file to file.bak
*
*     written by J. Neugebauer, University of Erlangen, 2001
 
#include "defs.h"
      character*(*) rfile
      character*255 tmpchar,tmptxt
      integer mode,info,system,lrfile,ltxt
      logical ex
 
      call llen(rfile,lrfile)
      inquire(file=rfile(1:lrfile),exist=ex)
      call clean(tmpchar)
      if(ex) then
        if(mode.eq.1) then
          call clean(tmptxt)
          tmptxt=rfile(1:lrfile)//' to '//rfile(1:lrfile)//'.bak'
          call llen(tmptxt,ltxt)
          write(iosl,'(2a)') '** rmfile2: moving file ',tmptxt(1:ltxt)
          tmpchar='mv '//rfile(1:lrfile)//' '//rfile(1:lrfile)//'.bak'
          info=system(tmpchar)
        else
         write(iosl,'(2a)') '** rmfile2: removing file ',rfile(1:lrfile)
         tmpchar='rm '//rfile(1:lrfile)
         info=system(tmpchar)
        end if
        if(info.ne.0) then
         write(iosl,'(2a)') '** Error while (re)moving ',rfile(1:lrfile)
        end if
      end if
      end

 
C************************************************************************
 

      subroutine wdalton(tdr,natoms,co,ic,mxatt,mxl,mxc,mxp,natt,nlqz,
     * ncon,nprim,coef,expo,jstepa,ibc)
*
* write DALTON input file "molecule.mol" to avoid based call
* 
* written by J. Neugebauer, Uni Erlangen, 2002
*
#include "defs.h"
      integer natoms,i,j,ih,ltd,ic(natoms),kcharge,ntyp,iat,mxsh
      parameter(mxsh=1500)
      integer lam,nco(mxsh),ldmn,jstepa,lcn
      real*8 co(3,natoms)
      character*(*) tdr
      character*24 dmname
      character*255 fname,cname
      character*2 symtxt
      character*1 charm
      parameter(ih=1)
* variables for basis set
      integer mxatt,mxl,mxc,mxp,ibc(mxatt)
      integer natt,nlqz(mxatt),ncon(mxl,mxatt),nprim(mxc,mxl,mxatt)
      real*8 coef(mxp,mxc,mxl,mxatt),expo(mxp,mxc,mxl,mxatt)

      call clean(fname)
      call llen(tdr,ltd)
      call clean(dmname)
      if(jstepa.ne.0) then
        call augnum(dmname,'molecule',jstepa)
      else
        dmname='molecule'
      end if
      call llen(dmname,ldmn)
C      fname=tdr(1:ltd)//'/molecule.mol.test'
      fname=tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
      open(unit=ih,file=fname)
      WRITE (IH,'(A)') 'INTGRL'
      WRITE (IH,'(A)') 'DALTON input converted from TURBOMOLE'
      WRITE (IH,'(A)') '====================================='
      call flush(ih)
      kcharge=0
      cname=tdr(1:ltd)//'/control'
      call llen(cname,lcn)
      call molchar(cname(1:lcn),natoms,ic,kcharge)
***
* determine number of different atom types
***
      ntyp=1
      do 75 j=2,natoms
        do i=1,j-1
          if(ic(i).eq.ic(j)) goto 75
        end do
        ntyp=ntyp+1
75    continue
      symtxt=' 0'
      charm=' '
      WRITE (IH,8800) charm,ntyp,kcharge,symtxt
8800  FORMAT(A1,I4,I3,A2)
      ntyp=0
      do 71 iat=1,natoms
        do i=1,iat-1
          if(ic(iat).eq.ic(i)) goto 71
        end do
        do i=1,mxatt
          if(ic(iat).eq.ibc(i)) ntyp=i
        end do
        lam=nlqz(ntyp)
        do i=1,lam
          nco(i)=1
        end do
        call wdalgeo(ih,iat,lam,nco,symtxt,ic,natoms,co)
        call wrgcdal(ih,ntyp,lam,mxatt,mxl,mxc,mxp,ncon,nprim,coef,expo)
71    continue
      close(ih)
      end                      



 
C************************************************************************

      SUBROUTINE wdalgeo(ih,iat,lam,nco,stxt,ic,natoms,co)
*
* write geometry record
*
* modified wmolgeo routine
* modifications by J. Neugebauer, University of Erlangen, 2002
*
#include "defs.h"
      integer natoms
      INTEGER ih,iat,lam,nco(lam),ic(natoms)
      real*8 co(3,natoms)
      character*2 find_element
      external find_element
* local
      CHARACTER*1 kaset
      CHARACTER*6 atn,aname
      CHARACTER*2 stxt
      INTEGER irc,nont,i,j,k
 
      kaset=' '
 
* determine number of centres with equal nuclear charge number
      nont=0
      DO j=1,natoms
        IF(ic(j).eq.ic(iat)) nont=nont+1
      END DO
      WRITE (ih,11) kaset,dble(ic(iat)),nont,lam,(nco(j),j=1,lam)
11    FORMAT (A1,F9.0,12I5)
 
* this atom
      WRITE (ih,12) find_element(ic(iat)),(co(j,iat),j=1,3)
* the other atoms of this type
      DO k=iat+1,natoms
       IF(ic(iat).eq.ic(k)) then
        WRITE (ih,12) find_element(ic(iat)),(co(j,k),j=1,3)
       END IF
      ENDDO
12    FORMAT (A2,2X,3F20.15)
      RETURN
      END

C************************************************************************

      subroutine wrgcdal(ih,iat,lam,mxatt,mxl,mxc,mxp,
     * ncon,nprim,gcoef,gexpo)
*
* write generalized contraction (basis in DALTON format)
*
* written by J. Neugebauer, University of Erlangen, 2002
*  

#include "defs.h"
* variables for basis set
      integer mxatt,mxl,mxc,mxp
      integer ncon(mxl,mxatt),nprim(mxc,mxl,mxatt)
      real*8 gcoef(mxp,mxc,mxl,mxatt),gexpo(mxp,mxc,mxl,mxatt)

      integer i,j,maxexp,maxcon,ip,iat,ih,lam,k,l,lerr
      parameter(maxexp=200,maxcon=40)
      real*8 coef(maxexp,maxcon),expo(maxexp)
      character*80 errmsg
 
      do i=1,lam
        do j=1,maxexp
          do k=1,maxcon
            coef(j,k)=0.0d0
          end do
          expo(j)=0.0d0
        end do
        ip=0
        do j=1,ncon(i,iat)
          do k=1,nprim(j,i,iat)
            do l=1,ip
              if(abs(gexpo(k,j,i,iat)-expo(l)).lt.1.0d-8) then
                coef(l,j)=gcoef(k,j,i,iat)
                goto 90
              end if
            end do
            ip=ip+1
            expo(ip)=gexpo(k,j,i,iat)
            coef(ip,j)=gcoef(k,j,i,iat)
90          continue
          end do
        end do
        call wrexbdal(ih,ip,ncon(i,iat),maxexp,maxcon,coef,
     *   expo)
      end do 
      end

C************************************************************************
 
        subroutine wrexbdal(ih,ip,ic,maxexp,maxcon,co,ex)
C
C write single gen. contracted basis function
C
C written by J. Neugebauer, University of Erlangen, 2002
C
        implicit none
        integer ih,ip,ic,maxexp,maxcon,j,k
        real*8 co(maxexp,maxcon),ex(maxexp)
        character(len=72) coform
 
        write(ih,'(a1,i4,i5)') 'H',ip,ic
        do k=1,ip
          if(ic.le.3) then
            coform='(4f20.10)'
          else
            coform='(4f20.10/,(20x,3f20.10))'
          end if
          write(ih,coform) ex(k),(co(k,j),j=1,ic)
        end do
        end


C************************************************************************

      subroutine wdalinp(ic,coord,natoms,direct,dalfunc,mode)
C    !----------------------------------------------------------------
C    ! writes the DALTON input file molecule.dal. Also the
C    ! file molecule.mol will be created, which is not necessary for
C    ! the akira calculation (this file has to be created for every
C    ! slave process, but not for the master process).
C    ! Note: keyword '.DIRECT' might be introduced after
C    ! '**DALTON INPUT' to perform integral direct calculations.
C    ! However, these seem to be slower than integral non-direct
C    ! calculations !?
C    !
C    ! written by J. Neugebauer, Uni Erlangen, 2001
C    ! modified for F77 by J. Neugebauer, Uni Erlangen, 2002
C    ! slightly modified by C. Herrmann, Uni Jena 06/2005 (Dalton 2.0)
C    ! based on according modifications in SNF 
C    ! by M. Reiher, Uni Erlangen, 2003
C    !----------------------------------------------------------------
      
#include "defs.h"
      integer natoms, ic(natoms)
      real*8 coord(3,natoms)
      integer info,system,inout,i,lcalc,jstepa,mode
      integer hfocc,multiplicity,inactive,cas,caselec
      character*132 buf
      character*10 progtype,calctype,dalfunc
      logical ex,direct
* variables for basis set
      integer mxatt,mxl,mxc,mxp
      parameter(mxatt=20,mxl=7,mxc=20,mxp=30)
      integer natt,nlqz(mxatt),ncon(mxl,mxatt),nprim(mxc,mxl,mxatt)
      integer ibc(mxatt),lqn(mxl,mxatt)
      real*8 coef(mxp,mxc,mxl,mxatt),expo(mxp,mxc,mxl,mxatt)
 
      write(*,*)
      write(*,*) '======================================='
      write(*,*) '=== CREATING DALTON INPUT FILES ... ==='
      write(*,*) '======================================='
      write(*,*)
 
       
      jstepa=0
      write(iosl,*) 'wdalinp: calling rbas'
      call rbas(mxatt,mxl,mxc,mxp,natt,nlqz,ncon,nprim,coef,expo,'.',
     * ibc,lqn)
      call wdalton('.',natoms,coord,ic,mxatt,mxl,mxc,mxp,natt,nlqz,ncon,
     * nprim,coef,expo,jstepa,ibc)

      inout=25
      call rmfile('rnf.tmp')
      open(inout,file='rnf.tmp')
      write(inout,'(a)') '**DALTON INPUT'
      write(inout,'(a)') '.RUN WAVE FUNCTION'
      if(direct) write(inout,'(a)') '.DIRECT'
      if(mode.eq.20.or.mode.eq.25.or.mode.eq.28) then
        write(inout,'(a)') '.RUN PROPERTIES'
        write(inout,'(a)') '**PROPERTIES'
        write(inout,'(a)') '.MOLGRA'
        if(.not.direct) then
          write(inout,'(a)') '**INTEGRALS'
          write(inout,'(a)') '.NOSUP'
        end if
        write(inout,'(a)') '**WAVE FUNCTIONS'
        if(mode.eq.20.or.mode.eq.25) then
          write(inout,'(a)') '.HF'
        else if(mode.eq.28) then
          write(inout,'(a)') '.DFT'
          write(inout,'(a)') dalfunc
        end if
        if(mode.eq.25) then
          call casinput(hfocc,multiplicity,inactive,cas,caselec)
          write(inout,'(a)') '.MCSCF'
          write(inout,'(a)') '*OPTIMIZATION'
          write(inout,'(a)') '.MAX MACRO ITERATIONS'
          write(inout,'(a)') '40'
          write(inout,'(a)') '.MAX MICRO ITERATIONS'
          write(inout,'(a)') '30'
          write(inout,'(a)') '*HF INPUT'
          write(inout,'(a)') '.HF OCCUPATION'
          write(inout,'(i3)') hfocc
          write(inout,'(a)') '*CONFIGURATION INPUT'
          write(inout,'(a)') '.SYMMETRY'
          write(inout,'(a)') '1'
          write(inout,'(a)') '.SPIN MULTIPLICITY'
          write(inout,'(i2)') multiplicity
          write(inout,'(a)') '.INACTIVE'
          write(inout,'(i3)') inactive         
          write(inout,'(a)') '.CAS SPACE'
          write(inout,'(i3)') cas
          write(inout,'(a)') '.ELECTRONS'
          write(inout,'(i3)') caselec
        end if
      else if(mode.ge.21.and.mode.le.24) then
C       !--------------------------------------------------
C       ! coupled cluster (or MP2 using CC module)
C       !--------------------------------------------------
        call prog_type(mode,progtype,calctype)
        write(inout,'(a)') '**INTEGRALS'
C        write(inout,'(a)') '.DIPLEN'
        write(inout,'(a)') '.DEROVL'
        write(inout,'(a)') '.DERHAM'
        if(.not.direct) write(inout,'(a)') '.NOSUP'
        write(inout,'(a)') '**WAVE FUNCTIONS'
        write(inout,'(a)') '.CC'
        write(inout,'(a)') '*CC INPUT'
        call llen(calctype,lcalc)
        write(inout,'(a)') '.'//calctype(1:lcalc)
C        write(inout,'(a)') '*CCFOP'
C        write(inout,'(a)') '.DIPMOM'
111     write(inout,'(a)') '*DERIVATIVES'
      end if
      write(inout,'(a)') '*ORBITAL INPUT'
      write(inout,'(a)') '.NOSUPSYM'
      write(inout,'(a)') '*END OF INPUT'
      close(inout)
      call rmfile('molecule.dal')
C--------------------------------------------------------------
C        call crdalmol('molecule')
C better use crdalmos, otherwise a molecular charge of zero
C is always assumed !
C--------------------------------------------------------------
C      call crdalmos('molecule')
      info=system('mv rnf.tmp molecule.dal')
      write(*,*)
      write(*,*) '======================================'
      write(*,*) '=== CREATED ALL DALTON INPUT FILES ==='
      write(*,*) '=== (press <return> to continue)   ==='
      write(*,*) '======================================'
      write(*,*)
      read(*,*)
      return
900   call serror('rnfdalton',2,'Error while preparing'//
     * 'DALTON input file.',6)
 
      end 

C********************************************************************* 
 
      subroutine casinput(hfocc,mult,inac,cas,ecas)
*----------------------------------------------------------------
* interactive input of data required for DALTON CASSCF
* calculation
*
* written by J. Neugebauer, Uni Erlangen, 2002
* F77 Version by J. Neugebauer, Uni Erlangen, 2002
*----------------------------------------------------------------
      implicit none
      integer hfocc,mult,inac,cas,ecas,i,lz
      character*80 zeile
      logical valid
 
      valid=.false.
100   do while(.not.valid)
        write(*,*)
        write(*,*)
        write(*,*) ' Additional input needed for CASSCF calculations.'
        write(*,*) ' Syntax: parameter <parameter_value>'
        write(*,*)
        write(*,*) ' Please enter the following parameters:'
        write(*,*)
        write(*,'(a)')
     * '    parameter: meaning                  : current setting'
        write(*,'(a)')
     * '    -----------------------------------------------------'
        write(*,'(a,i3)')
     * '    hfoc     : no. of occ. HF orbitals  : ',hfocc
        write(*,'(a,i3)')
     * '    mult     : spin multiplicity        : ',mult
        write(*,'(a,i3)')
     * '    inac     : no. of inactive orbitals : ',inac
        write(*,'(a,i3)')
     * '    ocas     : no. of orbitals in CAS   : ',cas
        write(*,'(a,i3)')
     * '    ecas     : no. of electrons in CAS  : ',ecas
        write(*,*)
        write(*,'(a)') '    >return< : quit this menu'
        write(*,*)
        read(*,'(a)') zeile
        call slen(zeile,lz)
        if(lz.eq.0) then
          valid=.true.
        else
          if(lz.le.4) goto 100
          read(zeile(5:),*,err=100,end=100) i
          if(zeile(1:4).eq.'hfoc') then
             hfocc=i
          else if(zeile(1:4).eq.'mult') then
             mult=i
          else if(zeile(1:4).eq.'inac') then
             inac=i
          else if(zeile(1:4).eq.'ocas') then
             cas=i
          else if(zeile(1:4).eq.'ecas') then
             ecas=i
          end if
        end if
      end do
      end
 
*************************************************************************
                             
      subroutine dalopt(direct,dalmw,mode,dalfunc,goback)
      !----------------------------------------------------------------
      ! Get basic information for DALTON control file
      !
      ! written by J. Neugebauer, Uni Erlangen, 2001
      ! modified by C. Herrmann, Uni Jena 06/2005 (Dalton 2.0)
      ! based on the according modifications made in SNF by
      ! M. Reiher, Uni Erlangen, June 2003
      !----------------------------------------------------------------
      implicit none
      logical  goback,valid,ex,direct
      character*132 zeile,buf
      character*10 progtype,calctype,dalfunc
      character*3 tag
      integer mode,dalmw,lz
      valid=.false.
      goback=.false.
10    if(.not.valid) then
        write(*,*)
        write(*,*)
        write(*,*) ' DALTON options: '
        write(*,*)
        call prog_type(mode,progtype,calctype)
        if(index(progtype,'DALTON').eq.0) 
     &    call serror('dalopt',2,
     *    'Wrong mode value for DALTON calculation',6)
        write(*,'(2a)') '    type of DALTON calculation: ',calctype
        if(dalmw.gt.0) 
     &  write(*,'(a,i18)') '    DALTON scratch memory size: ',dalmw
        if(mode.eq.25) then
          direct=.false.
          write(*,*)
          write(*,*)
        else
          tag='off'
          if(direct) tag='on '
          write(*,'(2a)')  '    direct calculation ',tag
          write(*,*)
          write(*,*)
          write(*,*)'   direct     : switch on/off direct calculation'
        end if
        write(*,*)'   dalmw <wm> : set non-def. DALTON work memory <wm>'
        write(*,*)'   <ctype>    : select type of calculation: '
        write(*,*)'                HF, DFT, MP2, MCSCF, CC2, CCS'
     *                             //' or CCSD'
        write(*,*)'   &          : go back to last menu'
        write(*,*)
        read(*,'(a)') zeile
        call slen(zeile,lz)
        call lower(zeile)
        if((zeile(1:3).eq.'hf')) then
          mode=20
        else if((zeile(1:3).eq.'mp2')) then
          write(*,*)
          write(*,*)'   Note: we will use the DALTON''s CC module'
          write(*,*)'         for MP2 calculations'
          write(*,*)                                
          mode=21
        else if((zeile(1:5).eq.'mcscf')) then
          mode=25
        else if((zeile(1:3).eq.'cc2')) then
          mode=22
        else if((zeile(1:4).eq.'ccsd')) then
          mode=24
        else if((zeile(1:3).eq.'ccs')) then
          mode=23
        else if((zeile(1:3).eq.'dft')) then
          write(*,*)
          write(*,*)'   Note: DFT is only available in DALTON versions'
          write(*,*)'         which have appeared after Dec. 2003 !'
666       write(*,*)
          write(*,*)'   Please provide the name of the functional: '
          write(*,*)'   available are: B3LYP, BLYP, WAH, LDA '
          write(*,*)
          read(*,'(a)') zeile
          call slen(zeile,lz)
          call lower(zeile)
          if((zeile(1:5).eq.'b3lyp')) then
            dalfunc='B3LYP  '
          else if((zeile(1:4).eq.'blyp')) then
            dalfunc='BLYP   '
          else if((zeile(1:3).eq.'wah')) then
            dalfunc='WAH    '
          else if((zeile(1:3).eq.'lda')) then
            dalfunc='LDA    '
          else
            write(*,*)'   THIS FUNCTIONAL IS NOT AVAILABLE !!! '
            goto 666
          end if
          mode=28
        else if(lz.eq.0) then
          valid=.true.
        else if(zeile(1:5).eq.'dalmw') then
          read(zeile(6:),*,err=10,end=10) dalmw
          if(dalmw.lt.0) dalmw=0
        else if(zeile(1:6).eq.'direct') then
          if(direct.or.mode.eq.25) then
            direct=.false.
          else
            direct=.true.
          end if
        else if(zeile(1:1) .eq. '&') then
          goback=.true.
          return
        else
          write(*,*) 'Unknown command'
        end if
      else
        return
      end if
      goto 10
     
      end
     
************************************************************************
