      subroutine checkfiles
*
* check if all inputfiles are present
*
* written by J. Neugebauer, University of Erlangen, 2002
*
      implicit none
      call testfile('restart.akira')      
      call testfile('control')      
      call testfile('coord')      
      end 

C************************************************************************
 
      subroutine testfile(rfile)
C
C     if rfile does not exist, then stop.
C
C     written by J. Neugebauer, University of Erlangen, 2002
 
      implicit none
      integer lr
      character*(*) rfile
      logical ex
 
      call llen(rfile,lr)
      inquire(file=rfile(1:lr),exist=ex)
      if(.not.ex) then
        write(*,'(3a)') '** testfile: file ',rfile(1:lr),
     *   ' does not exist.'
        stop
      end if
      end

C************************************************************************
 
      subroutine bfile(rfile)
C
C     if rfile exists, create a write-protected backup-copy
C
C     written by J. Neugebauer, University of Erlangen, 2002
C
 
      implicit none
      integer lr,info,info2,system,lnfile,i
      character*(*) rfile
      character*255 nfile
      logical ex,bex
 
      call llen(rfile,lr)
      inquire(file=rfile(1:lr),exist=ex)
      if(ex) then
        if(lr.ge.255) goto 999
        call clean(nfile)
        do i=1,lr
          nfile(i:i)=rfile(i:i)
        end do
        write(nfile(lr+1:),'(A)') '.bak'
        call llen(nfile,lnfile)
        inquire(file=nfile(1:lnfile),exist=bex)
        if(.not.bex) then
          info=system('cp '//nfile(1:lr)//' '//nfile(1:lnfile))
          info2=system('chmod u-w '//nfile(1:lnfile))
          if(info.ne.0) then
            write(*,*) 
     *       '** bfile: could not create backup copy of ',rfile(1:lr)
          else
            write(*,*) '** bfile: created backup copy ',nfile(1:lnfile)
     *  ,' of ',rfile(1:lr)
          end if
        else
          write(*,*) '** bfile: backup copy of ',nfile(1:lnfile),
     *     ' already exists'
        end if
      end if
      return
999   write(*,*) '** bfile: Filename to long'
      end
C************************************************************************
 
      subroutine mfile(rfile)
C
C     if rfile exists, move it to rfile.bak
C
C     written by J. Neugebauer, University of Erlangen, 2002
C
 
      implicit none
      integer lr,info,info2,system,lnfile,i
      character*(*) rfile
      character*255 nfile
      logical ex,bex
 
      call llen(rfile,lr)
      inquire(file=rfile(1:lr),exist=ex)
      if(ex) then
        if(lr.ge.255) goto 999
        call clean(nfile)
        do i=1,lr
          nfile(i:i)=rfile(i:i)
        end do
        write(nfile(lr+1:),'(A)') '.bak'
        call llen(nfile,lnfile)
C        inquire(file=nfile(1:lnfile),exist=bex)
C        if(.not.bex) then
          info=system('mv '//nfile(1:lr)//' '//nfile(1:lnfile))
C          info2=system('chmod u-w '//nfile(1:lnfile))
          if(info.ne.0) then
            write(*,*) 
     *       '** mfile: could not create backup copy of ',rfile(1:lr)
          else
            write(*,*) '** mfile: created backup copy ',nfile(1:lnfile)
     *  ,' of ',rfile(1:lr)
          end if
C        else
C          write(*,*) '** mfile: backup copy of ',nfile(1:lnfile),
C     *     ' already exists'
C        end if
      end if
      return
999   write(*,*) '** mfile: Filename to long'
      end

C************************************************************************
 
      subroutine rmfile(rfile)
C
C     if rfile exists, remove it
C
C     written by J. Neugebauer, University of Erlangen, 2002
C
 
      implicit none
      integer lr,info,info2,system,i
      character*(*) rfile
      character*255 nfile
      logical ex,bex
 
      call llen(rfile,lr)
      inquire(file=rfile(1:lr),exist=ex)
      call clean(nfile)
      do i=1,lr
        nfile(i:i)=rfile(i:i)
      end do
      if(ex) then
        if(lr.ge.255) goto 999
        info=system('rm '//nfile(1:lr))
        if(info.ne.0) then
          write(*,*) 
     *     '** rmfile: could not remove file ',nfile(1:lr)
        else
            write(*,*) '** rmfile: removed file ',nfile(1:lr)
        end if
      end if
      return
999   write(*,*) '** rmfile: Filename to long'
      end
