/*
 * Extract date and time
 *
 * ChangeLog
 * 2008/11/29 (St. Schenk)
 * 	* Cleanup for new autotools
 * 1991/06/16 (BAH)
 * 	* Initial revision
 * 
 */
#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#ifdef HAVE_STRING_H
#  if !defined STDC_HEADERS && defined HAVE_MEMORY_H
#    include <memory.h>
#  endif
#  include <string.h>
#endif

#ifdef HAVE_TIME_H
#  include <time.h>
#endif

/* We use FC_FUNC since FC will be used for linking */
#define FDATE_FC FC_FUNC (fdate, FDATE)
#ifdef __cplusplus
extern "C" /* prevent C++ name mangling */
#endif
void FDATE_FC( t)
  char *t;
{
  time_t now;
  time( &now);
/* 
 * St. Schenk:
 * The '24' is a magic number. It is the length of the corresponding
 * Fortran string. This should really be synchronized by either using
 * the preprocessor or by passing the length of the string as an
 * additional parameter into the function.
 */
  strncpy(t, (char*) ctime( &now), 24);
}

