/*
 * extract number of seconds since 1970
 *
 * Changelog
 * 2008/11/29 (St. Schenk)
 * 	* We need time.h and not sys/types.h
 * 	* Adjust to autotools name mangling scheme
 * 1999/12/01 (BAH)
 * 	* Initial revision
*/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

/* We use FC_FUNC since FC will be used for linking */
#define SECS_FC FC_FUNC (secs, SECS)
#ifdef __cplusplus
extern "C" /* prevent C++ name mangling */
#endif
void SECS_FC( t)
  int *t;
{
  time_t now;
  time( &now);
  *t = (int) now;
}
