      SUBROUTINE rslavem10(nbm)

****************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
*
* f90 memory management by J. Neugebauer, 2007
****************************************************

#include "defs.h"
#include "param.h"

      INTEGER info,nn,irc,l,mypid,idmy,j,mbuf,iclean,i

      real*8, allocatable :: grad(:),co(:,:),normmodes(:)
      integer, allocatable ::  ilab(:)

      real*8 escf,gsum
      integer lao,ldscf,lgrad,kstep,xprog,nbm
      integer*4 jstepa
      character*255 b1
      CHARACTER*24 date
      CHARACTER*255 dscfname,gradname,aoname
      REAL*8 cpu,wall,gcpu,gwall,acpu,awall
      INTEGER nit
      INTEGER xeq,tmpxeq,icmp
      logical found

*-------------------------------------------------------------------
* allocate arrays
*-------------------------------------------------------------------
      allocate(grad(nvar),co(3,natoms),normmodes(nvar*maxnbm))
      allocate(ilab(natoms))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1
      call rslave(co,ilab,normmodes,jstepa,iclean)

*-------------------------------------------------------------------
* do nothing, this is just a testrun
*-------------------------------------------------------------------

      CALL flush(iosl)
      CALL mnotify(5,mypid,6,'times read',10)
      CALL mnotify(5,mypid,5,'results read',12)

      do i=1,nvar
        grad(i)=0.01d0*dble(i)*dble(jstepa)
      end do
      gsum=0.111111111d0
      escf=-1.11111111d0
      call prmat(iosl,escf,1,1,'getgrad: SCF energy')
      call prmat(iosl,grad,natoms,3,'getgrad: gradient')
      wall=1.11111111d0
      gwall=1.11111111d0
      gcpu=1.11111111d0
      cpu=1.11111111d0
      nit=11
      CALL findstr(tempdir(1:lt)//'/control','$falsetest',found)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'$falsetest found',16)
       WRITE (iosl,*) '$falsetest found in control file ... '
       WRITE (iosl,*) 'setting electronic energie to 2.222222222'
       escf=2.222222222d0
       CALL flush(iosl)
      ENDIF
      WRITE (iosl,*) 'escf : ',escf
      CALL flush(iosl)

*     ------------------------------------------------------------------
*     send final results
*     ------------------------------------------------------------------

      call sendres(nit,cpu,wall,escf,gcpu,gwall,grad,jstepa,nbm)

      CALL mnotify(5,mypid,9,'fake results sent',17)

*-------------------------------------------------------------------
* deallocate arrays
*-------------------------------------------------------------------
      deallocate(grad,co,normmodes)
      deallocate(ilab)

      return
      end 
