      SUBROUTINE rslavem30(nbm)

**************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
**************************************************
* rslave-routine for GAUSSIAN single-point calculations
* written by C. Herrmann, Uni Bonn 2004,
* using large parts of rslavem4.r written by 
* J. Neugebauer
*
* f90 memory management by J. Neugebauer, 2007
**************************************************

#include "defs.h"
#include "param.h"

      real*8, allocatable :: grad(:),co(:,:),normmodes(:)
      integer, allocatable ::  ilab(:)

      integer info,nn,irc,l,mypid,j,mbuf,iclean,icleanl,i,idmy
      real*8 escf,gsum
      integer ldscf,kstep,xprog,lforce,nproc,system,lfout
      integer*4 jstepa,nbm
      character*255 b1
      character*24 date
      character*255 forcename,forceout,dscfname
      real*8 cpu,wall,gwall,gcpu
      integer nit
      integer xeq,tmpxeq,icmp
      character*5 nic
      logical found,parafreq,anffast

*-------------------------------------------------------------------
* allocate arrays
*-------------------------------------------------------------------
      allocate(grad(nvar),co(3,natoms),normmodes(nvar*maxnbm))
      allocate(ilab(natoms))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1
      call rslave(co,ilab,normmodes,jstepa,iclean)

*-------------------------------------------------------------------
* prepare GAUSSIAN input; use new set of coordinates
*-------------------------------------------------------------------
      call rcoord(tempdir(1:lt)//'/coord',nn,co,ilab)
      call wgauss(tempdir(1:lt),natoms,ilab,co,iosl)


      anffast=.false.
      nic='nice '
      call rkeywd(tempdir(1:lt)//'/akira_control','$anffast',anffast)
      if(anffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if

*-------------------------------------------------------------------
* do the calculation (g98/g03)
*-------------------------------------------------------------------
         CALL augnum(forceout,'force.log.',jstepa)
         CALL llen(forceout,lfout)
         if(mode.eq.30.or.mode.eq.31) then
           write(iosl,*) '** rslavem30: running gaussian98'
           call flush(iosl)
           info=xprog(nic(1:5)//turbodir(1:lb)//'g98 ' //tempdir(1:lt)//
     *     '/force.com','force.log')
         else if(mode.eq.32.or.mode.eq.33) then
            write(iosl,*) '** rslavem30: running gaussian03'
           call flush(iosl)
           info=xprog(nic(1:5)//turbodir(1:lb)//'g03 ' //tempdir(1:lt)//
     *     '/force.com','force.log')
         end if
         
*---------------------------------------------------
* read and save gradient
*---------------------------------------------------
CT          CALL augnum(forceout,'force.log.',jstepa)
CT         CALL llen(forceout,lfout)
CT      info=system('mv force.log '//forceout(1:lfout))
      CALL ggaussgrad(natoms,escf,grad,tempdir(1:lt)//'/'
     *                //'force.log')
      write(iosl,*) '** rslavem30: gradient read'
       CALL flush(iosl)
      cpu=0.0d0
      wall=0.0d0
      gcpu=0.0d0
      gwall=0.0d0
      CALL rxxxx('force.log',nit,cpu,wall)

      info=system('mv '//tempdir(1:lt)//'/force.log '
     *                //tempdir(1:lt)//'/'//forceout(1:lfout))
          write(iosl,*)('rslavem30: mv '//tempdir(1:lt)//'/force.log '
     *                //tempdir(1:lt)//'/'//forceout(1:lfout))
      CALL flush(iosl)
      if(info.ne.0) call errex('rslavem30: system command failed')
      CALL flush(iosl)

*     ------------------------------------------------------------------
*     send final results
*     ------------------------------------------------------------------
      call sendres(nit,cpu,wall,escf,gcpu,gwall,grad,jstepa,nbm)

      write(iosl,*) '** rslavem30: results sent'
      call flush(iosl)
      call mnotify(5,mypid,9,'results sent',12)


*     ------------------------------------------------------------------
*     deallocate arrays
*     ------------------------------------------------------------------
      deallocate(grad,co,normmodes)
      deallocate(ilab)

      return
      end subroutine rslavem30
