      subroutine rslavem4(nbm)

*****************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
* adapted for excited state gradients by C. Herrmann,
* Uni Jena 04/2005
*
* f90 memory management by J. Neugebauer, 2007
*****************************************************

#include "defs.h"
#include "param.h"

      real*8, allocatable :: grad(:),co(:,:),normmodes(:)
      integer, allocatable ::  ilab(:)

      integer info,nn,irc,l,mypid,j,mbuf,iclean,icleanl,i,idmy
      real*8 escf,gsum
      integer ldscf,kstep,xprog,lgrad,nproc,system,nbm
      integer*4 jstepa
      character*255 b1
      character*24 date
      character*255 dscfname,gradname,mpiname
      real*8 cpu,wall,gwall,gcpu
      integer nit
      integer xeq,tmpxeq,icmp,lmpi
      character*5 nic
      logical found,parafreq,anffast
      integer exopt

*-------------------------------------------------------------------
* allocate arrays
*-------------------------------------------------------------------
      allocate(grad(nvar),co(3,natoms),normmodes(nvar*maxnbm))
      allocate(ilab(natoms))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1
      call rslave(co,ilab,normmodes,jstepa,iclean)

      anffast=.false.
      nic='nice '
      nproc=4
      parafreq=.false.
      call rkeywd(tempdir(1:lt)//'/control','$parafreq',parafreq)
      call rkeywd(tempdir(1:lt)//'/akira_control','$anffast',anffast)
      if(anffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if

*---------------------------------------
* excited state calculation with egrad ?
*---------------------------------------
      if(rpast.gt.0) then
         if(exopt.eq.0) exopt=rpast
         write(iosl,*)  'No. of exc. states in egrad   = ',rpast
         write(iosl,*)  'State to be calculated in SNF = ',exopt
        if(smult.eq.1) then
          write(iosl,*) 'spin state of excited states  = singlet'
        else if(smult.eq.3) then
          write(iosl,*) 'spin state of excited states  = triplet'
        end if
      end if

*-------------------------------------------------------------------
* do the calculation; (only dscf/ridft)
*-------------------------------------------------------------------

      if(.not.parafreq) then
       if(riflag.eq.1) then
         CALL augnum(dscfname,'ridft.out.',jstepa)
         CALL llen(dscfname,ldscf)
         write(iosl,*) '** rslavem4: running ridft'
         call flush(iosl)
         info=xprog(nic(1:5)//turbodir(1:lb)//'ridft',dscfname(1:ldscf))
         write(iosl,*) '** rslavem4: done; info = ',info
         call flush(iosl)
         CALL augnum(gradname,'rdgrad.out.',jstepa)
         CALL llen(gradname,lgrad)
         write(iosl,*) '** rslavem4: running rdgrad'
         call flush(iosl)
         info=xprog(nic(1:5)//turbodir(1:lb)//'rdgrad',
     *        gradname(1:lgrad))
         write(iosl,*) '** rslavem4: done; info = ',info
         call flush(iosl)
       else if(rpast.gt.0) then
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
         CALL augnum(dscfname,'escf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'escf',dscfname(1:ldscf))
         CALL augnum(gradname,'egrad.out.',jstepa)
         CALL llen(gradname,lgrad)
          info=xprog(nic(1:5)//turbodir(1:lb)//'egrad',
     *         gradname(1:lgrad))
       else
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog(nic(1:5)//turbodir(1:lb)//'grad',gradname(1:lgrad))
       end if
      else
        write(iosl,*) '** rslavem4: found $parafreq entry in control'
*------------------------------------------------------------
* parallel turbomole calculation on every akira slave node;
* not yet tested
*------------------------------------------------------------
       if(riflag.eq.1) then
*------------------------------
* ridft statistics run
*------------------------------
         call prepstat('ridft')
         CALL augnum(dscfname,'ridft.statistics.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog('nice '//turbodir(1:lb)//'ridft',dscfname(1:ldscf))
*------------------------------
* rdgrad statistics run
*------------------------------
         call prepstat('rdgrad')
         CALL augnum(gradname,'rdgrad.statistics.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog('nice '//turbodir(1:lb)//'rdgrad',gradname(1:lgrad))
*------------------------------
* parallel ridft run
*------------------------------
         call mpiinp('ridft_mpi','mpiri.sub',nproc)
         call preppara(nproc-1)
         CALL augnum(mpiname,'ridft_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpiri.sub',
     *     mpiname(1:ldscf))
         CALL augnum(dscfname,'ridft.out.',jstepa)
         CALL llen(dscfname,ldscf)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//dscfname(1:ldscf))
*------------------------------
* parallel rdgrad run
*------------------------------
         call mpiinp('rdgrad_mpi','mpird.sub',nproc)
         CALL augnum(mpiname,'rdgrad_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpird.sub',
     *     mpiname(1:ldscf))
         CALL augnum(gradname,'rdgrad.out.',jstepa)
         CALL llen(gradname,lgrad)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//gradname(1:lgrad))
       else
*------------------------------
* dscf statistics run
*------------------------------
         call prepstat('dscf')
         irc=xeq('cp '//tempdir(1:lt)//'/control '
     *     //tempdir(1:lt)//'/control.dscfstat')
         CALL augnum(dscfname,'dscf.statistics.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog('nice '//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
*------------------------------
* grad statistics run
*------------------------------
         call prepstat('grad')
         irc=xeq('cp '//tempdir(1:lt)//'/control '
     *     //tempdir(1:lt)//'/control.gradstat')
         CALL augnum(gradname,'grad.statistics.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog('nice '//turbodir(1:lb)//'grad',gradname(1:lgrad))
*------------------------------
* parallel dscf run
*------------------------------
         call mpiinp('dscf_mpi','mpidscf.sub',nproc)
         call preppara(nproc-1)
         CALL augnum(mpiname,'dscf_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpidscf.sub',
     *     mpiname(1:ldscf))
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//dscfname(1:ldscf))
*------------------------------
* parallel grad run
*------------------------------
         call mpiinp('grad_mpi','mpigrad.sub',nproc)
         CALL augnum(mpiname,'grad_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpigrad.sub',
     *     mpiname(1:ldscf))
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//gradname(1:lgrad))
       end if
      end if
      gcpu=0.0d0
      gwall=0.0d0
      CALL rxxxx(dscfname,nit,cpu,wall)
      CALL rxxxx(gradname,idmy,gcpu,gwall)

*---------------------------------------------------
* read and save gradient
*---------------------------------------------------
      write(iosl,*) '** rslavem4: reading gradient from file:'
      write(iosl,*) tempdir(1:lt)//'/gradient'
      CALL flush(iosl)
      CALL getgrad(natoms,escf,grad,tempdir(1:lt)//'/gradient')
      write(iosl,*) '** rslavem4: gradient read'
      CALL flush(iosl)
      CALL augnum(gradname,tempdir(1:lt)//'/gradient.',jstepa)
      CALL llen(gradname,lgrad)
      write(iosl,*) '** rslavem4: moving gradient file ...'
      write(iosl,*) '** rslavem4: gradname: ',gradname(1:lgrad)
      write(iosl,*) '** rslavem4: command to be executed:'
      CALL flush(iosl)
      write(iosl,*) 
     *  'mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad)
      CALL flush(iosl)
C      irc=xeq('mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad))
      irc=system('mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad))
      write(iosl,*) '** rslavem4: info = ',irc
      if(info.ne.0) call errex('rslavem4: system command failed')
      CALL flush(iosl)

      CALL rxxxx(dscfname,nit,cpu,wall)
      WRITE (iosl,*) 'iterations: ',nit
      WRITE (iosl,*) 'cpu       : ',cpu
      WRITE (iosl,*) 'wall      : ',wall

C bis hierher geht gewoehnlich alles gut

      write(iosl,*) '** rslavem4: sending times read command'
      CALL flush(iosl)
      CALL mnotify(5,mypid,6,'times read',10)

*-------------------------------------------------------------------
* problems during calculation ?
*-------------------------------------------------------------------

      write(iosl,*) '** rslavem4: looking for $actual'
      CALL flush(iosl)
      CALL findstr(tempdir(1:lt)//'/control','$actual',found)
      write(iosl,*) '** rslavem4: $actual = ',found
      CALL flush(iosl)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'$actual found',13)
       WRITE (iosl,*)
     * '$actual found in control file ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF
      write(iosl,*) '** rslavem4: looking for dscf_problem'
      CALL flush(iosl)
      inquire(file=tempdir(1:lt)//'/dscf_problem',exist=found)
      write(iosl,*) '** rslavem4: $actual = ',found
      CALL flush(iosl)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'dscf_problem occured',13)
       WRITE (iosl,*)
     * 'found file dscf_problem ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF

*-------------------------------------------------------------------
* send final results
*-------------------------------------------------------------------

      write(iosl,*) '** rslavem4: sending results'
      CALL flush(iosl)

*     ------------------------------------------------------------------
*     send final results
*     ------------------------------------------------------------------
      call sendres(nit,cpu,wall,escf,gcpu,gwall,grad,jstepa,nbm)

      write(iosl,*) '** rslavem4: results sent'
      call flush(iosl)
      call mnotify(5,mypid,9,'results sent',12)

*-------------------------------------------------------------------
* deallocate arrays
*-------------------------------------------------------------------
      deallocate(grad,co,normmodes)
      deallocate(ilab)

      return
      end 

***********************************************************************

      subroutine prepstat(prognam)

*---------------------------------------------------------------
* prepare statistics run for parallel dscf/grad/ridft/rdgrad run
*
* written by J. Neugebauer, Uni Erlangen, 2002
*---------------------------------------------------------------
#include "defs.h"
#include "param.h"

      integer lu,mxrow,nrow,lprog,i
      parameter(mxrow=600)
      character*132 buf,cbuf(mxrow)
      character*(*) prognam
      logical ex
      lu=1
      call llen(prognam,lprog)

      open(unit=lu,file=tempdir(1:lt)//'/control',err=999)
      write(iosl,*) '** prepstat: changing control: ',
     * tempdir(1:lt)//'/control'
      call flush(iosl)
      nrow=0
100   read(lu,'(A)',err=999,end=999) buf
101   continue
      if((index(buf,'$parallel_platform').ne.0).or.
     *   (index(buf,'$numprocs').ne.0).or.
     *   (index(buf,'$2e-ints').ne.0).or.
     *   (index(buf,'$statistics').ne.0)) then
        goto 100
      else if((index(buf,'$scratch files').ne.0).or.
     * (index(buf,'$pardft').ne.0).or.
     * (index(buf,'$parallel_parameters').ne.0)) then
200    read(lu,'(A)',err=999,end=999) buf
       if(index(buf,'$').ne.0) goto 101
       goto 200 
      else if(index(buf,'$end').ne.0) then
        rewind(lu)
        do i=1,nrow
          write(lu,'(A)') cbuf(i)
        end do
        write(lu,'(3A)') '$statistics  ',prognam(1:lprog),' parallel'
        write(lu,'(A)')
     * '$2e-ints_shell_statistics    file=dscf-par-stat'
        write(lu,'(A)')
     * '$2e-ints''_shell_statistics    file=grad-par-stat'
        write(lu,'(A)') '$parallel_parameters'
        write(lu,'(A)') '       maxtask=400'
        write(lu,'(A)') '$end'
        write(iosl,'(A)') '** prepstat: changed control'
        call flush(iosl)
        goto 900
      else
        nrow=nrow+1
        if(nrow.gt.mxrow) call errex('** prepstat: buffer too small')
        cbuf(nrow)(1:132)=buf(1:132)
        goto 100
      end if
999   call errex('** preppara: error while reading control')
900   close(lu)
      return
      end
 
***********************************************************************

      subroutine preppara(nproc)

*---------------------------------------------------------------
* prepare parallel run of dscf/grad/ridft/rdgrad run
*
* written by J. Neugebauer, Uni Erlangen, 2002
*---------------------------------------------------------------
#include "defs.h"
#include "param.h"
      integer lu,mxrow,nrow,nproc,i
      parameter(mxrow=600)
      character*132 buf,cbuf(mxrow)
      lu=1

      open(lu,file=tempdir(1:lt)//'/control')
      nrow=0
100   read(lu,'(A)',end=999) buf
101   continue
      if((index(buf,'$parallel_platform').ne.0).or.
     *   (index(buf,'$numprocs').ne.0)) then
        goto 100
      else if(index(buf,'$end').ne.0) then
        rewind(lu)
        do i=1,nrow
          write(lu,'(A)') cbuf(i)
        end do
        write(lu,'(A)') '$parallel_platform linuxcluster'
        write(lu,'(A,i3)') '$numprocs ',nproc
        write(lu,'(A)') '$end'
        goto 900
      else
        nrow=nrow+1
        if(nrow.gt.mxrow) call errex('** prepstat: buffer too small')
        cbuf(nrow)(1:132)=buf(1:132)
        goto 100
      end if
999   call errex('** preppara: error while reading control')
900   close(lu)
      return
      end

 
***********************************************************************

      subroutine mpiinp(prognam,scname,nproc)

*---------------------------------------------------------------
* create mpi runscript for parallel turbomole run
*
* written by J. Neugebauer, Uni Erlangen, 2002
*---------------------------------------------------------------
#include "defs.h"
#include "param.h"
      integer lu,mxrow,nrow,nproc,lprog,lscnam,info,xeq
      parameter(mxrow=600)
      character*132 buf,cbuf(mxrow)
      character*255 fname
      character*(*) prognam,scname
      lu=1

      call llen(prognam,lprog)
      call llen(scname,lscnam)
      fname(1:1)='/'
      fname(2:lscnam+1)=scname(1:lscnam)
*-------------------------------
* create mpi runscript
*-------------------------------
      open(lu,file=tempdir(1:lt)//fname(1:lscnam+1))
      write(lu,'(A,i2,1x,3A)') 
     * '$MPICH/bin/mpirun -machinefile MACHINES -np ',nproc,
     * turbodir(1:lb-1),'_mpi/',prognam(1:lprog)
      close(lu)
*-------------------------------
* make mpi runscript executable
*-------------------------------
      info=xeq('chmod u+x '//tempdir(1:lt)//fname(1:lscnam+1))
      end
