      SUBROUTINE rslavem5(nbm)

****************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
*
* f90 memory management by J. Neugebauer, 2007
****************************************************

#include "defs.h"
#include "param.h"

      real*8, allocatable :: grad(:),co(:,:),normmodes(:)
      integer, allocatable ::  ilab(:)

      integer info,nn,irc,l,mypid,j,mbuf,iclean,icleanl,i,idmy
      real*8 escf,gsum
      integer ldscf,kstep,xprog,lgrad,system
      integer*4 jstepa,nbm
      character*255 b1
      character*24 date
      character*255 dscfname,gradname
      real*8 cpu,wall,gwall,gcpu
      integer nit
      integer xeq,tmpxeq,icmp
      character*5 nic
      logical found,anffast

*-------------------------------------------------------------------
* allocate arrays
*-------------------------------------------------------------------
      allocate(grad(nvar),co(3,natoms),normmodes(nvar*maxnbm))
      allocate(ilab(natoms))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1
      call rslave(co,ilab,normmodes,jstepa,iclean)

      anffast=.false.
      nic='nice '
      call rkeywd(tempdir(1:lt)//'/akira_control','$anffast',anffast)
      if(anffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if

*-------------------------------------------------------------------
* do the calculation; (dscf,mpgrad/rimp2)
*-------------------------------------------------------------------

      CALL augnum(dscfname,'dscf.out.',jstepa)
      CALL llen(dscfname,ldscf)
      info=xprog(nic(1:5)//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
      if(riflag.eq.1) then
        CALL augnum(gradname,'rimp2.out.',jstepa)
        CALL llen(gradname,lgrad)
        info=xprog(nic(1:5)//turbodir(1:lb)//'rimp2',gradname(1:lgrad))
      else
        CALL augnum(gradname,'mpgrad.out.',jstepa)
        CALL llen(gradname,lgrad)
        info=xprog(nic(1:5)//turbodir(1:lb)//'mpgrad',gradname(1:lgrad))
      end if

      gcpu=0.0d0
      gwall=0.0d0
      CALL rxxxx(dscfname,nit,cpu,wall)
      CALL rxxxx(gradname,idmy,gcpu,gwall)
      WRITE (iosl,*) 'iterations: ',nit
      WRITE (iosl,*) 'cpu       : ',cpu
      WRITE (iosl,*) 'wall      : ',wall

*---------------------------------------------------
* read and save gradient
*---------------------------------------------------
      CALL getgrad(natoms,escf,grad,tempdir(1:lt)//'/gradient')
      CALL augnum(gradname,tempdir(1:lt)//'/gradient.',jstepa)
      CALL llen(gradname,lgrad)
C      irc=xeq('mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad))
      irc=system('mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad))
      if(info.ne.0) call errex('rslavem5: system command failed')
      CALL flush(iosl)


      CALL mnotify(5,mypid,6,'times read',10)

*-------------------------------------------------------------------
* problems during calculation ?
*-------------------------------------------------------------------

      CALL findstr(tempdir(1:lt)//'/control','$actual',found)
            IF (found) THEN
       CALL mnotify(5,mypid,7,'$actual found',13)
       WRITE (iosl,*)
     * '$actual found in control file ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF
      CALL flush(iosl)
      inquire(file=tempdir(1:lt)//'/dscf_problem',exist=found)
      write(iosl,*) '** rslavem5: $actual = ',found
      CALL flush(iosl)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'dscf_problem occured',13)
       WRITE (iosl,*)
     * 'found file dscf_problem ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF

*     ------------------------------------------------------------------
*     send final results
*     ------------------------------------------------------------------
      call sendres(nit,cpu,wall,escf,gcpu,gwall,grad,jstepa,nbm)

      write(iosl,*) '** rslavem5: results sent'
      call flush(iosl)
      call mnotify(5,mypid,9,'results sent',12)

*     ------------------------------------------------------------------
*     deallocate arrays
*     ------------------------------------------------------------------
      deallocate(grad,co,normmodes)
      deallocate(ilab)

      return
      end 
