      SUBROUTINE rslavem60(nbm)

*****************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
* adapted for excited state gradients by C. Herrmann,
* Uni Jena 04/2005
*
* f90 memory management by J. Neugebauer 2007
*****************************************************

#include "defs.h"
#include "param.h"

      real*8, allocatable :: grad(:),co(:,:),normmodes(:),qmmmgrad(:)
      integer, allocatable ::  ilab(:)

      integer info,nn,irc,l,mypid,j,mbuf,iclean,icleanl,i,idmy
      real*8 escf,gsum
      integer ldscf,kstep,xprog,lgrad,nproc,system,nbm
      integer*4 jstepa
      character*255 b1
      character*24 date
      character*255 dscfname,gradname,mpiname
      real*8 cpu,wall,gwall,gcpu
      integer nit
      integer xeq,tmpxeq,icmp,lmpi
      character*5 nic
      logical found,parafreq,anffast
      integer exopt

*-------------------------------------------------------------------
* allocate arrays
*-------------------------------------------------------------------
      allocate(grad(nvar),co(3,natoms),normmodes(nvar*maxnbm))
      allocate(qmmmgrad(lastqmatom*3))
      allocate(ilab(natoms))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1
      call rslave(co,ilab,normmodes,jstepa,iclean)

      anffast=.false.
      nic='nice '
      nproc=4
      parafreq=.false.
      call rkeywd(tempdir(1:lt)//'/control','$parafreq',parafreq)
      call rkeywd(tempdir(1:lt)//'/akira_control','$anffast',anffast)
      if(anffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if

c============================================
* excited state calculation with egrad ?
c============================================
      if(rpast.gt.0) then
         if(exopt.eq.0) exopt=rpast
         write(iosl,*)  'No. of exc. states in egrad   = ',rpast
         write(iosl,*)  'State to be calculated in SNF = ',exopt
        if(smult.eq.1) then
          write(iosl,*) 'spin state of excited states  = singlet'
        else if(smult.eq.3) then
          write(iosl,*) 'spin state of excited states  = triplet'
        end if
      end if

*==========================================
* do the calculation; (only dscf/ridft)
*==========================================
         dscfname='comqum.out'
         CALL llen(dscfname,ldscf)
         write(iosl,*) '** rslavem60: starting comqum'
         call flush(iosl)

      if(.not.parafreq) then
        if(riflag.eq.1.and.rpast.le.0) then
          info=xprog(nic(1:5)//turbodir(1:lb)//
     *         'comqum -ri -c 1 -gradonly',
     *         dscfname(1:ldscf))
        else if(riflag.eq.1.and.rpast.gt.0) then
          info=xprog(nic(1:5)//turbodir(1:lb)//
     *         'comqum -ri -ex -c 1',
     *         dscfname(1:ldscf))   
        else if(riflag.ne.1.and.rpast.le.0) then
          info=xprog(nic(1:5)//turbodir(1:lb)//
     *         'comqum -c 1',
     *         dscfname(1:ldscf))
        else if(riflag.eq.1.and.rpast.gt.0) then
          info=xprog(nic(1:5)//turbodir(1:lb)//
     *         'comqum -ex -c 1',
     *         dscfname(1:ldscf))
        end if
        CALL augnum(dscfname,'job.last.',jstepa)
        CALL llen(dscfname,ldscf)
         irc=xeq('mv '//tempdir(1:lt)//'/job.last '
     *     //tempdir(1:lt)//'/'//dscfname(1:ldscf))
      else
        write(iosl,*) '** rslavem60: found $parafreq entry in control'
*=============================================================
* parallel turbomole calculation on every akira slave node;
* not yet tested
c STILL TO BE ADAPTED FOR COMQUM!! => DO NOT USE YET
*=============================================================
         write(iosl,*) '** rslavem60: done; info = ',info
         call flush(iosl)
       if(riflag.eq.1) then
*------------------------------
* ridft statistics run
*------------------------------
         call prepstat('ridft')
         CALL augnum(dscfname,'ridft.statistics.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog('nice '//turbodir(1:lb)//'ridft',dscfname(1:ldscf))
*------------------------------
* rdgrad statistics run
*------------------------------
         call prepstat('rdgrad')
         CALL augnum(gradname,'rdgrad.statistics.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog('nice '//turbodir(1:lb)//'rdgrad',gradname(1:lgrad))
*------------------------------
* parallel ridft run
*------------------------------
         call mpiinp('ridft_mpi','mpiri.sub',nproc)
         call preppara(nproc-1)
         CALL augnum(mpiname,'ridft_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpiri.sub',
     *     mpiname(1:ldscf))
         CALL augnum(dscfname,'ridft.out.',jstepa)
         CALL llen(dscfname,ldscf)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//dscfname(1:ldscf))
*------------------------------
* parallel rdgrad run
*------------------------------
         call mpiinp('rdgrad_mpi','mpird.sub',nproc)
         CALL augnum(mpiname,'rdgrad_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpird.sub',
     *     mpiname(1:ldscf))
         CALL augnum(gradname,'rdgrad.out.',jstepa)
         CALL llen(gradname,lgrad)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//gradname(1:lgrad))
       else
*------------------------------
* dscf statistics run
*------------------------------
         call prepstat('dscf')
         irc=xeq('cp '//tempdir(1:lt)//'/control '
     *     //tempdir(1:lt)//'/control.dscfstat')
         CALL augnum(dscfname,'dscf.statistics.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog('nice '//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
*------------------------------
* grad statistics run
*------------------------------
         call prepstat('grad')
         irc=xeq('cp '//tempdir(1:lt)//'/control '
     *     //tempdir(1:lt)//'/control.gradstat')
         CALL augnum(gradname,'grad.statistics.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog('nice '//turbodir(1:lb)//'grad',gradname(1:lgrad))
*------------------------------
* parallel dscf run
*------------------------------
         call mpiinp('dscf_mpi','mpidscf.sub',nproc)
         call preppara(nproc-1)
         CALL augnum(mpiname,'dscf_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpidscf.sub',
     *     mpiname(1:ldscf))
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//dscfname(1:ldscf))
*------------------------------
* parallel grad run
*------------------------------
         call mpiinp('grad_mpi','mpigrad.sub',nproc)
         CALL augnum(mpiname,'grad_mpi.',jstepa)
         CALL llen(mpiname,lmpi)
         info=xprog('nice '//tempdir(1:lt)//'/mpigrad.sub',
     *     mpiname(1:ldscf))
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         irc=xeq('mv '//tempdir(1:lt)//'/slave1.output '
     *     //tempdir(1:lt)//'/'//gradname(1:lgrad))
       end if
      end if
      gcpu=0.0d0
      gwall=0.0d0
      CALL rxxxx(dscfname,nit,cpu,wall)
      CALL rxxxx(gradname,idmy,gcpu,gwall)

*============================
* read gradient:
* 1) Read MM gradient components of QM and MM system
* 2) Read QM+MM gradient components for QM system
*    from gradient file and reorder them appropriately
*    => pure MM gradients are overwritten by QM+MM gradients
*       for QM system
*============================
      write(iosl,*) '** rslavem60: reading gradient for MM system '
     *              //'from file:'
      write(iosl,*) tempdir(1:lt)//'/fixforce.mmin'
      CALL flush(iosl)
      CALL gcomqum_mm_grad(lastqmatom,natoms,grad,tempdir(1:lt)//
     *                     '/fixforce.mmin')
      write(iosl,*) '** rslavem60: gradient read for MM system'
      CALL flush(iosl)

      write(iosl,*) '** rslavem60: reading QM/MM gradient for QM system'
     *              //' from file:'
      write(iosl,*) tempdir(1:lt)//'/gradient',natoms
      CALL flush(iosl)
      CALL getgrad(lastqmatom,escf,qmmmgrad,tempdir(1:lt)//'/gradient')
      write(iosl,*) '** rslavem60: calling qmmmgrad2grad'
      CALL flush(iosl)
      call qmmmgrad2grad(qmmmgrad,grad,lastqmatom,
     *     tempdir(1:lt)//'/comqum.dat')
      write(iosl,*) '** rslavem60: QM/MM gradient read for QM system'
      CALL flush(iosl)

*============================
* read energy
*============================
      write(iosl,*) '** rslavem60: reading QM/MM energy of QM system '
     *               //'from file:'
      write(iosl,*) tempdir(1:lt)//'/fixenergy.out'
      CALL flush(iosl)
      CALL gcomqum_energy(escf,tempdir(1:lt)//'/fixenergy.out')
      write(iosl,*) '** rslavem60: QM/MM energy of QM system read'
      CALL flush(iosl)

*============================
* save gradient output files
*============================
      CALL augnum(gradname,tempdir(1:lt)//'/gradient.',jstepa)
      CALL llen(gradname,lgrad)
      write(iosl,*) '** rslavem60: moving gradient file ...'
      write(iosl,*) '** rslavem60: gradname: ',gradname(1:lgrad)
      write(iosl,*) '** rslavem60: command to be executed:'
      CALL flush(iosl)
      write(iosl,*) 
     *  'mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad)
      CALL flush(iosl)
      irc=system('mv '//tempdir(1:lt)//'/gradient '
     *                //gradname(1:lgrad))
      write(iosl,*) '** rslavem60: info = ',irc
      if(info.ne.0) call errex('rslavem60: system command failed')
      CALL flush(iosl)

      CALL augnum(gradname,tempdir(1:lt)//'/fixforce.mmin.',jstepa)
      CALL llen(gradname,lgrad)
      write(iosl,*) '** rslavem60: moving gradient file ...'
      write(iosl,*) '** rslavem60: gradname: ',gradname(1:lgrad)
      write(iosl,*) '** rslavem60: command to be executed:'
      CALL flush(iosl)
      write(iosl,*) 
     *  'mv '//tempdir(1:lt)//'/fixforce.mmin '//gradname(1:lgrad)
      CALL flush(iosl)
      irc=system('mv '//tempdir(1:lt)//'/fixforce.mmin '
     *                //gradname(1:lgrad))
      write(iosl,*) '** rslavem60: info = ',irc
      if(info.ne.0) call errex('rslavem60: system command failed')
      CALL flush(iosl)

*============================
* save gradient output files
*============================
      CALL augnum(gradname,tempdir(1:lt)//'/fixenergy.out.',jstepa)
      CALL llen(gradname,lgrad)
      write(iosl,*) '** rslavem60: moving gradient file ...'
      write(iosl,*) '** rslavem60: gradname: ',gradname(1:lgrad)
      write(iosl,*) '** rslavem60: command to be executed:'
      CALL flush(iosl)
      write(iosl,*) 
     *  'mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad)
      CALL flush(iosl)
      irc=system('mv '//tempdir(1:lt)//'/fixenergy.out '
     *                //gradname(1:lgrad))
      write(iosl,*) '** rslavem60: info = ',irc
      if(info.ne.0) call errex('rslavem60: system command failed')
      CALL flush(iosl)

*============================
* output information
*============================
      CALL rxxxx(dscfname,nit,cpu,wall)
      WRITE (iosl,*) 'iterations: ',nit
      WRITE (iosl,*) 'cpu       : ',cpu
      WRITE (iosl,*) 'wall      : ',wall

      write(iosl,*) '** rslavem60: sending times read command'
      CALL flush(iosl)
      CALL mnotify(5,mypid,6,'times read',10)

*-------------------------------------------------------------------
* problems during calculation ?
*-------------------------------------------------------------------

      write(iosl,*) '** rslavem60: looking for $actual'
      CALL flush(iosl)
      CALL findstr(tempdir(1:lt)//'/control','$actual',found)
      write(iosl,*) '** rslavem60: $actual = ',found
      CALL flush(iosl)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'$actual found',13)
       WRITE (iosl,*)
     * '$actual found in control file ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF
      write(iosl,*) '** rslavem60: looking for dscf_problem'
      CALL flush(iosl)
      inquire(file=tempdir(1:lt)//'/dscf_problem',exist=found)
      write(iosl,*) '** rslavem60: $actual = ',found
      CALL flush(iosl)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'dscf_problem occured',13)
       WRITE (iosl,*)
     * 'found file dscf_problem ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF

*-------------------------------------------------------------------
* send final results
*-------------------------------------------------------------------

      call sendres(nit,cpu,wall,escf,gcpu,gwall,grad,jstepa,nbm)

      write(iosl,*) '** rslavem60: results sent'

      call flush(iosl)
      call mnotify(5,mypid,9,'results sent',12)


*-------------------------------------------------------------------
* deallocate arrays
*-------------------------------------------------------------------
      deallocate(grad,co,normmodes,qmmmgrad)
      deallocate(ilab)

      return
      end 

