      SUBROUTINE rslavemd(nbm)

****************************************************
* akira version by J. Neugebauer, Uni Erlangen, 2001
*
* f90 memory management by J. Neugebauer
****************************************************

#include "defs.h"
#include "param.h"

      real*8, allocatable :: grad(:),co(:,:),normmodes(:)
      integer, allocatable ::  ilab(:)

      integer info,nn,irc,l,mypid,j,mbuf,iclean,icleanl,i,idmy
      real*8 escf,gsum
      integer ldscf,kstep,xprog,lgrad,nbm
      integer*4 jstepa
      character*24 date
      character*255 dscfname,gradname,b1
      real*8 cpu,wall,gwall,gcpu
      integer xeq,tmpxeq,icmp,nit,ldal,ldalmw,ldmol,idalmw
      character*5 nic
      logical found,anffast
      character*80 dalmw,dalmw2,adjustl
      character*255 dalname
      character*24 dmname
      external adjustl

*-------------------------------------------------------------------
* allocate arrays
*-------------------------------------------------------------------
      allocate(grad(nvar),co(3,natoms),normmodes(nvar*maxnbm))
      allocate(ilab(natoms))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1
      call rslave(co,ilab,normmodes,jstepa,iclean)

*-------------------------------------------------------------------
* prepare DALTON input; use new set of coordinates
*-------------------------------------------------------------------
      call rcoord(tempdir(1:lt)//'/coord',nn,co,ilab)
      call wdal(tempdir(1:lt),jstepa,natoms,ilab,co)

*-------------------------------------------------------------------
* do the calculation; (DALTON)
*-------------------------------------------------------------------


      anffast=.false.
      nic='nice '
      call rkeywd(tempdir(1:lt)//'/akira_control','$anffast',anffast)
      if(anffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if

      CALL augnum(dalname,'dal.out.',jstepa)
      CALL llen(dalname,ldal)
      CALL augnum(dmname,'molecule',jstepa)
      CALL llen(dmname,ldmol)
 
CJN set maximum scratch memory if dalmw is specified in "control"

      call rkeyint(tempdir(1:lt)//'/akira_control','$dalmw',idalmw)
      write(dalmw2,*) idalmw
      dalmw=adjustl(dalmw2)
      CALL llen(dalmw,ldalmw)
 
      if(idalmw.le.800000) then
        if(idalmw.ne.0) then
          write(idbg,*)
     & 'rslavemd: using dalton with default scratch memory size'
          write(idbg,*) 'idalmw = ',idalmw
        end if
        info=xprog(nic(1:5)//turbodir(1:lb)//'dalton '
     & //dmname(1:ldmol)//' '//dmname(1:ldmol),dalname(1:ldal))
      else
        info=xprog(nic(1:5)//turbodir(1:lb)//'dalton -m '
     & //dalmw(1:ldalmw)//' '//dmname(1:ldmol)//' '//dmname(1:ldmol),
     & dalname(1:ldal))
      end if

*     --------------------------------------------------
*     read and save gradient
*     --------------------------------------------------
      if(mode.ge.21.and.mode.le.24) then
        CALL gdalgrad(natoms,escf,grad,
     *   tempdir(1:lt)//'/'//dmname(1:ldmol)//'.out')
      else if(mode.eq.20.or.mode.eq.25.or.mode.eq.28) then
        CALL gdalgradscf(natoms,escf,grad,
     *   tempdir(1:lt)//'/'//dmname(1:ldmol)//'.out')
      end if
      gcpu=0.0d0
      gwall=0.0d0
      nit=0
      cpu=0
      wall=0

      CALL mnotify(5,mypid,6,'times read',10)

*     ------------------------------------------------------------------
*     send final results
*     ------------------------------------------------------------------
      call sendres(nit,cpu,wall,escf,gcpu,gwall,grad,jstepa,nbm)

      write(iosl,*) '** rslavem5: results sent'
      call flush(iosl)
      call mnotify(5,mypid,9,'results sent',12)

*-------------------------------------------------------------------
* deallocate arrays
*-------------------------------------------------------------------
      deallocate(grad,co,normmodes)
      deallocate(ilab)

      return
      end 
